
#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).begin(), (c).end()
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int OPEN = 0, CLOSE = 1;

struct event
{
    int x, y, type;
    event() {}
    event(int x, int y, int type) : x(x), y(y), type(type) {}
};

struct node
{
    int val = 0, mod = 0;
    int vl, vr;
    node *l = 0, *r = 0;
    node() {}
    node(int tl, int tr)
    {
        vl = tl, vr = tr;
    }
    void push()
    {
        val += mod;
        if (!l && vr - vl != 1)
        {
            l = new node(vl, (vl + vr) >> 1);
            r = new node((vl + vr) >> 1, vr);
        }
        if (l)
        {
            l->mod += mod;
            r->mod += mod;
        }
        mod = 0;
    }
    void pull()
    {
        if (!l && vr - vl != 1)
        {
            l = new node(vl, (vl + vr) >> 1);
            r = new node((vl + vr) >> 1, vr);
        }
        if (l)
        {
            push();
            l->push();
            r->push();
            val = max(l->val, r->val);
        }
    }
    void add(int ql, int qr, int x)
    {
        push();
        if (vl == ql && vr == qr)
        {
            mod += x;
            push();
            pull();
            return;
        }
        if (!l && vr - vl != 1)
        {
            l = new node(vl, (vl + vr) >> 1);
            r = new node((vl + vr) >> 1, vr);
        }
        if (qr <= ((vl + vr) >> 1))
            l->add(ql, qr, x);
        else if (ql >= ((vl + vr) >> 1))
            r->add(ql, qr, x);
        else
            l->add(ql, (vl + vr) >> 1, x), r->add((vl + vr) >> 1, qr, x);
        pull();
    }
    int get(int ql, int qr)
    {
        push();
        if (vl == ql && vr == qr)
        {
            pull();
            return val;
        }
        int ret = 0;
        if (!l && vr - vl != 1)
        {
            l = new node(vl, (vl + vr) >> 1);
            r = new node((vl + vr) >> 1, vr);
        }
        if (qr <= ((vl + vr) >> 1))
            ret = l->get(ql, qr);
        else if (ql >= ((vl + vr) >> 1))
            ret = r->get(ql, qr);
        else 
            ret = max(l->get(ql, (vl + vr) >> 1), r->get((vl + vr) >> 1, qr));
        pull();
        return ret;
    }
};

signed main()
{
    Start();
    int n, w, h;
    cin >> n >> w >> h;
    vector <event> e;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        e.pb(x, y, OPEN);
        e.pb(x + w, y, CLOSE);
    }
    vector <int> ycoords;
    for (auto &ev : e)
        ycoords.pb(ev.y);
    sort(all(ycoords));
    ycoords.erase(unique(all(ycoords)), ycoords.end());
    map <int, int> coortoi;
    for (int i = 0; i < ycoords.size(); ++i)
        coortoi[ycoords[i]] = i;
    for (auto &ev : e)
        ev.y = coortoi[ev.y];
    const int MXC = 2e5+2;
    node *t = new node(0, MXC);
    sort(all(e), [] (const event &a, const event &b) -> bool
    {
        return a.x < b.x || (a.x == b.x && a.type < b.type);
    });
    int ans = 0;
    for (auto &ev : e)
    {
        if (ev.type == OPEN)
        {
            t->add(ev.y, upper_bound(all(ycoords), ycoords[ev.y] + h) - ycoords.begin(), +1);
        }
        else
        {
            t->add(ev.y, upper_bound(all(ycoords), ycoords[ev.y] + h) - ycoords.begin(), -1);
        }
        ans = max(ans, t->get(0, MXC));
    }
    cout << ans;
    return 0;
}

