// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long ull;
typedef long double ld;

#define P pair
typedef P<int, int> Pii;
typedef P<ll, ll> Pll;
typedef P<string, string> Pss;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()


#define add_fill(a, c) setw(a) << setfill(c)
// #define endl '\n'

#define slimming(a) a.shrink_to_fit()
#define len(a) (ll)a.size()

#define f first
#define s second

const ll INF = (ll) (1e9);
#define MOD 1000000009

#define yes "YES"
#define no "NO"
#define imp "impossible"

#define pb push_back
#define eb emplace_back

#pragma GCC optimize "-O3"
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/stack:200000000")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

// mt19937 rnd(time(0));

ll get_rand() {
   return (rand() << 16) ^ rand();
}

bool get(ll mask, ll id){
   return ((mask>>id)&1);
}

bool cmp(Pll &a, Pll &b){
   if(a.f > b.f) return true;
   if(a.f < b.f) return false;
   return a.s < b.s;
}

struct SegmentTree{
   vector < ll > a;
   vector < ll > tree;
   SegmentTree(vector < ll > _a){
      ll n = len(_a);
      tree.assign(n*4, 0);
      a = _a;

      build(1, 0, n-1);
   }
   void build(ll node, ll l, ll r){
      if(l == r){
         tree[node] = a[l];
         return;
      }

      ll m = (l + r) / 2;
      build(node*2, l, m);
      build(node*2+1, m +1, r);
      tree[node] = tree[node*2]+tree[node*2+1];
   }

   ll get(ll node, ll _l, ll _r, ll l, ll r){
      if(_l > r or _r < l)
         return 0;
      if(l <= _l and _r <= r)
         return tree[node];

      ll m = (_l + _r) / 2;
      return get(node*2, _l, m, l, r) + get(node*2+1, m+1, _r, l, r);
   }  
};

void solve() {
   ll n, k;
   cin >> n >> k;

   vector < ll > a(n);
   for(int i = 0 ; i < n; ++i)
      cin >> a[i];
   
   vector < Pll > b(n);
   for(int i = 0; i < n; ++i)
      b[i] = {a[i], i};

   sort(all(b), cmp);
   // for(auto i : b)
   //    cout << i.f << ' ' << i.s << endl;

   vector < Pll > id(k);
   for(int i = 0; i < k; ++i)
      id[i] = {b[i].s, b[i].f};
   
   sort(all(id));
   
   SegmentTree sgt(a);

   // for(auto i : id)
   //    cout << i.f << ' ' << i.s << endl;
   vector < ll > l, r;
   vector < ll > used(n, -1);
   set < ll > ind;
   for(int i = 0; i < k; ++i){
      ind.insert(id[i].f);
      l.pb(id[i].f);
      r.pb(id[i].f);
      used[id[i].f] = i;
   }

   
   for(int i = 0; i < k; ++i){
      // ll i = id[wer].f;
      for(int j = 0; j <= l[i]; ++j){
         if(used[l[i] - j] == i or used[l[i] - j] == -1){
            used[l[i]-j] = i;
         }else{
            l[i] -= (j-1);
            break;
         }
      }

      for(int j = 0; j <= n-r[i]; ++j){
         if(used[r[i] + j] == i or used[r[i] + j] == -1){
            used[r[i]+j] = i;
         }else{
            r[i] += (j-1);
            break;
         }
      }
   }

   // for(auto i : used)
   //    cout << i << '\t';
   // cout << endl;
   // for(int i = 0; i < k; ++i)
   //    cout << l[i] << ' ' << r[i] << endl;

   vector < ll > uk(k+1, 0);
   for(int i = 1; i < k; ++i)
      uk[i] = r[i-1];
   uk[k] = n-1;

   vector < ll > sm(k, 0);
   for(int i = 0; i < k; ++i){
      // cout << l[i] << ' ' << r[i] << endl;
      for(int j = 0; j + l[i] <= r[i]; ++j)
         sm[i] += a[l[i]+j] * (r[i]-l[i]);
   }
   ll ans = 0;
   for(auto i : sm){
      // cout << i << ' ';
      ans += i;
   }
   // cout << endl;
   // for(auto i : uk)
   //    cout << i << ' ';
   // cout << endl;
   for(int i = 1; i < k; ++i){
      ll tmpM = - a[uk[i]]*(uk[i] - uk[i-1]) - sgt.get(1, 0, n - 1, uk[i-1], uk[i]-1);
      ll tmpP = a[uk[i]]*(uk[i+1]-uk[i]) + sgt.get(1, 0, n-1, uk[i]+1, uk[i+1]);
      // cout << ans << ' ' << tmpM << ' ' << tmpP << ' ';
      // cout << sgt.get(1, 0, n - 1, uk[i-1], uk[i]-1) << ' ';
      while(!ind.count(uk[i]) and ans > ans + tmpM + tmpP){
         ans = ans + tmpM +tmpP;
         --uk[i];
         tmpM = - a[uk[i]]*(uk[i] - uk[i-1]) - sgt.get(1, 0, n - 1, uk[i-1], uk[i]-1);
         tmpP = a[uk[i]]*(uk[i+1]-uk[i]) + sgt.get(1, 0, n-1, uk[i]+1, uk[i+1]);
         // cout << ' ' << ans + tmpM +tmpP;
      }
      ++uk[i];
      // cout << endl;
   }
   cout << ans;
   return;
}

int main() {
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr);
   cout.tie(nullptr);

   // freopen("input.txt", "r", stdin);
   // freopen("output.txt", "w", stdout);

   ll t = 1;
   // cin >> t;
   while (t--) {
      solve();
      cout << endl;
   }
   return 0;
}