#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

typedef long long ll;

mt19937 rng(20);

const int N = 26;
const int L = 1e7 + 3;

int pnt = 0;
ll ans = 0;

vector<vector<int>> A(N);

int v[L];
int c[L];

int cnt(int x) {
    int p = -1;
    for (int t = N; t >= 0; t--) {
        if (p + (1 << t) < pnt && v[p + (1 << t)] < x) {
            p += (1 << t);
        }
    }
    p++;
    if (p == pnt || v[p] != x) {
        return 0;
    }
    return c[p];
}

double br_lim = 0.5;
int enough_time = 1;

void gen(int alr, int mask, int lim, int ps) {
    if ((double)clock() / CLOCKS_PER_SEC > br_lim) {
        enough_time = 0;
        return;
    }
    if (alr == lim) {
        if (ps) {
            v[pnt++] = mask;
        } else {
            ans += cnt(((1 << N) - 1) ^ mask);
        }
    } else {
        for (auto j : A[alr]) {
            if (!((mask >> j) & 1)) {
                gen(alr + 1, mask | (1 << j), lim, ps);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    for (int i = 0; i < N; i++) {
        string s;
        cin >> s;
        int mask = 0;
        for (auto x : s) {
            mask |= (1 << (x - 'A'));
        }
        for (int j = 0; j < N; j++) {
            if ((mask >> j) & 1) {
                A[i].push_back(j);
            }
        }
    }
    // shuffle(A.begin(), A.end(), rng);
    gen(0, 0, 13, 1);
    reverse(A.begin(), A.end());
    {
        sort(v, v + pnt);
        c[pnt - 1] = 1;
        for (int i = pnt - 2; i >= 0; i--) {
            if (v[i] == v[i + 1]) {
                c[i] = c[i + 1] + 1;
            } else {
                c[i] = 1;
            }
        }
    }
    gen(0, 0, 13, 0);
    if (enough_time) {
        cout << ans << '\n';
        return 0;
    }

    pnt = 0;
    ans = 0;
    br_lim = 10;
    shuffle(A.begin(), A.end(), rng);
    gen(0, 0, 13, 1);
    reverse(A.begin(), A.end());
    {
        sort(v, v + pnt);
        c[pnt - 1] = 1;
        for (int i = pnt - 2; i >= 0; i--) {
            if (v[i] == v[i + 1]) {
                c[i] = c[i + 1] + 1;
            } else {
                c[i] = 1;
            }
        }
    }
    gen(0, 0, 13, 0);
    cout << ans << '\n';
}
