#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

typedef long long ll;

mt19937 rng(30);

const int N = 26;
const int L = 1e7 + 3;

int pnt = 0;
ll ans = 0;
vector<vector<int>> A(N);

int v[L];
int c[L];

int cnt(int x) {
    int p = -1;
    for (int t = N; t >= 0; t--) {
        if (p + (1 << t) < pnt && v[p + (1 << t)] < x) {
            p += (1 << t);
        }
    }
    p++;
    if (p == pnt || v[p] != x) {
        return 0;
    }
    return c[p];
}

int alr;
int mask;
int lim;
int ps;

void gen() {
    if (alr == lim) {
        if (ps) {
            v[pnt++] = mask;
        } else {
            ans += cnt(((1 << N) - 1) ^ mask);
        }
    } else {
        for (auto j : A[alr]) {
            if (!((mask >> j) & 1)) {
                mask |= (1 << j);
                alr++;
                gen();
                alr--;
                mask ^= (1 << j);
            }
        }
    }
}

int score(vector<vector<int>> a) {
    int res = 0;
    vector<int> cnt(N);
    for (int i = 0; i < (int)a.size(); i++) {
        for (auto f : a[i]) {
            cnt[f]++;
        }
    }
    for (auto t : cnt) {
        res += t * t * t * t;
    }
    return res;
}

int real_score(vector<vector<int>> a) {
    int res = 0;
    vector<int> cnt(N);
    for (int i = 0; i < N; i++) {
        for (auto x : a[i]) {
            cnt[x]++;
        }
        if (i == 12) {
            for (auto t : cnt) {
                res += t * t * t * t;
            }
            fill(cnt.begin(), cnt.end(), 0);
        }
    }
    for (auto t : cnt) {
        res += t * t * t * t;
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    for (int i = 0; i < N; i++) {
        string s;
        cin >> s;
        int m = 0;
        for (auto x : s) {
            m |= (1 << (x - 'A'));
        }
        for (int j = 0; j < N; j++) {
            if ((m >> j) & 1) {
                A[i].push_back(j);
            }
        }
    }
    sort(A.begin(), A.end());
    {
        auto B = A;
        int best = real_score(A);
        for (int i = 0; i < 10000; i++) {

            shuffle(B.begin(), B.end(), rng);
            int nw = real_score(B);
            if (nw > best) {
                A = B;
                best = nw;
            }
        }
    }
    {
        alr = 0;
        mask = 0;
        lim = 12;
        ps = 1;
        gen();
    }
    reverse(A.begin(), A.end());
    {
        sort(v, v + pnt);
        c[pnt - 1] = 1;
        for (int i = pnt - 2; i >= 0; i--) {
            if (v[i] == v[i + 1]) {
                c[i] = c[i + 1] + 1;
            } else {
                c[i] = 1;
            }
        }
    }
    {
        alr = 0;
        mask = 0;
        lim = 14;
        ps = 0;
        gen();
    }
    cout << ans << '\n';
}
