#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

mt19937 rng(10);

const bool DEBUG = 1;

int solve(int n, int k, vector<int> a) {
    const int L = 1e15 + 239;
    const int INF = 1e18 + 239;

    vector<int> ps(n + 1);
    vector<pair<int, int>> dp(n + 1);

    for (int i = 0; i < n; i++) {
        ps[i + 1] = ps[i] + a[i];
    }

    auto grel = [&](int i, int j, int B) {
        pair<int, int> cand = dp[j];
        cand.first += (ps[i] - ps[j]) * (i - j) + B;
        cand.second--;
        return cand;
    };

    auto solve = [&](int B) {
        for (int i = 0; i <= n; i++) {
            dp[i] = {INF, -INF};
        }
        dp[0] = {0, 0};
        int p = 0;
        for (int i = 1; i <= n; i++) {
            while (p + 1 < i && grel(i, p + 1, B) < grel(i, p, B)) {
                p++;
            }
            for (int t = max((int)0, p - 5); t < min(i, p + 5); t++) {
                dp[i] = min(dp[i], grel(i, t, B));
            }
        }
        return -dp[n].second;
    };
    int l = 0;
    int r = L;
    while (r - l > 1) {
        int m = (r + l) >> 1;
        if (solve(m) >= k) {
            l = m;
        } else {
            r = m;
        }
    }
    solve(l);
    int ans = dp[n].first - k * l;
    ans -= ps[n];
    return ans;
}

int ok_solve(int n, int k, vector<int> a) {
    const int INF = 1e18 + 239;

    vector<int> ps(n + 1);
    vector<vector<int>> dp(n + 1, vector<int> (k + 1, INF));
    for (int i = 0; i < n; i++) {
        ps[i + 1] = ps[i] + a[i];
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int p = 0; p < i; p++) {
                dp[i][j] = min(dp[i][j], (i - p) * (ps[i] - ps[p]) + dp[p][j - 1]);
            }
        }
    }
    return dp[n][k] - ps[n];
}

void read() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &t : a) {
        cin >> t;
    }
    cout << solve(n, k, a) << '\n';
}

void gen(int &cnt) {
    const int N = 10;

    int n = rng() % N + 1;
    int k = rng() % n + 1;
    vector<int> a(n);
    for (auto &t : a) {
        t = rng() % N + 1;
    }

    int my_ans = solve(n, k, a);
    int ok_ans = ok_solve(n, k, a);

    if (my_ans != ok_ans) {
        cout << "WA\n";
        cout << n << ' ' << k << '\n';
        for (auto t : a) {
            cout << t << ' ';
        }
        cout << endl;
        exit(0);
    } else {
        cout << "ok " << cnt << '\n';
        cnt++;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    if (DEBUG) {
        int c = 1;
        while (true) {
            gen(c);
        }
    } else {
        read();
    }
}
