#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

mt19937 rng(10);

const int C = 20;
const bool DEBUG = 0;

int solve(int n, int k, vector<int> a) {
    const int L = 1e15 + 239;
    const int INF = 1e18 + 239;

    vector<int> ps(n + 1);
    vector<pair<int, int>> dp(n + 1);

    for (int i = 0; i < n; i++) {
        ps[i + 1] = ps[i] + a[i];
    }

    if (k == 3) {
        auto cost = [&](int l, int r) {
            return (ps[r] - ps[l]) * (r - l);
        };
        auto c = [&](int i, int mid) {
            return cost(0, mid) + cost(mid, i);
        };
        vector<int> pf(n + 1);
        int ans = INF;
        for (int i = 2; i <= n; i++) {
            {
                int l = 1;
                int r = i - 2;
                while (r - l > 1) {
                    int mid = (r + l) / 2;
                    if (c(i, mid) >= c(i, mid + 1)) {
                        l = mid;
                    } else {
                        r = mid;
                    }
                }
                pf[i] = INF;
                for (int j = max((int)0, l - C); j < min(i, l + C); j++) {
                    pf[i] = min(pf[i], c(i, j));
                }
            }
            ans = min(ans, pf[i] + cost(i, n));
        }
        return ans - ps[n];
    }

    auto grel = [&](int i, int j, int B) {
        pair<int, int> cand = dp[j];
        cand.first += (ps[i] - ps[j]) * (i - j) + B;
        cand.second--;
        return cand;
    };

    auto solve = [&](int B) {
        for (int i = 0; i <= n; i++) {
            dp[i] = {INF, -INF};
        }
        dp[0] = {0, 0};
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < i; j++) {
                dp[i] = min(dp[i], grel(i, j, B));
            }
        }
        return -dp[n].second;
    };
    int l = 0;
    int r = L;
    while (r - l > 1) {
        int m = (r + l) >> 1;
        if (solve(m) >= k) {
            l = m;
        } else {
            r = m;
        }
    }
    solve(l);
    int ans = dp[n].first - k * l;
    ans -= ps[n];
    return ans;
}

int ok_solve(int n, int k, vector<int> a) {
    const int INF = 1e18 + 239;

    vector<int> ps(n + 1);
    vector<vector<int>> dp(n + 1, vector<int> (k + 1, INF));
    for (int i = 0; i < n; i++) {
        ps[i + 1] = ps[i] + a[i];
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            for (int p = 0; p < i; p++) {
                dp[i][j] = min(dp[i][j], (i - p) * (ps[i] - ps[p]) + dp[p][j - 1]);
            }
        }
    }
    return dp[n][k] - ps[n];
}

void read() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &t : a) {
        cin >> t;
    }
    cout << solve(n, k, a) << '\n';
}

void gen(int &cnt) {
    const int N = 200;

    int n = rng() % N + 3;
    // int k = rng() % n + 1;
    int k = 3;
    vector<int> a(n);
    for (auto &t : a) {
        t = rng() % N + 1;
    }

    int my_ans = solve(n, k, a);
    int ok_ans = ok_solve(n, k, a);

    if (my_ans != ok_ans) {
        cout << "WA\n";
        cout << n << ' ' << k << '\n';
        for (auto t : a) {
            cout << t << ' ';
        }
        cout << endl;
        exit(0);
    } else {
        cout << "ok " << cnt << '\n';
        cnt++;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    if (DEBUG) {
        int c = 1;
        while (true) {
            gen(c);
        }
    } else {
        read();
    }
}
