#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

const int N = 1e5 + 7;

namespace SegmentTree {
    int n;
    int a[2 * N];

    void init(int n_) {
        n = n_;
    }

    void add(int l, int r, int val) {
        for (int i = l; i < r; i++) {
            a[i] += val;
        }
    }

    int mx() {
        return *max_element(a, a + n);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, w, h;
    cin >> n >> w >> h;
    vector<int> x(n);
    vector<int> y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    vector<int> iy;
    for (int i = 0; i < n; i++) {
        iy.push_back(y[i]);
        iy.push_back(y[i] - h);
    }
    sort(iy.begin(), iy.end());
    iy.resize(unique(iy.begin(), iy.end()) - iy.begin());
    vector<tuple<int, int, int, int, int>> ev;
    for (int i = 0; i < n; i++) {
        int y1 = lower_bound(iy.begin(), iy.end(), y[i] - h) - iy.begin();
        int y2 = lower_bound(iy.begin(), iy.end(), y[i]) - iy.begin();
        ev.push_back({x[i] - w, 0, 1, y1, y2});
        ev.push_back({x[i], 1, -1, y1, y2});
    }
    sort(ev.begin(), ev.end());
    SegmentTree::init(iy.size());
    int ans = 0;
    for (auto t : ev) {
        int cx, tp, val, y1, y2;
        tie(cx, tp, val, y1, y2) = t;
        SegmentTree::add(y1, y2, val);
        ans = max(ans, SegmentTree::mx());
    }
    cout << ans << '\n';
}
