#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

const int N = 1e5 + 7;

namespace SegmentTree {
    int n;
    int t[8 * N];
    int mod[8 * N];

    void pull(int v) {
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    void apply(int v, int x) {
        t[v] += x;
        mod[v] += x;
    }

    void push(int v) {
        if (mod[v]) {
            apply(2 * v + 1, mod[v]);
            apply(2 * v + 2, mod[v]);
            mod[v] = 0;
        }
    }

    void add(int v, int l, int r, int ql, int qr, int x) {
        if (qr <= l || r <= ql) {
            return;
        } else if (ql <= l && r <= qr) {
            apply(v, x);
        } else {
            push(v);
            int m = (r + l) >> 1;
            add(2 * v + 1, l, m, ql, qr, x);
            add(2 * v + 2, m, r, ql, qr, x);
            pull(v);
        }
    }

    void init(int n_) {
        n = n_;
    }

    void add(int l, int r, int val) {
        r++;
        add(0, 0, n, l, r, val);
    }

    int mx() {
        return t[0];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, w, h;
    cin >> n >> w >> h;
    vector<int> x(n);
    vector<int> y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    vector<int> iy;
    for (int i = 0; i < n; i++) {
        iy.push_back(y[i]);
        iy.push_back(y[i] - h);
    }
    sort(iy.begin(), iy.end());
    iy.resize(unique(iy.begin(), iy.end()) - iy.begin());
    vector<tuple<int, int, int, int, int>> ev;
    for (int i = 0; i < n; i++) {
        int y1 = lower_bound(iy.begin(), iy.end(), y[i] - h) - iy.begin();
        int y2 = lower_bound(iy.begin(), iy.end(), y[i]) - iy.begin();
        ev.push_back({x[i] - w, 0, 1, y1, y2});
        ev.push_back({x[i], 1, -1, y1, y2});
    }
    sort(ev.begin(), ev.end());
    SegmentTree::init(iy.size());
    int ans = 0;
    for (auto t : ev) {
        int cx, tp, val, y1, y2;
        tie(cx, tp, val, y1, y2) = t;
        SegmentTree::add(y1, y2, val);
        ans = max(ans, SegmentTree::mx());
    }
    cout << ans << '\n';
}
