#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
#define endl '\n'
#ifdef dremix
    #define p(x) cerr<<#x<<" = "<<x<<endl;
    #define p2(x,y) cerr<<"("<<#x<<","<<#y<<") = "<<x<<","<<y<<endl;
    #define pv(x) cerr<<#x<<" = {";for(auto v : x)cerr<<v<<", ";cerr<<"}"<<endl;
#else
    #define p(x)
    #define p2(x,y)
    #define pv(x)
#endif
const ll INF = 2e18;
const int MOD = 1e9+7;
const int N = 1e5+1;

int pref[1001][1001];

void valid(int &x){
    x = max(x,1);
    x = min(x,1000);
}

int get(int x1, int y1, int x2, int y2){
    /// (x1,y1) upper left
    /// (x2,y2) lower right
    valid(x1);
    valid(x2);
    valid(y1);
    valid(y2);
    return pref[x2][y2] - pref[x1-1][y2] - pref[x2][y1-1] +
    pref[x1-1][y1-1];
}

struct BIT{
    vector<int> bit;
    int N;

    void init(int n){
        bit.assign(n+1,0);
        N = n;
    }

    void add(int k, int x){
        while(k<=N){
            bit[k] += x;
            k += k&-k;
        }
    }

    int pref(int k){
        int sum = 0;
        while(k>0){
            sum += bit[k];
            k -= k&-k;
        }
        return sum;
    }

    int query(int l, int r){
        return pref(r) - pref(l-1);
    }

};


int main (){
fastio

/// lemma : optimal rectangle always has a corner on a point
/// => 4N possible positions for rectangle
/// find way to count points in rectangle efficiently
/// wrong ^^^
/// new lemma : optimal rectangle has a point on one of its sides
/// can prove that you can choose 2 sides of the rectangle that
/// are next to each other and always arrive at an optimal answer
/// with at least one point on each of those sides
/// choose top and right sides -> use 2 BITS to create a segment

int n,w,h;
cin>>n>>w>>h;

pi in[n];
bool small = n<=100 && w<=100 && h<=100;

for(int i=0;i<n;i++){
    cin>>in[i].F>>in[i].S;
    small &= in[i].F<=100 && in[i].S<=100;
}

if(small){

    int i,j;
    int arr[1001][1001];
    memset(arr,0,sizeof arr);

    pi p[n];

    for(i=0;i<n;i++){
        int x,y;
        x = in[i].F;
        y = in[i].S;
        p[i] = {x,y};
        arr[x][y]++;
    }

    for(i=1;i<1001;i++){
        int sum = 0;
        for(j=1;j<1001;j++){
            sum += arr[i][j];
            pref[i][j] = pref[i-1][j] + sum;
        }
    }

    int ans = 0;

    for(i=1;i<1001;i++)
        for(j=1;j<1001;j++)
            ans = max(ans,get(i,j,i+w,j+h));

    cout<<ans;

}
else{
    int i;
    pi arr[n];

    vector<vector<int> > pts(N);

    for(i=0;i<n;i++){
        int x,y;
        x = in[i].F;
        y = in[i].S;
        arr[i] = {x,y};
        pts[x].push_back(y);
    }

    BIT left,right;
    left.init(N);
    right.init(N);

    sort(arr,arr+n);

    int l = 0,r = 0;
    int ans = 0;

    for(i=0;i<n;i++){
        while(r < arr[i].F){
            r++;
            for(auto x : pts[r]){
                right.add(x,1);
                p(x)
            }
        }
        while(l < r - w - 1){
            l++;
            for(auto x : pts[l]){
                left.add(x,1);
                p2(1,x)
            }
        }
        p2(arr[i].F,arr[i].S)
        p2(l,r)

        int p1 = left.query(max(1,arr[i].S-h),arr[i].S);
        int p2 = right.query(max(1,arr[i].S-h),arr[i].S);

        p2(p1,p2)

        ans = max(ans,p2 - p1);
    }

    cout<<ans;

}


}
