#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
using ld = long double;

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000;
ll const inf = 1000000000000000000;

int v[1 + nmax];
ll sum[1 + nmax];
int sol[1 + nmax];

std::pair<ld, int> dp[1 + nmax];

std::pair<ld,int> extract(int n, ld cost) {
  for(int i = 1; i <= n; i++)
    dp[i] = {inf, 0};
  dp[0] = {0, 0};
  for(int i = 1;i <= n; i++)
    for(int j = 0; j < i; j++) {
      std::pair<ld, int> result = dp[j];
      result.second++;
      result.first += (sum[i] - sum[j]) * (i - j - 1) + cost;
      if(result < dp[i]) 
        dp[i] = result;
    }
  return dp[n];
}

int main() {
  int n, k;
  std::cin >> n >> k;
  for(int i = 1;i <= n; i++) 
    std::cin >> v[i];
  for(int i = 1;i <= n; i++)
    sum[i] = sum[i - 1] + v[i];
  ll x = 0, jump = (1LL << 60);
  for(int i = 0; i < 100; i++) {
    if(k <= extract(n, jump + x).second)
      x += jump;
    jump /= 2;
  }
  std::pair<ld, int> sol = extract(n, x);
  std::cout << sol.first - x * k;
  return 0;
}
