#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 100000;
ll const inf = 1000000000000000000;

int v[1 + nmax];
ll sum[1 + nmax];
int sol[1 + nmax];

std::pair<ll, int> dp[1 + nmax];

void transport(int j, int i, ll cost) {
  std::pair<ll, int> result = dp[j];
  result.second++;
  result.first += (sum[i] - sum[j]) * (i - j - 1) + cost;
  if(result.first < dp[i].first) { 
    dp[i] = result;
    sol[i] = j;
  } else if(result.first == dp[i].first && result.second < dp[i].second) {
    dp[i] = result;
    sol[i] = j;
  }
}


std::pair<ll,int> extract(int n, ll cost) {
  for(int i = 1; i <= n; i++)
    dp[i] = {inf, 0};
  dp[0] = {0, 0};
  for(int i = 1;i <= n; i++) {
    sol[i] = sol[i - 1];
    for(int j = sol[i]; j < std::min(sol[i] + 50, i); j++)
      transport(j, i, cost);
    for(int j = std::max(i - 50, 0); j < i; j++)
      transport(j, i, cost);
  }
  return dp[n];
}

int main() {
  int n, k;
  std::cin >> n >> k;
  if(k == n) {
    std::cout << 0;
    return 0;
  }
  for(int i = 1;i <= n; i++) 
    std::cin >> v[i];
  for(int i = 1;i <= n; i++)
    sum[i] = sum[i - 1] + v[i];
  ll x = 0;
  for(ll jump = (1LL << 60); 0 < jump; jump /= 2) 
    if(k < extract(n, jump + x).second) {
      x += jump;
    }
  std::pair<ll, int> sol = extract(n, x + 1);
  std::cout << sol.first - 1LL * (x + 1) * k;
  return 0;
}
