#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>

using ll = long long;
using us = unsigned short;

int const lgmax = 26;
std::vector<int> var[1 + lgmax];

void gcd(ll a, ll b, ll &x, ll &y) {
  if(b == 0) {
    x = 1;
    y = 0;
  } else {
    gcd(b, a % b, x, y);
    ll aux = x;
    x = y;
    y = aux - a/ b * y;
  }
}


ll prod_mod(ll a, ll b, ll modulo) {
  if(b == 0)
    return 0;
  else if(b == 1)
    return a % modulo;
  else {
    ll result = prod_mod(a, b / 2, modulo);
    if(b % 2 == 0)
      return (result + result) % modulo;
    else
      return ((result + result) % modulo + a) % modulo;
  }
}

ll inverse(ll number, ll modulo) {
  ll x, y;
  number %= modulo;

  gcd(number, modulo, x, y);
  x %= modulo;
  if(x < 0)
    x += modulo;
  return x;
}

us dp[(1 << lgmax)];

int getmod(int modulo) {
  for(int i = 0; i < (1 << lgmax); i++)
    dp[i] = 0;
  dp[0] = 1;
  int spec = 0;
  if(modulo == (1 << 16)) {
    for(int mask = 0; mask < (1 << lgmax) - 1; mask++) {
      if(0 < dp[mask]) {
        int id = __builtin_popcount(mask);
        for(int i = 0; i < var[id].size(); i++) {
          if((mask & (1 << var[id][i])) == 0) {
            dp[mask | (1 << var[id][i])] += dp[mask];
          }
        }
      }
    }
  } else {
    for(int mask = 0; mask < (1 << lgmax) - 1; mask++) {
      if(0 < dp[mask]) {
        int id = __builtin_popcount(mask);
        for(int i = 0; i < var[id].size(); i++) {
          if((mask & (1 << var[id][i])) == 0) {
            dp[mask | (1 << var[id][i])] += dp[mask];
            if(modulo <= dp[mask | (1 << var[id][i])])
              dp[mask | (1 << var[id][i])] -= modulo;
          }
        }
      }
    }
  }
  return dp[(1 << lgmax) - 1];
}

int prime(int number) {
  for(int i = 2; i * i <= number; i++)
    if(number % i == 0)
      return 0;
  return 1;
}

int main() {
  std::string s;
  for(int i = 0; i < lgmax; i++) {
    std::cin >> s;
    for(int j = 0; j < s.size(); j++)
      var[i].push_back(s[j] - 'A');
    std::sort(var[i].begin(), var[i].end());
    var[i].erase(std::unique(var[i].begin(), var[i].end()), var[i].end());
  }

  ll mod1 = (1<<16);
  ll mod2 = 16369;
  ll mod3 = 16381;
  ll res1 = getmod(mod1), res2 = getmod(mod2), res3 = getmod(mod3);

  res2 = (res2 - res1) % mod2;
  if(res2 < mod2)
    res2 += mod2;

  ll result = (res1 + 1LL * mod1 * inverse(mod1, mod2) * res2) % (mod1 * mod2);

  res3 = (res3 - result) % mod3;
  if(res3 < mod3)
    res3 += mod3;

  result = (result + prod_mod(prod_mod(mod1 * mod2,inverse(mod1 * mod2, mod3), mod1 * mod2 * mod3), res3, mod1 * mod2 * mod3));
  result %= mod1 * mod2 * mod3;

  if(result < 0)
    result += mod1 * mod2 * mod3;
  std::cout << result;
  return 0;
}

