#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 100000;
ll const inf = 1000000000000000000;

int v[1 + nmax];
ll sum[1 + nmax];
int sol[1 + nmax];

std::pair<ll, int> dp[1 + nmax];
int phase;

void transport(int j, int i, ll cost) {
  std::pair<ll, int> result = dp[j];
  result.second++;
  result.first += (sum[i] - sum[j]) * (i - j - 1) + cost;
  if(result.first < dp[i].first) { 
    dp[i] = result;
    sol[i] = j;
  } else if(result.first == dp[i].first && result.second < dp[i].second) {
    dp[i] = result;
    sol[i] = j;
  }
}


std::pair<ll,int> extract(int n, ll cost) {
  for(int i = 1; i <= n; i++)
    dp[i] = {inf, 0};
  if(n <= 6000) {
    dp[0] = {0, 0};
    for(int i = 1;i <= n; i++) {
      sol[i] = sol[i - 1];
      for(int j = sol[i]; j < i; j++)
        transport(j, i, cost);
    }
  } else {
    int plus = 100;
    for(int i = 1;i <= n; i++) {
      sol[i] = sol[i - 1];
      for(int j = sol[i]; j < std::min(sol[i] + plus, i); j++)
        transport(j, i, cost);
    }
  }
  return dp[n];
}

ll dp2[1 + nmax], dp3[1 + nmax];

int main() {
  int n, k;
  std::cin >> n >> k;
    if(k == n) {
      std::cout << 0;
      return 0;
    }
    for(int i = 1;i <= n; i++) 
      std::cin >> v[i];
    for(int i = 1;i <= n; i++)
      sum[i] = sum[i - 1] + v[i];
  if(400 < k) {
    ll x = 0;
    phase = 1;
    for(ll jump = (1LL << 60); 0 < jump; jump /= 2) 
      if(k < extract(n, jump + x).second) {
        x += jump;
      }
    phase = 2;
    std::pair<ll, int> sol = extract(n, x + 1);
    std::cout << sol.first - 1LL * (x + 1) * k;
  } else {
    dp2[0] = 0;
    for(int i = 1;i <= n; i++)
      dp2[i] = inf;
    for(int i = 0; i <= n; i++)
      dp3[i] = inf;
    dp3[0] = 0;
    for(int i = 1; i <= k; i++) {
      for(int j = 1;j <= n; j++) {
        sol[j] = sol[j - 1];
        for(int j2 = sol[j]; j2 < j; j2++) {
          ll result = dp2[j2] + (sum[j] - sum[j2]) * (j - j2 - 1);
          if(result < dp3[j]) {
            dp3[j] = result;
            sol[j] = j2;
          }
        }
      }
      for(int j = 0;j <= n; j++){
        dp2[j] = dp3[j];
        dp3[j] = inf;
      }
    }
    std::cout << dp2[n];
  }
  return 0;
}
