
#include <iostream>
#include <vector>
#include <cassert>

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 100000;
ll const inf = 1000000000000000000;

int v[1 + nmax];
ll sum[1 + nmax];
int sol[1 + nmax];

std::pair<ll, int> dp[1 + nmax];
int phase;

void transport(int j, int i, ll cost) {
  std::pair<ll, int> result = dp[j];
  result.second++;
  result.first += (sum[i] - sum[j]) * (i - j - 1) + cost;
  if(result.first < dp[i].first) { 
    dp[i] = result;
    sol[i] = j;
  } else if(result.first == dp[i].first && result.second < dp[i].second) {
    dp[i] = result;
    sol[i] = j;
  }
}


std::pair<ll,int> extract(int n, ll cost) {
  for(int i = 1; i <= n; i++)
    dp[i] = {inf, 0};
  if(n <= 0) {
    dp[0] = {0, 0};
    for(int i = 1;i <= n; i++) {
      sol[i] = sol[i - 1];
      for(int j = sol[i]; j < i; j++)
        transport(j, i, cost);
    }
  } else {
    std::vector<int> ids;
    int smax = 0, idmax = 0;

    for(int i = 1;i <= n; i++) {
      ids.push_back(i - 1);

      sol[i] = sol[i - 1];
      ll smax = 0, idmax = 0;
      for(int j = 0; j < ids.size(); j++) {
        transport(ids[j], i, cost);
        ll result = dp[ids[j]].first + (sum[i] - sum[ids[j]]) * (i - ids[j] - 1) + cost;
        if(smax < result) {
          smax = result;
          idmax = j;
        }
      }
      if(200 < ids.size())
        ids.erase(ids.begin() + idmax);
    }
  }
  return dp[n];
}

int main() {
  int n, k;
  std::cin >> n >> k;
  if(k == n) {
    std::cout << 0;
    return 0;
  }
  for(int i = 1;i <= n; i++) 
    std::cin >> v[i];
  for(int i = 1;i <= n; i++)
    sum[i] = sum[i - 1] + v[i];
  ll x = 0;
  phase = 1;
  for(ll jump = (1LL << 60); 0 < jump; jump /= 2) 
    if(k < extract(n, jump + x).second) {
      x += jump;
    }
  phase = 2;
  std::pair<ll, int> sol = extract(n, x + 1);
  std::cout << sol.first - 1LL * (x + 1) * k;
  return 0;
}

