#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100005;

struct Point {
  int x, y;
  bool operator <(const Point& other) const {
    return x < other.x;
  }
};

Point p[MAXN];

struct Node {
  int val;
  int lazy;
};

Node aint[8 * MAXN];

void propag(int node, int l, int r) {
  if (l > r)
    return ;
  aint[node].val += aint[node].lazy;
  if (l != r) {
    aint[2 * node].lazy += aint[node].lazy;
    aint[2 * node + 1].lazy += aint[node].lazy;
  }
  aint[node].lazy = 0;
}

void update(int node, int l, int r, int a, int b, int val) {
  propag(node, l, r);
  if (a <= l && r <= b) {
    aint[node].lazy += val;
    propag(node, l, r);
    return ;
  }
  int mid = (l + r) / 2;
  if (a <= mid)
    update(2 * node, l, mid, a, b, val);
  if (b > mid)
    update(2 * node + 1, mid + 1, r, a, b, val);
  aint[node].val = max(aint[2 * node].val, aint[2 * node + 1].val);
}

int query() {
  return aint[1].val;
}

int main() {

  int n, w, h;
  scanf("%d%d%d", &n, &w, &h);
  set<int>s;
  for (int i = 1; i <= n; ++i) {
    scanf("%d%d", &p[i].x, &p[i].y);
    s.insert(p[i].y - h);
    s.insert(p[i].y);
  }

  map<int, int>val;
  int k = 0;
  for (auto it:s)
    val[it] = ++k;

  sort(p + 1, p + n + 1);

  int ans = 0;
  int l = 0, r = 1;
  while (l <= n) {
    int vl = p[l].x;
    while (l <= n && p[l].x == vl) {
      if (l)
        update(1, 1, k, val[p[l].y - h], val[p[l].y], -1);
      l++;

    }
    if (l > n)
      break;
    while (r <= n && p[l].x + w >= p[r].x) {
      update(1, 1, k, val[p[r].y - h], val[p[r].y], 1);
      r++;
    }
    ans = max(ans, query());
  }

  printf("%d\n", ans);

  return 0;
}
