#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <bitset>
#include <string>

using namespace std;

#define fr(i, n)		 for(int i = 0; i < n; i++)
#define frs(i, s, n)	 for(int i = s; i < n; i++)
#define frsp(i, s, n, p) for(int i = s; i < n; i+= p)
typedef unsigned long long num;
typedef vector<num> vn;
typedef vector<vn> vvn;
typedef pair<num, num> point;

typedef unsigned int alphabet;
map < vector<alphabet>, num > alpha;

bool lt(alphabet a, alphabet b)
{
	bool now = a > b;
	int diff = 0;
	while (a != 0)
	{
		diff -= a & 1;
		a >>= 1;
	}
	while (b != 0)
	{
		diff += b & 1;
		b >>= 1;
	}
	return (diff < 0) || (diff == 0) && (now);
}


num recursiveSolve(vector<alphabet>& currMat)
{
	num res = 0;
	int size = currMat.size();
	vector<alphabet> newOne;
	if (alpha.find(currMat) != alpha.end())
	{
		return alpha[currMat];
	}

	alphabet a = currMat[size - 1];
	int i = 0;
	while (a > 0)
	{
		if ((a)&1)
		{
			newOne = currMat;
			newOne.pop_back();
			fr(j, size - 1)
			{
				newOne[j] = (((-(1 << (i + 1)))&newOne[j]) >> 1) | (((1 << i) - 1)&newOne[j]);
			}
			sort(newOne.begin(), newOne.end(), lt);
			res += recursiveSolve(newOne);
		}
		a >>= 1;
		i++;
	}


	return alpha[currMat] = res;
}


int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	vector<alphabet> currMat;
	string curr;
	currMat.resize(26);
	fr(i, 26)
	{
		cin >> curr;
		for (char c : curr)
		{
			currMat[i] |= 1<< (c - 'A');
		}
	}
	sort(currMat.begin(), currMat.end(), lt);
	alpha[vector<alphabet>(1, 1)] = 1;
	cout << recursiveSolve(currMat) <<endl;
	return 0;
}