#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <bitset>
#include <string>

using namespace std;

#define fr(i, n)		 for(int i = 0; i < n; i++)
#define frs(i, s, n)	 for(int i = s; i < n; i++)
#define frsp(i, s, n, p) for(int i = s; i < n; i+= p)
typedef int num;
typedef vector<num> vn;
typedef vector<vn> vvn;
typedef pair<int, int> point;
typedef pair< pair<int, int>, int> priple;


//segment tree - find max of range and add 1 to range
vector<point> tree; //(to add, max (inc to add))

#define treeSIZE 524288
#define toLower(currNodeIndex) ((currNodeIndex) << 1)
#define toUpper(currNodeIndex) (((currNodeIndex) << 1)|1)
void addToRange(int lower, int upper,  int nodeLower, int nodeUpper, int currNodeIndex, num value)
{
	int nodeMiddle = (nodeLower + nodeUpper) / 2;
	if (lower == nodeLower && upper == nodeUpper)
	{
		tree[currNodeIndex].first += value;
		tree[currNodeIndex].second += value;
		return;
	}
	else if (upper <= nodeMiddle)
	{
		addToRange(lower, upper, nodeLower, nodeMiddle, toLower(currNodeIndex), value);
	}
	else if (nodeMiddle <= lower)
	{
		addToRange(lower, upper, nodeMiddle, nodeUpper, toUpper(currNodeIndex), value);
	}
	else
	{
		addToRange(lower, nodeMiddle, nodeLower, nodeMiddle, toLower(currNodeIndex), value);
		addToRange(nodeMiddle, upper, nodeMiddle, nodeUpper, toUpper(currNodeIndex), value);
	}
	tree[currNodeIndex].second = max(tree[toLower(currNodeIndex)].second, tree[toUpper(currNodeIndex)].second) + tree[currNodeIndex].first;
}


inline void addToRange(int lower, int upper, num value)
{
	addToRange(lower, upper, 0, treeSIZE / 2, 1, value);
}
inline num getMaxAll()
{
	return tree[1].second;
}

#if(0)
void tester()
{
	cout << tree[1].second << endl;
	addToRange(0, 3, 1);
	cout << tree[1].second << endl;
	addToRange(3, 4, 1);
	cout << tree[1].second << endl;
	addToRange(3, 7, 2);
	cout << tree[1].second << endl;
	addToRange(0, 4, -1);
	cout << tree[1].second << endl;
	addToRange(3, 7, -2);
	cout << tree[1].second << endl;
}
#endif
int N, W, H;
vector<priple> allPoints;
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	tree.resize(treeSIZE);
	cin >> N >> W >> H;
	H++; W++;
	fr(i, N)
	{
		priple p;//y, sigh, x
		cin >> p.second >> p.first.first;
		p.first.second = 1;
		allPoints.push_back(p);
		p.first.first += H;
		p.first.second = -1;
		allPoints.push_back(p);
	}

	sort(allPoints.begin(), allPoints.end());
	num res = 0;
	for (priple curr : allPoints)
	{
		addToRange(max(curr.second - W + 1, 0), curr.second + 1, curr.first.second);
		res = max(res, getMaxAll());
	}
	cout << res << endl;
	return 0;
}