#include <bits/stdc++.h>

using namespace std;

struct seg_tree
{
    int sz = 1;
    vector<int> DO, L, R, mod;
    seg_tree(int n)
    {
        while (sz < n) sz <<= 1;
        DO.resize(sz << 1);
        L.resize(sz << 1);
        R.resize(sz << 1);
        mod.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
    }
    void relax(int x)
    {
        if (x >= sz)
        {
            DO[x] += mod[x];
            mod[x] = 0;
            return;
        }
        mod[x << 1] += mod[x];
        mod[x << 1 | 1] += mod[x];
        mod[x] = 0;
        DO[x] = max(DO[x << 1] + mod[x << 1], DO[x << 1 | 1] + mod[x << 1 | 1]);
    }
    void add(int l, int r, int val, int x = 1)
    {
        if (r < L[x] || R[x] < l) return;
        if (l <= L[x] && R[x] <= r)
        {
            mod[x] += val;
            return;
        }
        add(l, r, val, x << 1);
        add(l, r, val, x << 1 | 1);
        relax(x);
    }
    int get()
    {
        relax(1);
        return DO[1];
    }
};

int main()
{
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<pair<int, int>, pair<int, int> > > events;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        events.push_back({make_pair(x - w, 1), make_pair(y - h, y)});
        events.push_back({make_pair(x + 1, -1), make_pair(y - h, y)});
    }
    sort(events.begin(), events.end());
    if (n <= 100000)
    {
        vector<int> all;
        for (int i = 0; i < events.size(); ++i)
        {
            all.push_back(events[i].second.first);
            all.push_back(events[i].second.second);
        }
        sort(all.begin(), all.end());
        map<int, int> to;
        for (int i = 0; i < all.size(); ++i) to[all[i]] = i;
        for (int i  =0; i < events.size(); ++i)
        {
            events[i].second.first = to[events[i].second.first];
            events[i].second.second = to[events[i].second.second];
        }
    }
    int mx = -1;
    for (int i = 0; i < events.size(); ++i)
        mx = max(mx, events[i].second.second);
    seg_tree x(mx + 5);
    int res = 0;
    for (int i = 0; i < events.size(); ++i)
    {
        x.add(events[i].second.first, events[i].second.second, events[i].first.second);
        res = max(res, x.get());
    }
    cout << res << endl;
}
