#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define vvvll vector<vvll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define big (ll)10000000000000000
#define mod (ll)1000000007

using namespace std;

ll n, k;
vll arr;
vll sum;

ll ans;

void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}

void init_sum()
{
	sum.resize(n);
	sum[0] = arr[0];
	for (ll i = 1; i < n; i++)
	{
		sum[i] = arr[i] + sum[i - 1];
	}
}

ll cost(ll start, ll end)
{
	ll valsum = sum[end];
	if (start > 0) valsum -= sum[start - 1];
	
	ll valnum = end - start + 1;
	return valsum * (valnum - 1);
}


/*

dp[i][j][k] = min total fear after splitting i first fish into j plaecs, where the last group is of size k.


Try to do binary search of finding the maximum total fear of a group:
Let all the group reach no more than that fear.


*/
void solve()
{
	vvvll dp(n, vvll(k + 1, vll(n+1, big)));
	dp[0][1][1] = 0;
	
	for(ll i = 1; i < n; i++)
	{
		for (ll j = 0; j <= k; j++)
		{
			for (ll k = 0; k < n; k++)
			{
				dp[i][j][k];
			}
		}
	}
}


bool calc(ll mx)
{
	ll tans = 0;
	ll cursplit = 0;
	for (ll i = 0; i < n;)
	{
		cursplit++;
		if (cursplit > k) return false;
		ll right = i;
		while (right < n - 1 && cost(i, right + 1) <= mx) right++;
		tans += cost(i, right);
		i = right + 1;
	}
	
	ans = min(ans, tans);
	return true;
	
}


void solve_bin()
{
	ll low = 0, high = big, mid;
	ll lowmx = big;
	while (low <= high)
	{
		mid = (low + high) / 2;
		if (calc(mid))
		{
			lowmx = min(lowmx, mid);
			high = mid - 1;
		}
		else
		{
			low = mid + 1;
		}
	}
	//cout << "lowmx: " << lowmx << endl;
	//cout << "ans: " << endl;
	cout << ans << endl;
}

int main()
{
	cin >> n >> k;
	arr.resize(n);
	for (ll i = 0; i < n; i++) cin >> arr[i];
	init_sum();
	ans = big;

	solve_bin();

}