#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>

#define ll long long
#define vll vector<ll>
#define vvll vector<vll>
#define vvvll vector<vvll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define big (ll)10000000000000000
#define mod (ll)1000000007

using namespace std;

ll n, k;
vll arr;
vll sum;

ll ans;

void print_vll(vll& arr, const string name)
{
	cout << name << ": " << endl;
	for (ll i = 0; i < arr.size(); i++)
	{
		cout << arr[i] << " ";
	}
	cout << endl;
}

void init_sum()
{
	sum.resize(n);
	sum[0] = arr[0];
	for (ll i = 1; i < n; i++)
	{
		sum[i] = arr[i] + sum[i - 1];
	}
}

ll cost(ll start, ll end)
{
	ll valsum = sum[end];
	if (start > 0) valsum -= sum[start - 1];
	
	ll valnum = end - start + 1;
	return valsum * (valnum - 1);
}


/*

dp[i][j][k] = min total fear after splitting i first fish into j plaecs, where the last group is of size k.


Try to do binary search of finding the maximum total fear of a group:
Let all the group reach no more than that fear.


*/
void solve()
{
	vvvll dp(n+1, vvll(k + 1, vll(n+1, big)));
	dp[0][0][0] = 0;

	vvll dpbest(n + 1, vll(k + 1, big));
	dpbest[0][0] = 0;
	
	for(ll i = 1; i <= n; i++)
	{
		for (ll j = 1; j <= k; j++)
		{
			for (ll k = 1; k < n; k++)
			{
				if (i - k < 0) continue;

				// try to create a new one:
				dp[i][j][k] = dpbest[i - k][j - 1] + cost(i - k , i-1);
				dpbest[i][j] = min(dpbest[i][j], dp[i][j][k]);

			}
		}
	}

	/*
	for (ll i = 0; i <= n; i++)
	{
		for (ll j = 0; j <= k; j++)
		{
			for (ll k = 0; k <= n; k++)
			{
				cout << "done " << i << ", has " << j << " splits, last split is of size " << k << ": " << dp[i][j][k] << endl;
			}
		}
	}
	*/
	ans = big;
	for (ll i = 0; i <= n; i++)
	{
		ans = min(ans, dp[n][k][i]);
	}
	//cout << "ans: " << endl;
	cout << ans << endl;
}



void solve2()
{
	vvll dp(n + 1, vll(k+1, big));
	dp[0][0] = 0;

	for (ll i = 1; i <= n; i++)
	{
		for (ll j = 0; j <= k; j++)
		{
			ll low = 1, high = i, mid;
			while (low <= high)
			{
				mid = (low + high) / 2;

			}
		}
	}
}


void solve3()
{
	ll tans = big;
	//end1 = we finish in arr[end1]
	for (ll end1 = 0; end1 < n-2; end1++)
	{
		ll curans = cost(0, end1);
		ll low = end1 + 1;
		ll high = n - 2, mid;
		while (low <= high)
		{
			mid = (low + high) / 2;
			ll costleft = cost(end1 + 1, mid);
			ll costright = cost(mid + 1, n - 1);
			tans = min(tans, curans + costleft + costright);
			if (costleft < costright) low = mid + 1;
			else high = mid - 1;
		}
	}
	cout << tans << endl;
}
bool calc(ll mx)
{
	ll tans = 0;
	ll cursplit = 0;
	for (ll i = 0; i < n;)
	{
		cursplit++;
		if (cursplit > k) return false;
		ll right = i;
		while (right < n - 1 && cost(i, right + 1) <= mx) right++;
		tans += cost(i, right);
		i = right + 1;
	}
	
	ans = min(ans, tans);
	return true;
	
}


void solve_bin()
{
	ll low = 0, high = big, mid;
	ll lowmx = big;
	while (low <= high)
	{
		mid = (low + high) / 2;
		if (calc(mid))
		{
			lowmx = min(lowmx, mid);
			high = mid - 1;
		}
		else
		{
			low = mid + 1;
		}
	}
	//cout << "lowmx: " << lowmx << endl;
	//cout << "ans: " << endl;
	cout << ans << endl;
}

int main()
{
	cin >> n >> k;
	k = min(n, k);
	arr.resize(n);
	for (ll i = 0; i < n; i++) cin >> arr[i];
	init_sum();
	ans = big;

	if (k == 1)
	{
		ans = cost(0, n - 1);
		cout << ans << endl;
		return 0;
	}
	else if (k == 3)
	{
		solve3();
	}
	else
	{
		solve();
	}
	

}


/*

2 1
2 2

4 3
1 10 10 10



*/