﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif
 
using namespace std;
 
#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 1e5 + 10;
const int M = 3e7 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

int n, k, a[N], p[N];
int opt[N], opt2[N];

struct Kek {
    int a[M];

    int& operator()(int i, int j) {
        int pos = 0;
        if (i > k) {
            pos += (i - k) * (k + 1);
            i = k;
        }
        return a[pos + i * (i + 1) / 2 + j];
    }
} dp;

inline int cost(int l, int r) {
    return (r - l) * (p[r + 1] - p[l]);
}

int solve1() {
    fill(dp.a, dp.a + M, 1e18);
    dp(0, 0) = 0;

    for (int i = 1; i <= n; i++) {
        opt[min(i, k) + 1] = i - 1;
        for (int j = min(i, k); j > 0; j--) {
            for (int k = opt2[j]; k <= opt[j + 1]; k++) {
                if (dp(i, j) > dp(k, j - 1) + cost(k, i - 1)) {
                    dp(i, j) = dp(k, j - 1) + cost(k, i - 1);
                    opt[j] = k;
                }
            }
        }
        opt[min(i, k) + 1] = 0;

        for (int j = 0; j < N; j++) {
            opt2[j] = opt[j];
        }
    }

    return dp(n, k);
}

void solve(int j, int l, int r, int lx, int rx) {
    if (l > r) {
        return;
    }

    int i = (l + r) / 2, opt = lx;
    for (int k = lx; k <= min(i - 1, rx); k++) {
        if (dp(i, j) > dp(k, j - 1) + cost(k, i - 1)) {
            dp(i, j) = dp(k, j - 1) + cost(k, i - 1);
            opt = k;
        }
    }

    solve(j, l, i - 1, lx, opt);
    solve(j, i + 1, r, opt, rx);
}

int solve2() {
    fill(dp.a, dp.a + M, 1e18);
    dp(0, 0) = 0;

    for (int j = 1; j <= k; j++) {
        solve(j, 1, n, 0, n);
    }

    /*
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= min(i, k); j++) {
            cout << i << " " << j << " " << dp(i, j) << endl;
        }
    }
    */

    return dp(n, k);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        p[i + 1] = p[i] + a[i];
    }

    if (k == 3) {
        cout << solve2() << endl;
    }
    else {
        cout << solve1() << endl;
    }

    return 0;
}
