﻿//#pragma GCC optimize("Ofast,unroll-loops")

#ifdef LOCAL
#include "headers.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#endif
 
using namespace std;
 
//#define int ll
 
typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
#define sz(x) int((x).size())

template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef ONLINE_JUDGE
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#else
mt19937 rng(1000 - 7);
#endif
 
const int N = 1e5 + 10;
//const ll MOD = 998244353;
const ll MOD = 1e9 + 7;
const ld eps = 5e-8;
const pii dir[] = { { 0, 1 }, { 0, -1 }, { 1, 0 }, { -1, 0 } };

int n, w, h;
vector <int> y[N];

struct Tree {
    vector <int> t[4 * N];

    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = y[l];
        }
        else {
            int m = (l + r) / 2;

            build(2 * v, l, m);
            build(2 * v + 1, m + 1, r);

            t[v].reserve(t[2 * v].size() + t[2 * v + 1].size());
            merge(
                t[2 * v].begin(), t[2 * v].end(),
                t[2 * v + 1].begin(), t[2 * v + 1].end(),
                back_inserter(t[v])
            );
        }
    }

    int query(int v, int tl, int tr, int lx, int rx, int ly, int ry) {
        if (lx > rx) {
            return 0;
        }
        else if (tl == lx && tr == rx) {
            return upper_bound(t[v].begin(), t[v].end(), ry) - 
                lower_bound(t[v].begin(), t[v].end(), ly);
        }
        else {
            int tm = (tl + tr) / 2;

            return
                query(2 * v, tl, tm, lx, min(rx, tm), ly, ry) +
                query(2 * v + 1, tm + 1, tr, max(tm + 1, lx), rx, ly, ry);
        }
    }

    inline int query(int lx, int ly, int rx, int ry) {
        return query(1, 0, N - 1, lx, rx, ly, ry);
    }
} tree;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> w >> h;
    vector <pii> c(n);
    for (int i = 0, cx, cy; i < n; i++) {
        cin >> cx >> cy;
        y[cx].push_back(cy);
        c[i] = { cx, cy };
    }

    for (int i = 0; i < N; i++) {
        sort(y[i].begin(), y[i].end());
    }

    tree.build(1, 0, N - 1);

    int ans = 0;
    for (auto [x, y] : c) {
        ans = max(ans, tree.query(max(0, x - w), max(0, y - h), x, y));
    }

    cout << ans << endl;
    
    return 0;
}
