#include <algorithm>
#include <iostream>
#include <bitset>
#include <random>
#include <chrono>
#include <set>
using namespace std;
using llong = long long;
using uint = unsigned int;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int alSz = 26;
const int dpSz = 22;
const int szDiff = alSz - dpSz;
#define Bits(x) __builtin_popcount(x)

llong dp[1 << dpSz];
vector<int> at[dpSz];

llong DP()
{
    sort(at, at + dpSz, [](const vector<int>& l, const vector<int>& r) {
         return l.size() > r.size();
    });
    dp[0] = 1;
    for (uint mask = 1; mask < (1 << dpSz); ++mask)
    {
        dp[mask] = 0;
        int bits = Bits(mask);
        for (int i: at[bits - 1])
            if (mask & (1 << i))
                dp[mask] += dp[mask ^ (1 << i)];
    }
    return dp[(1 << dpSz) - 1];
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
    string raw[alSz];
    for (int i = 0; i < alSz; ++i) {
        cin >> raw[i];
        sort(raw[i].begin(), raw[i].end());
        raw[i].erase(unique(raw[i].begin(), raw[i].end()), raw[i].end());
    }
    sort(raw, raw + alSz, [](const string& l, const string& r) {
         return l.size() < r.size();
    });
    llong ans = 0;
    for (char a: raw[0])
    for (char b: raw[1])
    for (char c: raw[2])
    for (char d: raw[3])
    {
        if (set<char>{a, b, c, d}.size() != szDiff) continue;
        for (int i = 0; i < dpSz; ++i)
            at[i].clear();
        for (int i = szDiff; i < alSz; ++i)
            for (char t: raw[i])
                if (!set<char>{a, b, c, d}.count(t))
                    at[t - 'A' - (t>a) - (t>b) - (t>c) - (t>d)].push_back(i - szDiff);
        ans += DP();
    }
    cout << ans;
}
