#include <iostream>
#include <string>
#include <random>
#include <chrono>
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

namespace NNK
{
    const int maxN = 1000;
    llong dp[maxN][maxN + 1];
    llong Solve(int n, int k) {
        const llong inf = 1000'000'000'000'000'000LL;
        for (int i = 0; i < n; ++i)
            for (int p = 1; p <= i + 1; ++p)
                dp[i][p] = inf;
        vector<llong> a(n);
        for (llong& i: a) cin >> i;
        vector<llong> pref(n);
        partial_sum(a.begin(), a.end(), pref.begin());
        dp[0][1] = 0;
        for (int i = 1; i < n; ++i)
        {
            dp[i][1] = i * pref[i];
            for (int p = 2; p <= i + 1; ++p)
                for (int j = p - 2; j < i; ++j)
                    dp[i][p] = min(dp[i][p], dp[j][p - 1] + (i - j - 1) * (pref[i] - pref[j]));
        }
        return dp[n - 1][k];
    }
}
namespace K3
{
    llong Solve(int n, int k)
    {
        vector<llong> a(n);
        for (llong i: a) cin >> i;
    }
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
    if (n <= 1000) {
        cout << NNK::Solve(n, k);
        exit(0);
    }
}
