#include <algorithm>
#include <iostream>
#include <random>
#include <chrono>
using namespace std;
using llong = long long;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) {cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';}
ostream& operator<<(ostream& out, const pair<auto, auto>& p) {
	return out << "{" << p.first << ", " << p.second << "}";
}
#else
#define BUGO(x)
#define BUGOARR(x)
#endif
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
const int maxN = 100'005;
struct P {
    int x, y;
};
#define ROOT 1, 0, 1e8

int nodes = 1;
const int buff = 12e6;
int t[buff], lazy[buff], lson[buff], rson[buff];

void Push(int v, int vl, int vr)
{
    if (vl != vr) {
        if (lson[v] == -1) {
            if (nodes + 2 >= buff) {
                exit(0);
            }
            lson[v] = ++nodes;
            rson[v] = ++nodes;
        }
        lazy[lson[v]] += lazy[v];
        lazy[rson[v]] += lazy[v];
    }
    t[v] += lazy[v];
    lazy[v] = 0;
}
void Add(int v, int vl, int vr, int l, int r, int val)
{
    if (vl > r || l > vr)
        return;
    if (l <= vl && vr <= r) {
        lazy[v] += val;
        return;
    }
    Push(v, vl, vr);
    int vm = vl + (vr - vl) / 2;
    Add(lson[v], vl, vm, l, r, val);
    Add(rson[v], vm + 1, vr, l, r, val);
    Push(lson[v], vl, vm); Push(rson[v], vm + 1, vr);
    t[v] = max(t[lson[v]], t[rson[v]]);
}
int main()
{
    fill(lson, lson + buff, -1);
    fill(rson, rson + buff, -1);
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, xlen, ylen;
	cin >> n >> xlen >> ylen;
	vector<P> a(n);
	for (P& p: a) cin >> p.x >> p.y;
    sort(a.begin(), a.end(), [](const P& l, const P& r) {
         return l.y < r.y;
    });
    int ans = 0;
    for (int l = 0, r = l - 1; l < n; ) {
        while (r + 1 < n && a[r + 1].y - a[l].y <= ylen) {
            int x = a[++r].x;
            Add(ROOT, max(0, x - xlen), x, 1);
        }
        Push(ROOT);
        ans = max(ans, t[1]);
        int x = a[l++].x;
        Add(ROOT, max(0, x - xlen), x, -1);
    }
    cout << ans;
}
