#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>

using namespace std;

const int m = 100;

void build_tree(vector<int>& tree, vector<int>& a, int L, int R, int u) {
	if (R - L == 1) {
		tree[u] = a[L];
		return;
	}
	int M = (L + R) / 2;
	build_tree(tree, a, L, M, 2 * u + 1);
	build_tree(tree, a, M, R, 2 * u + 2);
	tree[u] = tree[2 * u + 1] + tree[2 * u + 2];
}

int summ(vector<int>& tree, int L, int R, int u, int left, int right) {
	if (L >= right || left >= R)
		return 0;
	if (left <= L && R <= right)
		return tree[u];
	int M = (L + R) / 2;
	return summ(tree, L, M, 2 * u + 1, left, right) + summ(tree, M, R, 2 * u + 2, left, right);
}

void build_tree2(vector<int>& tree, vector<int>& tree1, vector<int>& tree2, int L, int R, int u) {
	if (R - L == 1) {
		tree[u] = tree1[u] + tree2[u];
		return;
	}
	int M = (L + R) / 2;
	build_tree2(tree, tree1, tree2, L, M, 2 * u + 1);
	build_tree2(tree, tree1, tree2, M, R, 2 * u + 2);
	tree[u] = tree[2 * u + 1] + tree[2 * u + 2];
}

void build_tree2d(vector<vector<int>>& tree2d, vector<vector<int>>& a, int L, int R, int u) {
	if (R - L == 1) {
		build_tree(tree2d[u], a[L], 0, m, 0);
		return;
	}
	int M = (L + R) / 2;
	build_tree2d(tree2d, a, L, M, 2 * u + 1);
	build_tree2d(tree2d, a, M, R, 2 * u + 2);
	build_tree2(tree2d[u], tree2d[2 * u + 1], tree2d[2 * u + 2], 0, m, 0);
}

int summ2d(vector<vector<int>>& tree2d, int L, int R, int u, int left1, int right1, int left2, int right2) {
	if (L >= right1 || left1 >= R)
		return 0;
	if (left1 <= L && R <= right1) {
		return summ(tree2d[u], 0, m, 0, left2, right2);
	}
	int M = (L + R) / 2;
	return summ2d(tree2d, L, M, 2 * u + 1, left1, right1, left2, right2) + summ2d(tree2d, M, R, 2 * u + 2, left1, right1, left2, right2);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, w, h;
	cin >> n >> w >> h;
	vector<vector<int>> crd(100, vector<int>(100, 0));
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		crd[x - 1][y - 1]++;
	}
	vector<vector<int>> tree2d(400, vector<int>(400, 0));
	build_tree2d(tree2d, crd, 0, 100, 0);
	int ans = 0;
	for (int i = 0; i + w <= 99; ++i)
		for (int j = 0; j + h <= 99; ++j)
			ans = max(ans, summ2d(tree2d, 0, 100, 0, i, i + w + 1, j, j + h + 1));
	cout << ans;
}