#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll maxn = ll(1e3) + 2;
const ll inf = ll(1e17) + 123;

ll n, w, h;
vector<pll> ps;

struct node {
    ll l, mid, r;
    node *left, *right;
    ll mus;
    node(ll l, ll r): l(l), r(r) {
        mid = (l + r) / 2;
        mus = 0;
        left = right = nullptr;
    }
};

void build(node *root) {}

void add_val(node *root, ll ql, ll qr, ll val) {
    if(root->r < ql || root->l > qr) {
        return;
    }
    if(ql <= root->l && root->r <= qr) {
        root->mus += val;
        return;
    }
    if(root->left == nullptr) root->left = new node(root->l, root->mid);
    if(root->right == nullptr) root->right = new node(root->mid + 1, root->r);
    add_val(root->left, ql, qr, val);
    add_val(root->right, ql, qr, val);
    root->mus = root->left->mus + root->right->mus;
}

ll get_mus(node *root, ll ql, ll qr) {
    if(root == nullptr) return 0;
    if(root->r < ql || root->l > qr) {
        return 0;
    }
    if(ql <= root->l && root->r <= qr) {
        return root->mus;
    }
    return get_mus(root->left, ql, qr) +
            get_mus(root->right, ql, qr);
}

void solve() {
    cin >> n >> w >> h;
    for(ll i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        ps.pb({x, y});
    }

    ll ans = 0;

    sort(ps.begin(), ps.end());

    if(n > ll(1e3)) {
        node *root = new node(0, maxn);

        ll l = 0;
        for(ll i = 0; i < n; i++) {
            add_val(root, ps[i].second, ps[i].second, 1);
            while(l < i && ps[i].first - ps[l].first > w) {
                add_val(root, ps[l].second, ps[l].second, -1);
                l++;
            }
            ans = max(ans, get_mus(root, ps[i].second - h, ps[i].second));
        }
        cout << ans << endl;
        return;
    }

    for(ll i = 0; i < n; i++) {
        vector<pll> cur;
        for(ll j = i; j < n; j++) {
            if(ps[j].first - ps[i].first > w) {
                break;
            }
            cur.pb({ps[j].second, ps[j].first});
        }
        sort(cur.begin(), cur.end());

        ll l = 0, r = 0;
        while(l < cur.size()) {
            while(r < cur.size() && cur[r].first - cur[l].first <= h) {
                r++;
            }
            ans = max(ans, r - l);
            l++;
        }
    }
    cout << ans;
}


int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
