#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

int tree[800000];

void update(int interval_left, int interval_right, int interval_idx, int val, int pos) {
    if (interval_left > interval_right || interval_left > pos || interval_right < pos) return;

    if (interval_left == interval_right) {
        if (interval_left == pos) tree[interval_idx] += val;

        return;
    }

    int mid = (interval_left+interval_right)/2;

    update(interval_left,mid,2*interval_idx,val,pos);
    update(mid+1,interval_right,2*interval_idx+1,val,pos);

    tree[interval_idx] = tree[2*interval_idx] + tree[2*interval_idx+1];
}

int query (int interval_left, int interval_right, int interval_idx, int left, int right) {
    if (interval_left > interval_right) return 0;
    if (interval_left > right || interval_right < left) return 0;

    if (interval_left >= left && interval_right <= right) return tree[interval_idx];

    int mid = (interval_left+interval_right)/2;

    return query(interval_left,mid,2*interval_idx,left,right) + query(mid+1,interval_right,2*interval_idx+1,left,right);
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,w,h;

    cin>>n>>w>>h;

    if (n <= 100) {
        pair<int,int> tacki[n];

        for (int i = 0; i<n; i++) cin>>tacki[i].first>>tacki[i].second;

        vector<pair<int,int>> events[2001];

        for (int i = 0; i<n; i++) {
            events[tacki[i].first].pb({1, tacki[i].second});
            events[tacki[i].first+w+1].pb({0, tacki[i].second});
        }

        int vertEvents[2001];
        MS(vertEvents,0);

        int res = 0;

        for (int i = 0; i<2001; i++) {
            for (auto it:events[i]) {
                pair<int,int> currCoord = {i, it.second};
                bool finish = !it.first;

                if (finish) { vertEvents[currCoord.second]--; vertEvents[currCoord.second+h+1]++; }
                else { vertEvents[currCoord.second]++; vertEvents[currCoord.second+h+1]--; }
            }

            int ctrMom = 0;

            for (int j = 0; j<2001; j++) {
                ctrMom += vertEvents[j];
                res = max(res,ctrMom);
            }
        }

        cout<<res<<endl;

        return 0;
    }

    pair<int,int> tacki[n];
    for (int i = 0; i<n; i++) cin>>tacki[i].first>>tacki[i].second;

    vector<pair<pair<int,int>,int>> events;

    for (int i = 0; i<n; i++) {
        events.pb({{tacki[i].first, 1}, tacki[i].second});
        events.pb({{tacki[i].first+w+1, 0}, tacki[i].second});
    }

    sort(events.begin(), events.end());

    multiset<int> crnt;
    int res = 0;

    MS(tree,0);

    for (int i = 0; i<2*n; i++) {
        pair<int,int> currCoord = {events[i].first.first, events[i].second};
        bool finish = !events[i].first.second;

        if (finish) { crnt.erase(currCoord.second); update(0,100000,1,-1,currCoord.second); }
        else {
            crnt.insert(currCoord.second);

            update(0,100000,1,+1,currCoord.second);

            res = max(res,query(0,100000,1,currCoord.second-h,currCoord.second));
        }
    }

    cout<<res<<endl;
}
