#include <bits/stdc++.h>

#define int long long
using namespace std;

struct node {
    int x;
    node *L;
    node *R;

    node() {
        x = 0;
        L = nullptr;
        R = nullptr;
    }
};

node *build(int tl, int tr) {
    if (tl == tr) {
        return new node();
    }
    int tm = (tl + tr) / 2;
    node *y = new node();
    y->L = build(tl, tm);
    y->R = build(tm + 1, tr);
    return y;
}

node *upd(node *v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        node *y = new node();
        y->x = v->x + val;
        y->L = v->L;
        y->R = v->R;
        return y;
    }
    int tm = (tl + tr) / 2;
    node *y = new node();
    y->L = v->L;
    y->R = v->R;
    if (pos <= tm) {
        y->L = upd(v->L, tl, tm, pos, val);
    } else {
        y->R = upd(v->R, tm + 1, tr, pos, val);
    }
    y->x = y->L->x + y->R->x;
    return y;
}

int get(node *v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)return 0;
    if (l <= tl && tr <= r) {
        return v->x;
    }
    int tm = (tl + tr) / 2;
    return get(v->L, tl, tm, l, r) + get(v->R, tm + 1, tr, l, r);
}

int n;
const int maxn = 1e3;
int a[maxn][maxn];
int pref[maxn + 1][maxn + 1];
vector<pair<int, int>> p;
int mxx = 0;
int mxy = 0;
node *root[(int) 1e5 + 10];

void calc() {
    for (int i = 1; i < maxn + 1; ++i) {
        for (int j = 1; j < maxn + 1; ++j) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i - 1][j - 1];
        }
    }
}

int gt(int x1, int y1, int x2, int y2) {
    return pref[x2 + 1][y2 + 1] - pref[x1][y2 + 1] - pref[x2 + 1][y1] + pref[x1][y1];
}

int solve(int w, int h) {
    int ans = 0;
    for (int i = 0; i <= mxx; ++i) {
        for (int j = 0; j <= mxy; ++j) {
            int x = i;
            int y = j;
            ans = max(ans, gt(max(x - w, 0ll), max(y - h, 0ll), x, y));
        }
    }
    return ans;
}

bool comp(pair<int, int> o1, pair<int, int> o2) {
    return o1.second < o2.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cin >> n;
    int w, h;
    cin >> w >> h;
    mxx = w;
    mxy = h;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        mxx = max(mxx, x);
        mxy = max(mxy, y);
        p.push_back({x, y});
        if (x < maxn && y < maxn)
            a[x][y]++;
    }

    if (mxx < 1e2 && mxy < 1e2) {
        calc();
        cout << solve(w, h);
    } else if (mxx >= 1e5 || mxy >= 1e5) {
        sort(p.begin(), p.end(), comp);
        int ans = 0;
        for (int i = 0; i < p.size(); ++i) {
            int cnt = 0;
            vector<int> ok;
            for (int j = 0; j < p.size(); ++j) {
                if (p[i].first - p[j].first >= 0 && p[i].first - p[j].first <= w) {
                    ok.push_back(p[j].second);
                }
            }
            auto it = upper_bound(ok.begin(), ok.end(), p[i].second);
            int id = it - ok.begin() - 1;
            for (int k = 0; k <= id; ++k) {
                int l = ok[k];
                int r = ok[k] + h;
                it = upper_bound(ok.begin(), ok.end(), r);
                int cnt1 = it - ok.begin();
                it = upper_bound(ok.begin(), ok.end(), l - 1);
                int cnt2 = it - ok.begin();
                ans = max(ans, cnt1 - cnt2);
            }
        }
        cout << ans;
    } else {
        int M = 1e5 + 10;
        sort(p.begin(), p.end());
        vector<int> pp;
        for (int j = 0; j < p.size(); ++j) {
            pp.push_back(p[j].first);
        }
        root[0] = build(0, M);
        for (int i = 0; i < p.size(); ++i) {
            root[i + 1] = upd(root[i], 0, M, p[i].second, 1);
        }
        int ans = 0;
        for (int k = 0; k < p.size(); ++k) {
            int x = p[k].first;
            int y = p[k].second;
            auto it = upper_bound(pp.begin(), pp.end(), x);
            int id2 = it - pp.begin();
            it = upper_bound(pp.begin(), pp.end(), x - w - 1);
            int id1 = it - pp.begin();
            int cnt = get(root[id2], 0, M, max(0ll, y - h), y) - get(root[id1], 0, M, max(0ll, y - h), y);
            ans = max(ans, cnt);
        }
        cout << ans;
    }
}