#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define MAXN 1000000
#define MAXN 1000000
int tree[MAXN * 4];
int add[MAXN * 4];

void push(int v, int l, int r) {
    tree[v] += add[v];
    if (r - l > 1) {
        add[v * 2] += add[v];
        add[v * 2 + 1] += add[v];
    }
    add[v] = 0;
}

void init(int v, int l, int r) {
    tree[v] = 0;
    if (r - l > 1) {
        int m = (r + l) / 2;
        init(v * 2, l, m);
        init(v * 2 + 1, m, r);
    }
}

void inc(int v, int l, int r, int tl, int tr, int cnt) {
    if (l >= tr || r <= tl) {
        return;
    }
    push(v, l, r);
    if (tl <= l && r <= tr) {
        add[v] += cnt;
        push(v, l, r);
        return;
    }
    int m = (r + l) / 2;
    inc(v * 2, l, m, tl, tr, cnt);
    inc(v * 2 + 1, m, r, tl, tr, cnt);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> events;
    set<int> all;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        events.push_back({x - w, -y});
        events.push_back({x, y});
        all.insert(y + 1);
        all.insert(max(y - h, 0));
        if (y < 1) {
            cout << 1 / 0;
        }
    }
    map<int, int> comp;
    int index = 0;
    for (auto el:all) {
        comp[el] = index++;
    }

    sort(events.begin(), events.end());
    int ans = 0;
    init(1, 0, MAXN);
    for (auto event:events) {
        int y = abs(event.second);
        int delta = (event.second > 0 ? -1 : 1);
        inc(1, 0, MAXN, comp[max(y - h, 0)], comp[y + 1], delta);
        push(1, 0, MAXN);
        ans = max(ans, tree[1]);
    }
    cout << ans;
    return 0;
}