// #pragma GCC optimize("O3")
// #pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10, K = 4;
const ll INF = 0x3f3f3f3f3f3f3f3f;

int n, k;
int a[N];
ll pref[N];
pair<ll, int> dp[N];
ll dp2[K][N];

void countFor(ll cost) {
	fill(all(dp), make_pair(ll(+INF), -1));
	dp[0] = {0, 0};
	int prev = 0;
	for (int j = 1; j <= n; ++j) {
		for (int h = prev; h < j; ++h) {
			ll curr = dp[h].x + cost + ll(j - h - 1) * (pref[j] - pref[h]);
			if (dp[j].x > curr) {
				prev = h;
				dp[j].x = curr;
				dp[j].y = dp[h].y + 1;
			}
		}
	}
}

void count2For(int k, int l, int r, int pmin, int pmax) {
	if (l >= r)
		return;
	int j = (l + r) / 2;
	int pcurr = -1;
	for (int h = pmin; h < min(pmax + 1, j); ++h) {
		ll curr = dp2[k - 1][h] + ll(j - h - 1) * (pref[j] - pref[h]);
		if (dp2[k][j] > curr) {
			pcurr = h;
			dp2[k][j] = curr;
		}
	}
	count2For(k, l, j, pmin, pcurr);
	count2For(k, j + 1, r, pcurr, pmax);
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		pref[i + 1] = pref[i] + a[i];
	}
	if (k < 4) {
		fill(dp2[0], dp2[K], +INF);
		dp2[0][0] = 0;
		for (int i = 1; i <= k; ++i)
			count2For(i, 0, n + 1, 0, n);
		cout << dp2[k][n];
		return 0;
	}

	ll lef = 0, rig = 1e12;
	int already = false;
	while (rig - lef > 1) {
		ll cost = (lef + rig) / 2;
		countFor(cost);
		if (dp[n].y == k) {
			rig = cost;
			already = true;
			break;
		}
		if (dp[n].y > k) {
			lef = cost;
			already = false;
		} else {
			rig = cost;
			already = true;
		}
	}
	if (!already)
		countFor(rig);
	cout << dp[n].x - rig * k;
#ifdef DEBUG
	cout << endl << "time: " << clock() << endl;
#endif
	return 0;
}