#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5 + 5;
const int VMAX = 1e8;

struct rect {
	int x, y;
	bool operator < (const rect &aux)const {
		if (x != aux.x) return x < aux.x;
		return y < aux.y;
	}
};

rect a[DIM];
priority_queue <rect> pq;
int n, w, h;

struct dinamic {
	int mx, lazy;
	dinamic *l, *r;
	dinamic() {mx = lazy = 0; l = r = NULL;}
};

dinamic *T;

void propag(dinamic *nod) {
	if (nod->l == NULL) nod->l = new dinamic;
	if (nod->r == NULL) nod->r = new dinamic;

	nod->l->lazy += nod->lazy;
	nod->l->mx += nod->lazy;
	nod->r->lazy += nod->lazy;
	nod->r->mx += nod->lazy;
	
	nod->lazy = 0;
}

void update(int x, int y, int val, int st = 1, int dr = VMAX, dinamic *nod = T) {
	if (x <= st && dr <= y) {
		nod->mx += val;
		nod->lazy += val;
		return ;
	}

	if (nod->lazy) propag(nod);
	int mij = (st + dr) / 2;
	if (x <= mij) {
		if (nod->l == NULL) nod->l = new dinamic;
		update(x, y, val, st, mij, nod->l);
	} 
	if (mij + 1 <= y) {
		if (nod->r == NULL) nod->r = new dinamic;
		update(x, y, val, mij + 1, dr, nod->r);
	}
	nod->mx = 0;
	if (nod->l != NULL) nod->mx = max(nod->mx, nod->l->mx);
	if (nod->r != NULL) nod->mx = max(nod->mx, nod->r->mx);
}

int query() {
	return T->mx;
}

int main() {
	scanf("%d%d%d", &n, &w, &h);
	for (int i = 1; i <= n ; ++i) scanf("%d%d", &a[i].x, &a[i].y);
	sort(a + 1, a + n + 1);

	T = new dinamic;
	int ans = 0;
	for (int i = 1; i <= n ; ++i) {
		while (!pq.empty() && -pq.top().x <= a[i].x) {
			int y = pq.top().y;
			pq.pop();
			update(y, y + h, -1);
		}

		update(a[i].y, a[i].y + h, 1);
		pq.push({-(a[i].x + w + 1), a[i].y});
		ans = max(ans, query());
	}

	printf("%d", ans);
	return 0;
}
