#include<iostream>
#include<vector>
#include<unordered_set>
#include<algorithm>

using namespace std;

vector<long long> ft;
const int ft_size = 1e5 + 2;
const long long INF = 2e18;

struct side {
	int x, lower_y, upper_y, rect_index;
	side(int _x=0, int y1=0, int y2=0, int index=0) {
		x = _x;
		lower_y = y1;
		upper_y = y2;
		rect_index = index;
	}
};

bool cmp(side a, side b) {
	return a.x < b.x;
}

long long get_pref(int x) {
	long long res = 0;
	for (int i = x; i >= 0; i = (i & (i - 1)) - 1)
		res += ft[i];
	return res;
}

void update(int x, int v) {
	for (int i = x; i < ft_size; i = i | (i + 1))
		ft[i] += v;
}


int main() {
	int n, w, h;
	cin >> n >> w >> h;
	bool good = true;
	vector<vector<int>> desk(1001, vector<int>(1001, 0));
	vector<pair<int, int>> point(n);
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		if (x > 1000 || y > 1000)
			good = false;
		desk[x][y] += 1;
		point[i] = { x, y };
	}
	if (w > 1000 || h > 1000)
		good = false;
	if (good) {
		vector<vector<int>> pref_sum_rows(1001 + 1, vector<int>(1001 + 1, 0));
		for (int x = 1; x < 1002; ++x)
			for (int y = 1; y < 1002; ++y)
				pref_sum_rows[x][y] = pref_sum_rows[x][y - 1] + desk[x - 1][y - 1];
		vector<vector<int>> pref_sum_cols(1001 + 1, vector<int>(1001 + 1, 0));
		for (int y = 1; y < 1002; ++y)
			for (int x = 1; x < 1002; ++x)
				pref_sum_cols[x][y] = pref_sum_cols[x - 1][y] + desk[x - 1][y - 1];
		int base = 0;
		for (int x = 0; x <= w; ++x) {
			for (int y = 0; y <= h; ++y) {
				base += desk[x][y];
			}
		}
		int cur = base;
		int ans = base;
		for (int x = 0; x <= 1000 - w; ++x) {
			for (int y = 1; y <= 1000 - h; ++y) {
				cur -= pref_sum_cols[x + w + 1][y] - pref_sum_cols[x][y];
				cur += pref_sum_cols[x + w + 1][y + h + 1] - pref_sum_cols[x][y + h + 1];
				ans = max(ans, cur);
			}
			base -= pref_sum_rows[x + 1][h + 1] - pref_sum_rows[x + 1][0];
			if (x < 1000 - w)
				base += pref_sum_rows[x + 1 + w + 1][h + 1] - pref_sum_rows[x + 1 + w + 1][0];
			cur = base;
			ans = max(ans, cur);
		}
		cout << ans;
	}
	else {
		vector<long long> rect(n, -INF);
		vector<side> sides;
		sides.reserve(2 * n);
		for (int i = 0; i < n; ++i) {
			if (point[i].first - w >= 0 && point[i].second - h >= 0) {
				sides.emplace_back(point[i].first - w, point[i].second - h, point[i].second, i);
				sides.emplace_back(point[i].first, point[i].second - h, point[i].second, i );
			}
		}
		sort(point.begin(), point.end());
		sort(sides.begin(), sides.end(), cmp);
		ft.assign(ft_size, 0);
		int i = 0, j = 0;
		long long ans = 0;
		for (int x = 0; x <= 1e5; ++x) {
			while (i < n && point[i].first == x) {
				update(x, 1);
				++i;
			}
			while (j < sides.size() && sides[j].x == x) {
				if (rect[sides[j].rect_index] == -INF)
					rect[sides[j].rect_index] = -(get_pref(sides[j].upper_y) - get_pref(sides[j].lower_y - 1));
				else
					rect[sides[j].rect_index] += get_pref(sides[j].upper_y) - get_pref(sides[j].lower_y);
				ans = max(ans, rect[sides[j].rect_index]);
				++j;
			}
		}
		cout << ans;
	}
}