#include <bits/stdc++.h>

const int MAX_N = 100000;
// 2 * 10^12 = 10^7 * 10^5 * 2
const long long ALIENS_LIM = 2000000000000LL;
const long long INF = 1LL << 62;

int a[1+MAX_N];
int cnt[1+MAX_N];
long long dp[1+MAX_N], sp[1+MAX_N];

// Ax + B
struct Line {
	long long a, b;
	int id;
	
	long long eval(long long x) {
		return a * x + b;
	}
};

// a / b < c / d
bool cmp_frac(long long a, long long b, long long c, long long d) {
	if(b < 0) {
		a *= -1LL;
		b *= -1LL;
	}

	if(d < 0) {
		c *= -1LL;
		d *= -1LL;
	}
	return (long double)a / b < (long double)c / d;
}

bool take_out(Line a, Line b, Line c) {
	// a n c < a n b
	return cmp_frac(a.b - c.b, c.a - a.a, a.b - b.b, b.a - a.a);
}

struct Batch {
	long long lazy;
	std::deque<Line> hull;

	Batch() {
		lazy = 0LL;
	}

	void push_line(Line x) {
		/*x.b -= lazy;
		if(hull.size() <= 1)
			hull.push_back(x);
		else {
			int N = hull.size();
			while(N >= 2 && take_out(hull[N - 2], hull[N - 1], x)) {
				N--;
				hull.pop_back();
			}
			hull.push_back(x);
		}*/
		hull.push_back(x);
	}

	std::pair<long long, int> query_min(long long x) {
		std::pair<long long, int> res(INF, 0);
		for(auto it: hull)
			res = std::min(res, std::make_pair(it.eval(x), cnt[it.id]));
		return res;
	}

	void add_lazy(long long val) {
		lazy += val;
	}
};

int cut[1+MAX_N];

int counted(int N, long long extra) {
	cnt[0] = 0;
	dp[0] = 0;

	/*int last = 0;
	for(int i = 1; i <= N; ++i) {
		long long sum = 0LL;
		
		int last2 = last;
		for(int t = 0; t < 100 && last + t < i; ++t) {
			if(dp[last + t] + (i - (last + t) - 1) * (sp[i] - sp[last + t]) <
			   dp[last2]    + (i - last2 - 1)      * (sp[i] - sp[last2])) {
				last2 = last + t;
			} else if(dp[last + t] + (i - (last + t) - 1) * (sp[i] - sp[last + t]) ==
			          dp[last2]    + (i - last2 - 1)      * (sp[i] - sp[last2]) &&
					  cnt[last + t] < cnt[last2])
				last2 = last;
		}

		last = last2;	
		dp[i] = dp[last] + (i - last - 1) * (sp[i] - sp[last]) + extra;
		cnt[i] = cnt[last] + 1;
		//printf("%d(%d)->%lld %d\n", i, last, dp[i], cnt[i]);
	}*/

	for(int i = 1; i <= N; ++i) {
		long long sum = 0LL;
		dp[i] = INF;
		cnt[i] = 0;
		// Bad dp - O(N^2)
		for(int j = i; j > 0; --j) {
			sum += a[j];
			if(dp[j - 1] + sum * (i - j) + extra < dp[i]) {
				dp[i] = dp[j - 1] + sum * (i - j) + extra;
				cnt[i] = cnt[j - 1] + 1;
				cut[i] = j - 1;
			} else if(dp[j - 1] + sum * (i - j) + extra == dp[i] && cnt[j - 1] + 1 < cnt[i]) {
				cnt[i] = cnt[j - 1] + 1;
				cut[i] = j - 1;
			}
		}
		//printf("%d->%lld %d %d\n", i, dp[i], cnt[i], cut[i]);
	}


	return cnt[N];
}

long long dgk[4][1+MAX_N];

void solve(int K, int l, int r, int i, int j) {
	int N = (l + r) / 2;
	dgk[K][N] = INF;
	int cut = -1;
	for(int t = i; t <= j && t < N; ++t) {
		long long new_dp = dgk[K - 1][t] + (sp[N] - sp[t]) * (N - t - 1);
		if(new_dp < dgk[K][N]) {
			dgk[K][N] = new_dp;
			cut = t;
		}
	}

	if(l <= N - 1)
		solve(K, l, N - 1, i, cut);
	if(N + 1 <= r)
		solve(K, N + 1, r, cut, j);
}

long long subtaskk3(int N, int K) {
	dgk[0][0] = 0;
	for(int i = 1; i <= N; ++i)
		dgk[0][i] = INF;
	for(int i = 1; i <= K; ++i)
		dgk[i][0] = INF;

	solve(1, 1, N, 0, N);
	solve(2, 1, N, 0, N);
	solve(3, 1, N, 0, N);

	return dgk[K][N];
}

int main() {
	int N, K;
	scanf("%d%d", &N, &K);

	for(int i = 1; i <= N; ++i) {
		scanf("%d", &a[i]);
		sp[i] = sp[i - 1] + a[i];
	}
	
	if(K == 3) {
		printf("%lld", subtaskk3(N, K));
		return 0;
	}
	long long l = -1, r = ALIENS_LIM + 1;

	while(r - l > 1) {
		long long mid = (l + r) / 2;
		if(counted(N, mid) > K)
			l = mid;
		else
			r = mid;
	}

	counted(N, r);
	printf("%lld\n", dp[N] - r * K);
	

	/*for(int i = 0; i <= 100; ++i) {
		counted(N, i);
		printf("%d -> %lld %d:%lld\n", i, dp[N], cnt[N], dp[N] - cnt[N] * i);
	}*/

	//counted(N, 19);
	return 0;
}
