#include <bits/stdc++.h>

const int MAX_N = 100000;
const int MAX_COORD = 2 * MAX_N;

struct Event {
	int down, up, val, x;
} events[2*MAX_N];

bool cmp_ev(Event a, Event b) {
	return a.x < b.x;
}

int* pnt[4*MAX_N];

bool cmp(int *a, int *b) {
	return *a < *b;
}

void normalize(int N_ev) {
	for(int i = 0; i < N_ev; i++) {
		pnt[i * 2] = &events[i].up;
		pnt[i * 2 + 1] = &events[i].down;
	}

	int N = N_ev * 2;
	std::sort(pnt, pnt + N, cmp);

	int last = *pnt[0], j = 1;
	for(int i = 0; i < N; ++i)
		if(last == *pnt[i])
			*pnt[i] = j;
		else {
			last = *pnt[i];
			*pnt[i] = ++j;
		}
}

int aint[1+4*MAX_COORD], lazy[1+4*MAX_COORD];

void pushlazy(int nod, int l, int r) {
	aint[nod] += lazy[nod];
	if(l < r) {
		lazy[2 * nod] += lazy[nod];
		lazy[2 * nod + 1] += lazy[nod];
	}
	lazy[nod] = 0;
}

void update(int i, int j, int val, int l = 1, int r = MAX_COORD, int nod = 1) {
	pushlazy(nod, l, r);
	if(j < l || r < i || j < i) return;

	if(i <= l && r <= j) {
		lazy[nod] += val;
		pushlazy(nod, l, r);
	} else {
		int mid = (l + r) / 2;
		update(i, j, val, l, mid, 2 * nod);
		update(i, j, val, mid + 1, r, 2 * nod + 1);
		aint[nod] = std::max(aint[2 * nod], aint[2 * nod + 1]);
	}
}

int query() {
	pushlazy(1, 1, MAX_COORD);
	return aint[1];
}

int main() {
	int n, w, h;
	scanf("%d%d%d", &n, &w, &h);

	for(int i = 0; i < n; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		events[2 * i] = {y, y + h, 1, x};
		events[2 * i + 1] = {y, y + h, -1, x + w + 1};
	}

	normalize(2 * n);
	std::sort(events, events + 2 * n, cmp_ev);

	int i = 0, res = 0;
	while(i < n * 2) {
		int j = i;
		while(j < n * 2 && events[i].x == events[j].x) {
			update(events[j].down, events[j].up, events[j].val);
			++j;
		}
		i = j;
	
		res = std::max(res, query());
	}

	printf("%d", res);

	return 0;
}
