//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
//#pragma GCC optimize(3)
//#pragma GCC optimize("O3")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("-fgcse")
//#pragma GCC optimize("-fgcse-lm")
//#pragma GCC optimize("-fipa-sra")
//#pragma GCC optimize("-ftree-pre")
//#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("-falign-jumps")
//#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

#ifdef DEBUG
const int N = 1e3 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;
#else
const int N = 2e5 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;
#endif

struct segment_tree {
    int t[4 * N], mod[4 * N];

    void push(int v, int l, int r) {
        if (mod[v] != 0) {
            t[v] += mod[v];
            if (l != r) {
                mod[v * 2] += mod[v];
                mod[v * 2 + 1] += mod[v];
            }
            mod[v] = 0;
        }
    }

    void update(int v, int l, int r, int tl, int tr, int val) {
        push(v, l, r);
        if (l >= tl && r <= tr) {
            mod[v] += val;
            push(v, l, r);
            return;
        }
        if (l > tr || r < tl) return;
        int m = (r + l) / 2;
        update(v * 2, l, m, tl, tr, val);
        update(v * 2 + 1, m + 1, r, tl, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr && r < tl) return -INF;
        int m = (r + l) / 2;
        return max(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }

};

int n, w, h, ans;
pair < int, int > a[N];
segment_tree tree;

void solve() {
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a,a + n);
    if (n <= 1000) {
        multiset < pair < int, int > > se;
        int r = -1;
        for (int i = 0; i < n; i++) {
            while (r + 1 < n && a[r + 1].first <= a[i].first + w) {
                r++;
                se.insert({a[r].second, a[r].first});
            }
            if (!se.empty()) {
                int cnt = 1;
                auto itr = se.begin();
                itr++;
                for (auto it = se.begin(); it != se.end(); it++) {
                    while (itr != se.end() && it->first + h >= itr->first) {
                        cnt++;
                        itr++;
                    }
                    ans = max(ans, cnt);
                    cnt--;
                }
            }
            se.erase(se.find({a[i].second, a[i].first}));
        }
        cout << ans;
        return;
    }
    int r = -1;
    for (int i = 0; i < n; i++) {
        while (r + 1 < n && a[r + 1].first <= a[i].first + w) {
            r++;
            tree.update(1, 0, N - 1, a[r].second, a[r].second + h, 1);
        }
        ans = max(ans, tree.get(1, 0, N - 1, 0, N - 1));
        tree.update(1, 0, N - 1, a[i].second, a[i].second + h, -1);
    }
    cout << ans;
}