//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
//#pragma GCC optimize(3)
//#pragma GCC optimize("O3")
//#pragma GCC optimize("inline")
//#pragma GCC optimize("-fgcse")
//#pragma GCC optimize("-fgcse-lm")
//#pragma GCC optimize("-fipa-sra")
//#pragma GCC optimize("-ftree-pre")
//#pragma GCC optimize("-ftree-vrp")
//#pragma GCC optimize("-fpeephole2")
//#pragma GCC optimize("-fsched-spec")
//#pragma GCC optimize("-falign-jumps")
//#pragma GCC optimize("-falign-loops")
//#pragma GCC optimize("-falign-labels")
//#pragma GCC optimize("-fdevirtualize")
//#pragma GCC optimize("-fcaller-saves")
//#pragma GCC optimize("-fcrossjumping")
//#pragma GCC optimize("-fthread-jumps")
//#pragma GCC optimize("-freorder-blocks")
//#pragma GCC optimize("-fschedule-insns")
//#pragma GCC optimize("inline-functions")
//#pragma GCC optimize("-ftree-tail-merge")
//#pragma GCC optimize("-fschedule-insns2")
//#pragma GCC optimize("-fstrict-aliasing")
//#pragma GCC optimize("-falign-functions")
//#pragma GCC optimize("-fcse-follow-jumps")
//#pragma GCC optimize("-fsched-interblock")
//#pragma GCC optimize("-fpartial-inlining")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("-freorder-functions")
//#pragma GCC optimize("-findirect-inlining")
//#pragma GCC optimize("-fhoist-adjacent-loads")
//#pragma GCC optimize("-frerun-cse-after-loop")
//#pragma GCC optimize("inline-small-functions")
//#pragma GCC optimize("-finline-small-functions")
//#pragma GCC optimize("-ftree-switch-conversion")
//#pragma GCC optimize("-foptimize-sibling-calls")
//#pragma GCC optimize("-fexpensive-optimizations")
//#pragma GCC optimize("inline-functions-called-once")
//#pragma GCC optimize("-fdelete-null-pointer-checks")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

#define int long long

#ifdef DEBUG
const int N = 100, MOD = 1e9 + 7, base = 131, INF = 1e9;
#else
const int N = 2e5 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;
#endif

struct Node {
    Node *l = nullptr;
    Node *r = nullptr;

    int val, mod;

    Node(Node *l, Node *r) : l(l), r(r) {
        val = max(l->val, r->val);
        mod = 0;
    }

    Node() {
        val = 0;
        mod = 0;
    }

    Node(Node *l, Node *r, int val, int mod) : l(l), r(r), val(val), mod(mod) {}
};

struct segment_tree {

    void push(Node *t, int l, int r) {
        if (t->mod != 0) {
            t->val += t->mod;
            if (l != r) {
                if (t->r == nullptr) t->r = new Node();
                t->r->mod += t->mod;
                if (t->l == nullptr) t->l = new Node();
                t->l->mod += t->mod;
            }
            t->mod = 0;
        }
    }

    void update(Node *t, int l, int r, int tl, int tr, int val) {
        push(t, l, r);
        if (l >= tl && r <= tr) {
            t->mod += val;
            push(t, l, r);
            return;
        }
        if (l > tr || r < tl) return;
        int m = (r + l) / 2;
        if (t->l == nullptr) t->l = new Node();
        update(t->l, l, m, tl, tr, val);
        if (t->r == nullptr) t->r = new Node();
        update(t->r, m + 1, r, tl, tr, val);
        t->val = max(t->l->val, t->r->val);
    }

    int get(Node *t, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t->val;
        }
        if (l > tr && r < tl) return -INF;
        int m = (r + l) / 2;
        if (t->l == nullptr) t->l = new Node();
        if (t->r == nullptr) t->r = new Node();
        return max(get(t->l, l, m, tl, tr), get(t->r, m + 1, r, tl, tr));
    }

};

int n, w, h, ans;
pair < int, int > a[N];
segment_tree tree;

void solve() {
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    Node *t = new Node();
    sort(a,a + n);
    int r = -1;
    for (int i = 0; i < n; i++) {
        while (r + 1 < n && a[r + 1].first <= a[i].first + w) {
            r++;
            tree.update(t, 0, N - 1, a[r].second, a[r].second + h, 1);
        }
        ans = max(ans, tree.get(t, 0, N - 1, 0, N - 1));
        tree.update(t, 0, N - 1, a[i].second, a[i].second + h, -1);
    }
    cout << ans;
}