
#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

#ifdef DEBUG
const int N = 1e3 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;
#else
const int N = 2e5 + 10, MOD = 1e9 + 7, base = 131, INF = 1e9;
#endif

struct segment_tree {
    int t[4 * N], mod[4 * N];

    void push(int v, int l, int r) {
        if (mod[v] != 0) {
            t[v] += mod[v];
            if (l != r) {
                mod[v * 2] += mod[v];
                mod[v * 2 + 1] += mod[v];
            }
            mod[v] = 0;
        }
    }

    void update(int v, int l, int r, int tl, int tr, int val) {
        push(v, l, r);
        if (l >= tl && r <= tr) {
            mod[v] += val;
            push(v, l, r);
            return;
        }
        if (l > tr || r < tl) return;
        int m = (r + l) / 2;
        update(v * 2, l, m, tl, tr, val);
        update(v * 2 + 1, m + 1, r, tl, tr, val);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    int get() {
        return t[1];
    }

};

int n, w, h, ans;
pair < int, int > a[N];
segment_tree tree;
vector < int > v;
map < int, int > ma;

void solve() {
    cin >> n >> w >> h;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        v.push_back(a[i].second);
        v.push_back(a[i].second + h);
    }
    sort(v.begin(), v.end());
    for (int i = 0; i < v.size(); i++) {
        if (!ma.count(v[i])) {
            ma[v[i]] = ma.size();
        }
    }
    sort(a,a + n);
    int r = -1;
    for (int i = 0; i < n; i++) {
        while (r + 1 < n && a[r + 1].first <= a[i].first + w) {
            r++;
            tree.update(1, 0, N - 1, ma[a[r].second], ma[a[r].second + h], 1);
        }
        ans = max(ans, tree.get());
        tree.update(1, 0, N - 1, ma[a[i].second], ma[a[i].second + h], -1);
    }
    cout << ans;
}