#include <iostream>

using namespace std;

using ll = long long;

const int NMAX = 3e2 + 5;
const ll INF = 1LL * 1e18;

int N, K, A[NMAX];

ll sp[NMAX];

ll dp[NMAX][NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for(int i = 1; i <= N; ++i)
        cin >> A[i], sp[i] = sp[i - 1] + 1LL * A[i];

    return;
}

static inline ll Cost (int Left, int Right)
{
    return 1LL * (sp[Right] - sp[Left - 1]) * 1LL * (Right - Left);
}

static inline void Initialize ()
{
    for(int i = 1; i <= N; ++i)
        dp[i][1] = Cost(1, i);

    return;
}

static inline ll my_min (ll a, ll b)
{
    return ((a < b) ? a : b);
}

static inline void Solve ()
{
    Initialize();

    for(int k = 2; k <= K; ++k)
    {
        for(int i = k; i <= N; ++i)
        {
            dp[i][k] = INF;

            for(int j = i; j >= 1; --j)
                dp[i][k] = my_min(dp[i][k], dp[j - 1][k - 1] + Cost(j, i));
        }
    }

    cout << dp[N][K] << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
