#include <iostream>

using namespace std;

using ll = long long;

const int NMAX = 1e5 + 5;
const ll INF = 1LL * 1e18;

int N, K, A[NMAX];

ll sp[NMAX];

ll dp[NMAX][2];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for(int i = 1; i <= N; ++i)
        cin >> A[i], sp[i] = sp[i - 1] + 1LL * A[i];

    return;
}

static inline ll Cost (int Left, int Right)
{
    return 1LL * (sp[Right] - sp[Left - 1]) * 1LL * (Right - Left);
}

static inline void Initialize ()
{
    for(int i = 1; i <= N; ++i)
        dp[i][1] = Cost(1, i);

    return;
}

static inline ll my_min (ll a, ll b)
{
    return ((a < b) ? a : b);
}

static inline void Go (int Left, int Right, int chosen_Left, int chosen_Right, int Level)
{
    if(Left > Right)
        return;

    int Mid = ((Left + Right) >> 1);
    int chosen = 0;

    dp[Mid][Level & 1] = INF;

    for(int i = chosen_Left; i <= ((Mid <= chosen_Right) ? Mid : chosen_Right); ++i)
    {
        ll now = dp[i - 1][(Level - 1) & 1] + Cost(i, Mid);

        if(now < dp[Mid][Level & 1])
            dp[Mid][Level & 1] = now, chosen = i;
    }

    Go(Left, Mid - 1, chosen_Left, chosen, Level);
    Go(Mid + 1, Right, chosen, chosen_Right, Level);

    return;
}

static inline void Solve ()
{
    Initialize();

    for(int j = 2; j <= K; ++j)
        Go(j, N, j, N, j);

    cout << dp[N][K & 1] << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
