#include <iostream>

using namespace std;

using ll = long long;

const int NMAX = 1e5 + 5;
const ll INF = 1LL * 1e18;

int N, K;
int X;

ll sp[NMAX];

ll ans = INF;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for(int i = 1; i <= N; ++i)
        cin >> X, sp[i] = sp[i - 1] + 1LL * X;

    return;
}

static inline ll Cost (int Left, int Right)
{
    return 1LL * (Right - Left) * (sp[Right] - sp[Left - 1]);
}

static inline ll my_min (ll a, ll b)
{
    return ((a < b) ? a : b);
}

static inline bool Ok (ll Lim)
{
    int groups = 0;
    ll SUM = 0;

    for(int i = 1; i <= N; )
    {
        ++groups;

        int Left = i + 1, Right = N, pos = i;

        while(Left <= Right)
        {
            int Mid = ((Left + Right) >> 1);

            if(Cost(i, Mid) <= Lim)
                pos = Mid, Left = Mid + 1;
            else Right = Mid - 1;
        }

        SUM += 1LL * Cost(i, pos);

        i = (pos + 1);
    }

    if(groups <= K)
        ans = my_min(ans, SUM);

    return (groups <= K);
}

static inline void Solve ()
{
    ll left = 0, right = INF;

    while(left <= right)
    {
        ll mid = ((left + right) >> 1LL);

        Ok(mid - 1LL), Ok(mid + 1LL);

        if(Ok(mid))
            right = mid - 1LL;
        else left = mid + 1LL;
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
