#include <iostream>
#include <cstdio>

using namespace std;

using ll = long long;

const int NMAX = 1e5 + 5;
const ll INF =  1LL * 1e18;

int N, K, X;

ll sp[NMAX];

ll dp[NMAX][2];

namespace InParser
{
static const int BSIZE = (1 << 16);

static int pos = (BSIZE - 1);
static char buff[BSIZE];

static inline char Char ()
{
    ++pos;

    if(pos == BSIZE)
    {
        pos = 0;

        int n = fread(buff, 1, BSIZE, stdin);

        if(n != BSIZE)
            for(int i = n; i < BSIZE; ++i)
                buff[i] = 0;
    }

    return buff[pos];
}

inline int Int ()
{
    int ans = 0;

    for( ; ; )
    {
        char Ch = Char();

        if(Ch >= '0' && Ch <= '9')
        {
            ans = (int)(Ch - '0');

            break;
        }
    }

    for( ; ; )
    {
        char Ch = Char();

        if(Ch >= '0' && Ch <= '9')
            ans = ans * 10 + (int)(Ch - '0');
        else break;
    }

    return ans;
}
};

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    N = InParser :: Int(), K = InParser :: Int();

    for(int i = 1; i <= N; ++i)
        X = InParser :: Int(), sp[i] = sp[(i - 1)] + 1LL * X;

    return;
}

static inline ll Sum (int Left, int Right)
{
    if(Left > Right)
        return 0LL;

    return sp[Right] - sp[(Left - 1)];
}

static inline ll Cost (int Left, int Right)
{
    if(Left > Right)
        return 0LL;

    int cnt = (Right - Left + 1);

    return 1LL * (cnt - 1LL) * Sum(Left, Right);
}

static inline void Initialize ()
{
    for(int i = 1; i <= N; ++i)
        dp[i][1] = Cost(1, i);

    return;
}

static inline int my_min (int a, int b)
{
    return ((a < b) ? a : b);
}

static inline void Go (int Left, int Right, int chosen_Left, int chosen_Right, int Level)
{
    if(Left > Right)
        return;

    int Mid = ((Left + Right) >> 1);

    dp[Mid][(Level & 1)] = INF;
    int chosen = -1;

    for(int ind = chosen_Left; ind <= my_min(Mid, chosen_Right); ++ind)
    {
        ll Val = dp[ind - 1][((Level - 1) & 1)] + Cost(ind, Mid);

        if(Val < dp[Mid][(Level & 1)])
            dp[Mid][(Level & 1)] = Val, chosen = ind;
    }

    Go(Left, Mid - 1, chosen_Left, chosen, Level);
    Go(Mid + 1, Right, chosen, chosen_Right, Level);

    return;
}

static inline void Solve ()
{
    Initialize();

    for(int j = 2; j <= K; ++j)
        Go(j, N, j, N, j);

    printf("%lld\n", dp[N][(K & 1)]);

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}