#include <iostream>
#include <unordered_map>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e5 + 5;

int N, W, H;

PII A[NMAX];

unordered_map < int, bool > fr_X;

int List[NMAX];

int Aux[NMAX], V[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> W >> H;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].first >> A[i].second, fr_X[A[i].first] = 1;

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Task_1 ()
{
    int ans = 0;

    for(auto it : fr_X)
    {
        int X1  = it.first, X2 = X1 + W;

        List[0] = 0;

        for(int i = 1; i <= N; ++i)
            if(A[i].first >= X1 && A[i].first <= X2)
                List[++List[0]] = A[i].second;

        sort(List + 1, List + List[0] + 1);

        for(int j = 1; j <= List[0]; ++j)
        {
            int Left = j + 1, Right = List[0], pos = j;

            while(Left <= Right)
            {
                int Mid = ((Left + Right) >> 1);

                if(List[Mid] - List[j] <= H)
                    pos = Mid, Left = Mid + 1;
                else Right = Mid - 1;
            }

            ans = my_max(ans, pos - j + 1);
        }
    }

    cout << ans << '\n';

    return;
}

static inline void Normalize_Oy ()
{
    for(int i = 1; i <= N; ++i)
        Aux[i] = A[i].second;

    sort(Aux + 1, Aux + N + 1);

    V[++V[0]] = Aux[1];

    for(int i = 2; i <= N; ++i)
        if(Aux[i] != Aux[i - 1])
            V[++V[0]] = Aux[i];

    return;
}

class FenwickTree
{
    int A[NMAX];

private:
    static inline int UB (int X)
    {
        return (X & (-X));
    }

    inline int Query (int pos)
    {
        if(pos < 1)
            return 0;

        int ans = 0;

        for(int i = pos; i >= 1; i -= UB(i))
            ans += A[i];

        return ans;
    }

public:
    inline void Update (int pos, int Val)
    {
        for(int i = pos; i <= V[0]; i += UB(i))
            A[i] += Val;

        return;
    }

    inline int Find_Number (int Left, int Right)
    {
        if(Left > Right)
            return 0;

        return Query(Right) - Query(Left - 1);
    }
} AIB;

static inline void Task_2 ()
{
    int ans = 0;

    sort(A + 1, A + N + 1);

    Normalize_Oy();

    int j = 1;

    for(int i = 1; i <= N; ++i)
    {
        while(j <= N && A[i].first - A[j].first > W)
            AIB.Update((int)(lower_bound(V + 1, V + V[0] + 1, A[j].second) - V), -1), ++j;

        AIB.Update((int)(lower_bound(V + 1, V + V[0] + 1, A[i].second) - V), +1);

        int Now_we_have = (int)(lower_bound(V + 1, V + V[0] + 1, A[i].second) - V);

        int Left = 1, Right = Now_we_have - 1, pos = Now_we_have;

        while(Left <= Right)
        {
            int Mid = ((Left + Right) >> 1);

            if(A[i].second - V[Mid] <= H)
                pos = Mid, Right = Mid - 1;
            else Left = Mid + 1;
        }

        ans = my_max(ans, AIB.Find_Number(pos, Now_we_have));
    }

    return;
}

static inline void Solve ()
{
    if(N <= 1e3)
        Task_1();
    else Task_2();

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
