#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e5 + 5;

int N, W, H;

PII A[NMAX];

int Aux[NMAX], V[NMAX];

namespace InParser
{
static const int BSIZE = (1 << 16);

static int pos = (BSIZE - 1);
static char buff[BSIZE];

static inline char Char ()
{
    ++pos;

    if(pos == BSIZE)
    {
        pos = 0;

        int n = fread(buff, 1, BSIZE, stdin);

        if(n != BSIZE)
            for(int i = n; i < BSIZE; ++i)
                buff[i] = 0;
    }

    return buff[pos];
}

inline int Int ()
{
    int ans = 0;

    for( ; ; )
    {
        char Ch = Char();

        if(Ch >= '0' && Ch <= '9')
        {
            ans = (int)(Ch - '0');

            break;
        }
    }

    for( ; ; )
    {
        char Ch = Char();

        if(Ch >= '0' && Ch <= '9')
            ans = ans * 10 + (int)(Ch - '0');
        else break;
    }

    return ans;
}
};

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    N = InParser :: Int(), W = InParser :: Int(), H = InParser :: Int();

    for(int i = 1; i <= N; ++i)
        A[i] = {InParser :: Int(), InParser :: Int()};

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Normalize_Oy ()
{
    for(int i = 1; i <= N; ++i)
        Aux[i] = A[i].second;

    sort(Aux + 1, Aux + N + 1);

    V[++V[0]] = Aux[1];

    for(int i = 2; i <= N; ++i)
        if(Aux[i] != Aux[i - 1])
            V[++V[0]] = Aux[i];

    return;
}

class SegmentTree
{
    int A[(NMAX << 2)];
    int Lazy[(NMAX << 2)];

private:
    inline void Go (int Node, int a, int b)
    {
        if(a == b)
            return;

        if(!Lazy[Node])
            return;

        A[(Node << 1)] += Lazy[Node];
        A[((Node << 1) + 1)] += Lazy[Node];

        Lazy[(Node << 1)] += Lazy[Node];
        Lazy[((Node << 1) + 1)] += Lazy[Node];

        Lazy[Node] = 0;

        return;
    }

public:
    inline void Update (int Node, int a, int b, int ua, int ub, int Val)
    {
        if(ua <= a && b <= ub)
        {
            A[Node] += Val;

            Lazy[Node] += Val;

            return;
        }

        Go(Node, a, b);

        int Mid = ((a + b) >> 1);

        if(ua <= Mid)
            Update((Node << 1), a, Mid, ua, ub, Val);

        if(ub > Mid)
            Update(((Node << 1) + 1), Mid + 1, b, ua, ub, Val);

        A[Node] = my_max(A[(Node << 1)], A[((Node << 1) + 1)]);

        return;
    }

    inline int Query (int Node, int a, int b, int qa, int qb)
    {
        if(qa <= a && b <= qb)
            return A[Node];

        Go(Node, a, b);

        int Mid = ((a + b) >> 1);
        int p_Left = 0, p_Right = 0;

        if(qa <= Mid)
            p_Left = Query((Node << 1), a, Mid, qa, qb);

        if(qb > Mid)
            p_Right = Query(((Node << 1) + 1), Mid + 1, b, qa, qb);

        return my_max(p_Left, p_Right);
    }
} AINT;

static inline void Do_Update (int Y, int Val)
{
    int Now_we_have = (int)(lower_bound(V + 1, V + V[0] + 1, Y) - V);
    int pos_1 = Now_we_have, pos_2 = Now_we_have;

    int Left = 1, Right = Now_we_have - 1;

    while(Left <= Right)
    {
        int Mid = ((Left + Right) >> 1);

        if(Y - V[Mid] <= H)
            pos_1 = Mid, Right = Mid - 1;
        else Left = Mid + 1;
    }

    Left = Now_we_have + 1, Right = V[0];

    while(Left <= Right)
    {
        int Mid = ((Left + Right) >> 1);

        if((V[Mid] + H) - Y <= H)
            pos_2 = Mid, Left = Mid + 1;
        else Right = Mid - 1;
    }

    AINT.Update(1, 1, V[0], pos_1, pos_2, Val);

    return;
}

static inline void Solve ()
{
    int ans = 0;

    sort(A + 1, A + N + 1);

    Normalize_Oy();

    int j = 1;

    for(int i = 1; i <= N; ++i)
    {
        while(j <= N && A[i].first - A[j].first > W)
            Do_Update(A[j].second, -1), ++j;

        Do_Update(A[i].second, +1);

        ans = my_max(ans, AINT.Query(1, 1, V[0], 1, V[0]));
    }

    printf("%d\n", ans);

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
