#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 444;

int tree[4 * N];
int push[4 * N];

void Push(int V)
{
    tree[2 * V + 1] += push[V];
    push[2 * V + 1] += push[V];
    tree[2 * V + 2] += push[V];
    push[2 * V + 2] += push[V];
    push[V] = 0;
}

void Add(int l, int r, int x, int L = 0, int R = N, int V = 0)
{
    if (r <= L || R <= l) return;
    if (l <= L && R <= r)
    {
        tree[V] += x;
        push[V] += x;
        return;
    }
    int M = (L + R) / 2;
    Push(V);
    Add(l, r, x, L, M, 2 * V + 1);
    Add(l, r, x, M, R, 2 * V + 2);
    tree[V] = max(tree[2 * V + 1], tree[2 * V + 2]);
}

int Get()
{
    return tree[0];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, w, h;
    cin >> n >> w >> h;
    struct q{
        int L, R;
        int x;
        int t;
    };
    vector<q> asks;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        asks.push_back({x, x + w, 1, y});
        asks.push_back({x, x + w, -1, y + h + 1});
    }
    sort(asks.begin(), asks.end(), [&](q A, q B)
         {
             if (A.t == B.t) return A.x < B.x;
             return A.t < B.t;
         });
    int ans = 0;
    for (auto e : asks)
    {
        Add(e.L, e.R + 1, e.x);
        ans = max(ans, Get());
    }
    cout << ans;
}
