#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const ll Inf = 1e18;

ll smart(int n, int k, vector <int> a) {
  vector <ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }

  auto get = [&] (ll x) {
    vector <ll> dp(n + 1, Inf);
    vector <int> go(n + 1, 0);
    dp[0] = 0;
    vector <pair <int, int>> st;
    st.push_back({0, 0});
    auto get_cost = [&] (int from, int to) {
      return dp[from] + (pref[to] - pref[from]) * (to - from - 1) + x;
    };

    for (int i = 1; i <= n; ++i) {
      auto it = upper_bound(st.begin(), st.end(), make_pair(i, n + 1));
      dp[i] = get_cost(prev(it)->second, i);
      go[i] = prev(it)->second;
      while (!st.empty() && i < st.back().first && get_cost(i, st.back().first) < get_cost(st.back().second, st.back().first)) {
        st.pop_back();
      }
      int l = max(i, st.back().first);
      int r = n + 1;
      while (r - l > 1) {
        int m = (l + r) >> 1;
        if (get_cost(i, m) < get_cost(st.back().second, m)) r = m;
        else l = m;
      }
      if (r <= n) st.push_back({r, i});
    }
    /*for (auto p : st) {
      cout << p.first << ' ' << p.second << endl;
    }
    for (int i = 0; i <= n; ++i) cout << dp[i] << ' ';
    cout << endl;*/
    ll cost = dp[n]; 
    int cnt = 0;
    int id = n;
    while (id != 0) {
      ++cnt;
      id = go[id];
    }
    return make_pair(cost, cnt);
  };  
  ll l = -1, r = 1e13;
  while (r - l > 1) {
    ll m = (l + r) / 2;
    if (get(m).second > k) l = m;
    else r = m;
  }
  return get(r).first - r * k;
}

ll stupid(int n, int k, vector <int> a) {
  vector <ll> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }

  auto get = [&] (ll x) {
    vector <ll> dp(n + 1, Inf);
    vector <int> go(n + 1, 0);
    dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
      for (int j = 0; j < i; ++j) {
        ll cur = dp[j] + (pref[i] - pref[j]) * (i - j - 1) + x;
        if (cur < dp[i]) {
          dp[i] = cur;
          go[i] = j;
        }
      }
    }
    ll cost = dp[n]; 
    int cnt = 0;
    int id = n;
    while (id != 0) {
      ++cnt;
      id = go[id];
    }
    return make_pair(cost, cnt);
  };  

  ll l = -1, r = 1e13;
  while (r - l > 1) {
    ll m = (l + r) / 2;
    if (get(m).second > k) l = m;
    else r = m;
  }
  return get(r).first - r * k;
}
 
mt19937 rnd(123);

void stress() {
  for (int tt = 0; tt < 1000; ++tt) {
    int n = rnd() % 10 + 1;
    int k = rnd() % n + 1;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
      a[i] = rnd() % 10 + 1;
    }
    ll sm = smart(n, k, a);
    ll st = stupid(n, k, a);
    if (sm != st) {
      cout << n << ' ' << k << endl;
      for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
      }
      cout << endl;
      cout << sm << ' ' << st << endl;
      exit(0);
    }
    if ((tt + 1) % 10 == 0) {
      cout << tt + 1 << endl;
    }
  }
}
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, k;
  cin >> n >> k;
  vector <int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  /*cout << stupid(n, k, a) << endl;
  return 0;*/
  cout << smart(n, k, a) << '\n';
}
