#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const int N = 1e5 + 7;

int t[4 * N];
int mod[4 * N];

void update(int v, int x) {
  t[v] += x;
  mod[v] += x;
}

void push(int v) {
  if (mod[v]) {
    update(2 * v + 1, mod[v]);
    update(2 * v + 2, mod[v]);
    mod[v] = 0;
  }
}

void modify(int ql, int qr, int x, int l, int r, int v) {
  if (qr < l || r < ql) return;
  if (ql <= l && r <= qr) {
    update(v, x);
  } else {
    push(v);
    int m = (l + r) >> 1;
    modify(ql, qr, x, l, m, 2 * v + 1);
    modify(ql, qr, x, m + 1, r, 2 * v + 2);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
  }
}
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n, w, h;
  cin >> n >> w >> h;
  vector <pair <int, int>> pt(n);
  for (int i = 0; i < n; ++i) {
    cin >> pt[i].first >> pt[i].second;
  }
  vector <int> ys;
  for (int i = 0; i < n; ++i) {
    ys.push_back(pt[i].second);
  }
  sort(ys.begin(), ys.end());
  ys.resize(unique(ys.begin(), ys.end()) - ys.begin());
  vector <int> go((int)ys.size());
  int uk = 0;
  for (int i = 0; i < (int)ys.size(); ++i) {
    while (ys[i] - ys[uk] > h) ++uk;
    go[i] = uk;
  }
  sort(pt.begin(), pt.end());
  vector <int> where(n);
  for (int i = 0; i < n; ++i) {
    where[i] = lower_bound(ys.begin(), ys.end(), pt[i].second) - ys.begin();
  }
  uk = 0;
  int ans = 0;
  for (int i = 0; i < n; ++i) {
    int y = where[i];
    modify(go[y], y, 1, 0, n - 1, 0);
    while (pt[i].first - pt[uk].first > w) {
      y = where[uk];
      modify(go[y], y, -1, 0, n - 1, 0);
      ++uk;
    } 
    ans = max(ans, t[0]);
  }
  cout << ans << '\n';
}
