﻿#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <iomanip>
#include <cmath>
#include <regex>
#include <string>

using namespace std;

int n;
long long w, h;

struct point {
	long long x, y;
};

vector <point> points;

vector <long long> px;
vector <long long> py;

map <long long, vector <long long >> pxy;

int maxindx(long long ogr) {
	int left = 0, right = n, mid;
	while (right - left > 1) {
		mid = (right + left) / 2;
		if (px[mid] > ogr)
			right = mid;
		else
			left = mid;
	}
	return left;
}

int maxindy(long long ogr, int ind1, int ind2) {
	int left = ind2 - 1, right = pxy[ind1].size(), mid;
	while (right - left > 1) {
		mid = (right + left) / 2;
		if (pxy[ind1][mid] > ogr)
			right = mid;
		else {
			left = mid;
		}
	}
	return left;
}

int minindy(long long ogr, int ind1) {
	int left = -1, right = pxy[ind1].size(), mid;
	while (right - left > 1) {
		mid = (right + left) / 2;
		if (pxy[ind1][mid] >= ogr)
			right = mid;
		else {
			left = mid;
		}
	}
	return right;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	cin >> w >> h;
	point point1;
	for (int i = 0; i < n; ++i) {
		cin >> point1.x >> point1.y;
		points.push_back(point1);
		pxy[point1.x].push_back(point1.y);
		px.push_back(point1.x);
		py.push_back(point1.y);
	}
	for (auto& el : pxy) {
		sort(el.second.begin(), el.second.end());
	}
	sort(px.begin(), px.end());
	int maximum = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			int this_count = 0;
			long long minx, maxx;
			minx = i;
			maxx = maxindx(minx + w);
			for (long long xx = minx; xx <= maxx; ++xx) {
				int miny, maxy;
				miny = minindy(py[j], px[xx]);
				maxy = maxindy(py[j] + h, px[xx], miny);
				this_count += maxy - miny + 1;
			}
			if (this_count > maximum) {
				maximum = this_count;
			}
		}
	}
	cout << maximum;
}