#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e5 + 7;
int n;
int l1;
int l2;
int sz;
int x[N];
int y[N];

struct T {
  int x;
  int y;
  int my;
};

bool operator < (T a, T b) {
  if (a.x != b.x) {
    return a.x < b.x;
  } else {
    return a.y < b.y;
  }
}


vector<int> doary;
int down[N];
int tree[4 * N];
int lazy[4 * N];

void push(int v, int tl, int tr) {
  if (lazy[v]) {
    tree[v] += lazy[v];
    if (tl < tr) {
      lazy[2 * v] += lazy[v];
      lazy[2 * v + 1] += lazy[v];
    }
    lazy[v] = 0;
  }
}

void add(int v, int tl, int tr, int l, int r, int x) {
  push(v, tl, tr);
  if (tr < l || r < tl) {
    return;
  }
  if (l <= tl && tr <= r) {
    lazy[v] += x;
    push(v, tl, tr);
  } else {
    int tm = (tl + tr) / 2;
    add(2 * v, tl, tm, l, r, x);
    add(2 * v + 1, tm + 1, tr, l, r, x);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
  }
}

int mx() {
  push(1, 1, sz);
  return tree[1];
}

void upd(int my, int val) {
  int l = my, r = sz, last = my - 1;
  while (l <= r) {
    int j = (l + r) / 2;
    if (down[j] <= my) {
      last = j;
      l = j + 1;
    } else {
      r = j - 1;
    }
  }
  if (my <= last) {
    add(1, 1, sz, my, last, val);
  }
}



int solve() {
  map<int, int> memo;
  for (int i = 1; i <= n; i++) {
    memo[y[i]] = 0;
  }
  doary.push_back(-(int) 1e9);
  for (auto &it : memo) {
    doary.push_back(it.first);
    it.second = ++sz;
  }
  vector<T> v;
  for (int val = 1; val <= sz; val++) {
    int l = 0, r = val;
    down[val] = val;
    while (l <= r) {
      int m = (l + r) / 2;
      if (doary[val] - doary[m] > l2) {
        l = m + 1;
      } else {
        down[val] = m;
        r = m - 1;
      }
    }
  }
  for (int i = 1; i <= n; i++) {
    int val = memo[y[i]];
    v.push_back({x[i], y[i], val});
  }
  sort(v.begin(), v.end());
  int sol = 0;
  int j = 0;
  for (int i = 0; i < n; i++) {
    upd(v[i].my, +1);
    while (v[i].x - v[j].x > l1) {
      upd(v[j].my, -1);
      j++;
    }
    sol = max(sol, mx());
  }
  return sol;
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  ///freopen ("input", "r", stdin);

  cin >> n >> l1 >> l2;
  for (int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
  }
  cout << solve() << "\n";
}
