#define fast ios::sync_with_stdio(false); cin.tie(0);
#define foru(i, k, n) for (int i = k; i < n; i++)
#define ford(i, k, n) for (int i = k; i >= n; i--)
#define pb push_back

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<pii, int> pt;

struct S {
	int v=0;
	bool tog=0;
	S():v(0),tog(false){}
};

const int sz = 1e5;
const int segSz = 5e5;
int n, w, h, range[sz];
pii t[sz];
pt p[sz];
vector<pair<int, vector<int>>> byX;

struct seglazy {
	pii lohi[segSz];
	S seg[segSz], delta[segSz];
	void push(int i) {
		delta[2 * i].v += delta[i].v;
		delta[2 * i + 1].v += delta[i].v;
		delta[i].v = 0;
	}
	void update(int i) {
		seg[i].v = max((seg[2 * i].tog ? seg[2 * i].v + delta[2 * i].v : 0),
			(seg[2 * i + 1].tog ? seg[2 * i + 1].v + delta[2 * i + 1].v : 0));
		seg[i].tog = seg[2 * i].tog | seg[2 * i + 1].tog;
	}
	void build(int i, int l, int r) {
		lohi[i] = { l,r };
		if (l == r) {
			return;
		}
		int mid = (l + r) / 2;
		build(2 * i, l, mid);
		build(2 * i + 1, mid + 1, r);
	}
	void updateUtil(int i, int l, int r, int val) {
		if (lohi[i].first >= l && lohi[i].second <= r)delta[i].v += val;
		else if (lohi[i].second <l || lohi[i].first > r)return;
		else {
			push(i);
			updateUtil(2 * i, l, r, val);
			updateUtil(2 * i + 1, l, r, val);
			update(i);
		}
	}
	int queryUtil(int i, int l, int r) {
		if (lohi[i].first >= l && lohi[i].second <= r) {
			update(i);
			return (seg[i].tog ? seg[i].v : 0); //change to neginf
		}
		else if (lohi[i].second <l || lohi[i].first > r)return 0;
		else {
			push(i);
			int lhs = queryUtil(2 * i, l, r);
			int rhs = queryUtil(2 * i + 1, l, r);
			update(i);
			return max(lhs, rhs);
		}
	}
	void toggle(int i, int pos, bool mode) {
		if (lohi[i].first == lohi[i].second)seg[i].tog = mode;
		else if (pos > lohi[i].second || pos < lohi[i].first)return;
		else {
			push(i);
			int mid = (lohi[i].first + lohi[i].second) / 2;
			if (pos <= mid) toggle(2 * i, pos, mode);
			else toggle(2 * i + 1, pos, mode);
			update(i);
		}
	}
	void myUpdate(int l, int r, int val) { updateUtil(1, l, r, val); }
	int myQuery(int l, int r) { return queryUtil(1, l, r); }
	void myToggle(int i, bool mode) { toggle(1, i, mode); }
};


bool sortByY(const pt& lhs, const pt& rhs) {
	if (lhs.first.second != rhs.first.second)return lhs.first.second < rhs.first.second;
	else if (lhs.first.first != rhs.first.first)return lhs.first.first < rhs.first.first;
	else return lhs.second < rhs.second;
}

void initRange() {
	int l = 0, r = 0;
	while (l < n) {
		while (r < n&&p[r].first.second - p[l].first.second <= h)r++;
		range[l] = r;
		l++;
	}
}

void input() {
	cin >> n >> w >> h;
	foru(i, 0, n) {
		cin >> p[i].first.first >> p[i].first.second;
	}
	sort(p, p + n, sortByY);
	foru(i, 0, n) {
		p[i].second = i; t[i] = p[i].first;
	}
	sort(p, p + n);
	int cr = -1;
	vector<int> crv;
	foru(i, 0, n) {
		if (p[i].first.first != cr) {
			if (!crv.empty())byX.pb({ cr,crv });
			crv.clear();
			cr = p[i].first.first;
		}
		crv.pb(p[i].second);
	}
	byX.pb({ cr,crv });
	sort(p, p + n, sortByY);
	initRange();
	sort(p, p + n);
}
/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/

signed main() {
	fast;
	input();
	seglazy seg;
	seg.build(1, 0, n - 1);
	int xSize = byX.size(), l = 0, r = 0, ret = 0;
	while (l < xSize) {
		if (l > 0) {
			for (int i : byX[l].second) {
				seg.myUpdate(i, range[i] - 1, -1);
				seg.myToggle(i, 0);
			}
		}
		while (r < xSize&&byX[r].first - byX[l].first <= w) {
			for (int i : byX[r].second) {
				seg.myUpdate(i, range[i] - 1, 1);
				seg.myToggle(i, 1);
			}
			r++;
		}
		ret = max(ret, seg.myQuery(0, n - 1));
		l++;
	}
	cout << ret << '\n';
	return 0;
}