#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

const int N = 1e5 + 10;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int rx[4] = {-1, 0, 1, 0};
const int ry[4] = {0, 1, 0, -1};


mt19937 gen(time(0));

struct segtree {
    vector <int> t;
    int nw;

    segtree (int n) {
        nw = (1 << (32 - __builtin_clz(n) - (__builtin_popcount(n) == 1)));
        t.resize(nw << 1);
    }

    void modify(int v, int cl, int cr, int pos, int val) {
        if (cr - cl == 1) {
            t[v] += val;
            return;
        }
        int mid = (cl + cr) / 2;
        if (pos < mid) modify(v * 2, cl, mid, pos, val);
        else modify(v * 2 + 1, mid, cr, pos, val);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    void modify(int pos, int val) {
        modify(1, 1, nw + 1, pos, val);
    }

    int sum(int v, int cl, int cr, int l, int r) {
        if (cl >= l && cr <= r) return t[v];
        if (cl >= r || cr <= l) return 0;
        int mid = (cl + cr) / 2;
        return sum(v * 2, cl, mid, l, r) + sum(v * 2 + 1, mid, cr, l, r);
    }

    int sum(int l, int r) {
        return sum(1, 1, nw + 1, l, r + 1);
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, w, h;
    cin >> n >> w >> h;
    int mx = max(w, h);
    pair <int, int> cs[n];
    for (int i = 0; i < n; i++) {
        cin >> cs[i].F >> cs[i].S;
        mx = max(mx, cs[i].F);
        mx = max(mx, cs[i].S);
    }
    sort(cs, cs + n);
    if (mx > 100000) {
        multiset <int> st;
        int l = 0, ans = 0;
        for (int i = 0; i < n; i++) {
            st.insert(cs[i].S);
            while (cs[i].F - cs[l].F > w) {
                st.erase(st.find(cs[l].S));
                l ++;
            }
            int l2 = 0;
            vector <int> v;
            for (auto it : st) v.pb(it);
            for (int j = 0; j < v.size(); j++) {
                while (v[j] - v[l2] > h) l2 ++;
                ans = max(ans, j - l2 + 1);
            }
        }
        cout << ans << endl;
        return 0;
    }
    int l = 0;
    segtree sgt(100100);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        while (cs[i].F - cs[l].F > w) {
            sgt.modify(cs[l].S, -1);
            l ++;
        }
        sgt.modify(cs[i].S, 1);
        ans = max(ans, sgt.sum(max(1, cs[i].S - h), cs[i].S));
    }
    cout << ans << endl;
    return 0;
}
