#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228

const int N = 6005;
const long long INF = 1e18 + 228;

int n, k;
int a[N];
pair<long long, int> dp[N]; // min scare, if equal -> min number of blocks
long long pref[N];

// min number of blocks

pair<long long, int> getResult(long long fine) {
	for (int i = 1; i <= n; ++i) {
		dp[i] = {INF, INF};
	}
	dp[0] = {0, 0};
	for (int i = 1; i <= n; ++i) {
		dp[i] = {pref[i] * (i - 1) + fine, 1};
		for (int j = i; j >= 1; --j) {
			pair<long long, int> cur = dp[j - 1];
			++cur.second; // + 1 block
			cur.first += fine; // 1 block gets 1 fine
			cur.first += (pref[i] - pref[j - 1]) * (i - j);

			uin(dp[i], cur);
		}
	}
	// for (int i = 1; i <= n; ++i) {
	// 	cout << dp[i].first << " " << dp[i].second << endl;
	// }
	return {dp[n].first - dp[n].second * fine, dp[n].second};
}

signed main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pref[i] = pref[i - 1] + a[i];
	}

	long long low = -1, high = INF / 100000;
	while (high - low > 1) {
		long long fine = (low + high) / 2;
		pair<long long, int> res = getResult(fine);
		int number = res.second;
		if (number > k) {
			low = fine;
		} else {
			high = fine;
		}
	}
	pair<long long, int> res = getResult(high);
	cout << res.first << '\n';



	// for (int i = 1; i <= n; ++i) {
	// 	dp[i][1] = pref[i] * (i - 1);
	// 	for (int j = 2; j <= min(i, k); ++j) {
	// 		dp[i][j] = INF;
	// 		for (int t = i; t >= j; --t) {
	// 			uin(dp[i][j], (pref[i] - pref[t - 1]) * (i - t) + dp[t - 1][j - 1]);
	// 		}
	// 	}
	// }
	// cout << dp[n][k] << '\n';
	return 0;
}

/*

8 4
8 1 2 3 9 1 9 1

32

---------------------

6 3
10 3 8 5 4 7

37


*/