

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define left left228
#define right right228
#define double long double

const int N = 6005;
const long long INF = 1e18 + 228;

int n, k;
int a[N];
pair<double, int> dp[N]; // min scare, if equal -> min number of blocks
long long pref[N];

// min number of blocks

const double eps = 1e-6;

pair<double, int> getResult(double fine) {
    for (int i = 1; i <= n; ++i) {
        dp[i] = {INF, INF};
    }
    dp[0] = {0, 0};
    for (int i = 1; i <= n; ++i) {
        dp[i] = {(double)pref[i] * (i - 1) + fine, 1};
        for (int j = i; j >= 1; --j) {
            pair<double, int> cur = dp[j - 1];
            ++cur.second; // + 1 block
            cur.first += fine; // 1 block gets 1 fine
            cur.first += (pref[i] - pref[j - 1]) * (i - j);

            // uin(dp[i], cur);
            if (cur.first + eps < dp[i].first) {
                dp[i] = cur;
            } else if (abs(dp[i].first - cur.first) <= eps && cur.second < dp[i].second) {
                dp[i] = cur;
            }
        }
    }
    // for (int i = 1; i <= n; ++i) {
    //  cout << dp[i].first << " " << dp[i].second << endl;
    // }
    return {(dp[n].first - dp[n].second * fine + 0.1), dp[n].second};
}

signed main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }

    double low = -1, high = INF / 100000;
    for (int it = 0; it < 100; ++it) {
        double fine = (low + high) / 2;
        pair<double, int> res = getResult(fine);
        int number = res.second;
        if (number > k) {
            low = fine;
        } else {
            high = fine;
        }
    }

    // long long high = 3;
    // cout << "high=" << high << endl;
    // cout << setprecision(10) << "hi=" << high << endl;
    pair<double, int> res = getResult(high);
    // cout << res.first << " " << res.second << endl;
    int ans = (int)(res.first + 0.1);
    if (res.second != k) {
        ans /= 2;
    }
    cout << ans << '\n';



    // for (int i = 1; i <= n; ++i) {
    //  dp[i][1] = pref[i] * (i - 1);
    //  for (int j = 2; j <= min(i, k); ++j) {
    //      dp[i][j] = INF;
    //      for (int t = i; t >= j; --t) {
    //          uin(dp[i][j], (pref[i] - pref[t - 1]) * (i - t) + dp[t - 1][j - 1]);
    //      }
    //  }
    // }
    // cout << dp[n][k] << '\n';
    return 0;
}

/*

8 4
8 1 2 3 9 1 9 1

32

---------------------

6 3
10 3 8 5 4 7

37


*/