#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define list list228
#define double long double

const int N = 200 * 1000 + 228;

int n, w, h;
int xMax = 0, yMax = 0;
int ans = 0;

vector<int> list[N];

int cnt[N];

void add(int x, int delta) {
	for (int i = max(1, x - w); i <= x; ++i) {
		cnt[i] += delta;
	}
}

void relax() {
	for (int i = 1; i <= xMax; ++i) {
		uax(ans, cnt[i]);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		uax(xMax, x);
		uax(yMax, y);
		list[y].emplace_back(x);
	}
	for (int y = 1; y <= h + 1; ++y) {
		for (int x : list[y]) {
			add(x, 1); // add pt
		}
	}
	relax();
	for (int y = h + 2; y <= yMax; ++y) {
		for (int x : list[y - h - 1]) {
			add(x, -1); // del
		}
		for (int x : list[y]) {
			add(x, 1); // add
		}
		relax();
	}

	cout << ans << '\n';
	return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

4



10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2


*/