#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define list list228
#define double long double

const int N = 200 * 1000 + 228;

struct node
{
	int mx, mod;
	int l, r;
	node() {
		mx = mod = l = r = 0;
	}
};

vector< node > d;

void build(int l, int r, int v = 1) {
	d[v].l = l;
	d[v].r = r;
	if (l == r) {

	} else {
		int m = (l + r) >> 1;
		build(l, m, v << 1);
		build(m + 1, r, v << 1 | 1);
	}
}

int gets(int v) {
	return d[v].mx + d[v].mod;
}

void push(int v) {
	d[v << 1].mod += d[v].mod;
	d[v << 1 | 1].mod += d[v].mod;
	d[v].mod = 0;
	d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
}

void update(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) return;
	if (l <= d[v].l && d[v].r <= r) {
		d[v].mod += x;
	} else {
		push(v);
		update(l, r, x, v << 1);
		update(l, r, x, v << 1 | 1);
		d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
	}
}

void init(int n) {
	int s = 1;
	while (s < n) s <<= 1;
	s <<= 1;
	d.resize(s + 1, node());
	build(1, n);
}

int n, w, h;
int xMax = 0, yMax = 0;
int ans = 0;

vector<int> list[N];

int cnt[N];

void add(int x, int delta) {
	int l = max(1, x - w);
	update(l, x, delta);
	// for (int i = max(1, x - w); i <= x; ++i) {
		// cnt[i] += delta;
	// }
}

void relax() {
	uax(ans, gets(1));
	// return gets(1);
	// for (int i = 1; i <= xMax; ++i) {
	// 	uax(ans, cnt[i]);
	// }
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		uax(xMax, x);
		uax(yMax, y);
		list[y].emplace_back(x);
	}
	init(xMax);
	for (int y = 1; y <= h + 1; ++y) {
		for (int x : list[y]) {
			add(x, 1); // add pt
		}
	}
	relax();
	for (int y = h + 2; y <= yMax; ++y) {
		for (int x : list[y - h - 1]) {
			add(x, -1); // del
		}
		for (int x : list[y]) {
			add(x, 1); // add
		}
		relax();
	}

	cout << ans << '\n';
	return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

4



10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

7

*/