#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define left left228
#define right right228
#define list list228
#define double long double
#define all(v) v.begin(), v.end()

const int N = 200 * 1000 + 228;

struct node
{
	int mx, mod;
	int l, r;
	node() {
		mx = mod = l = r = 0;
	}
};

vector< node > d;

void build(int l, int r, int v = 1) {
	d[v].l = l;
	d[v].r = r;
	if (l == r) {

	} else {
		int m = (l + r) >> 1;
		build(l, m, v << 1);
		build(m + 1, r, v << 1 | 1);
	}
}

int gets(int v) {
	return d[v].mx + d[v].mod;
}

void push(int v) {
	d[v << 1].mod += d[v].mod;
	d[v << 1 | 1].mod += d[v].mod;
	d[v].mod = 0;
	d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
}

void update(int l, int r, int x, int v = 1) {
	if (l > r || d[v].l > r || d[v].r < l) return;
	if (l <= d[v].l && d[v].r <= r) {
		d[v].mod += x;
	} else {
		push(v);
		update(l, r, x, v << 1);
		update(l, r, x, v << 1 | 1);
		d[v].mx = max(gets(v << 1), gets(v << 1 | 1));
	}
}

void init(int n) {
	int s = 1;
	while (s < n) s <<= 1;
	s <<= 1;
	d.resize(s + 1, node());
	build(1, n);
}

int n, w, h;
int ans = 0;

vector<int> crdx, crdy;
vector<int> list[N];
int X[N], Y[N], left[N];


void add(int x, int delta) {
	update(left[x], x, delta);
}

void relax() {
	uax(ans, gets(1));
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> w >> h;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		X[i] = x;
		Y[i] = y;

		crdx.emplace_back(x);
		crdy.emplace_back(y);
	}

	{
		sort(all(crdx));
		sort(all(crdy));

		for (int i = 0; i < n; ++i) {
			X[i] = lower_bound(all(crdx), X[i]) - crdx.begin() + 1;
			Y[i] = lower_bound(all(crdy), Y[i]) - crdy.begin() + 1;
			list[Y[i]].emplace_back(X[i]);
		}
	}

	int szX = (int)crdx.size();
	int szY = (int)crdy.size();

	{
		// find left[x]

		int ptr = 1;

		for (int x = 1; x <= szX; ++x) {
			while (crdx[x - 1] - crdx[ptr - 1] > w) {
				++ptr;
			}
			left[x] = ptr;
		}
	}

	init(szX);

	int ptr = 0; // ptr who deletes byaku

	for (int y = 1; y <= szY; ++y) {
		{
			// add
			for (int x : list[y]) {
				add(x, 1);
			}
		}
		{
			// delete sb
			while (ptr + 1 < y && crdy[y - 1] - crdy[ptr + 1 - 1] > h) {
				++ptr;
				for (int x : list[ptr]) {
					add(x, -1);
				}
			}
		}

		relax();
	}

	cout << ans << '\n';
	return 0;
}

/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

4



10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2

7

*/