
/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

const int N = 1e5 + 10, MXN = 2e8 + 10;
int t[4 * N], add[4 * N];

struct node {
    node *tl, *tr;
    int val, add;
    int l, r;

    node(int l, int r) {
        this->l = l;
        this->r = r;
        val = add = 0;
        tl = tr = nullptr;
    }
};

node *root = new node(0, MXN);

void build(node *v) {
    int mid = (v->l + v->r) / 2;
    if (v->tl == nullptr)
        v->tl = new node(v->l, mid);
    if (v->tr == nullptr)
        v->tr = new node(mid, v->r);
}

void push(node *v) {
    v->val += v->add;
    if (v->l != v->r - 1) {
        build(v);
        v->tl->add += v->add;
        v->tr->add += v->add;
    }
    v->add = 0;
}

//void push(int v, int l, int r) {
//    t[v] += add[v];
//    if (l != r - 1) {
//        add[2 * v + 1] += add[v];
//        add[2 * v + 2] += add[v];
//    }
//    add[v] = 0;
//}

void update(node *v, int tl, int tr, int val) {
    push(v);
    if (tl <= v->l && v->r <= tr) {
        v->add += val;
        push(v);
        return;
    }
    if (v->l >= tr || v->r <= tl)
        return;
    int mid = (v->r + v->l) / 2;
    build(v);
    update(v->tl, tl, tr, val);
    update(v->tr, tl, tr, val);
    v->val = max(v->tl->val, v->tr->val);
}

//void update(int v, int l, int r, int tl, int tr, int val) {
//    push(v, l, r);
//    if (tl <= l && r <= tr) {
//        add[v] += val;
//        push(v, l, r);
//        return;
//    }
//    if (l >= tr || r <= tl)
//        return;
//    int mid = (r + l) / 2;
//    update(2 * v + 1, l, mid, tl, tr, val);
//    update(2 * v + 2, mid, r, tl, tr, val);
//    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
//}

int get(node *v, int tl, int tr) {
    push(v);
    if (tl <= v->l && tr >= v->r) {
        return v->val;
    }
    if (v->l >= tr || v->r <= tl)
        return 0;
    int mid = (v->r + v->l) / 2;
    build(v);
    return max(get(v->tl, tl, tr), get(v->tr, tl, tr));
}

//int get(int v, int l, int r, int tl, int tr) {
//    push(v, l, r);
//    if (tl <= l && tr >= r) {
//        return t[v];
//    }
//    if (l >= tr || r <= tl)
//        return 0;
//    int mid = (r + l) / 2;
//    return max(get(2 * v + 1, l, mid, tl, tr), get(2 * v + 2, mid, r, tl, tr));
//}

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    pair<int, int> coord[n];
    for (int i = 0; i < n; i++)
        cin >> coord[i].f >> coord[i].s;
    sort(coord, coord + n);
    vector<int> reb;
    for (int i = 0; i < n; i++) {
        reb.pb(coord[i].f);
        reb.pb(max(0LL, coord[i].f - w));
    }
    sort(reb.begin(), reb.end());
    int l = 0, r = 0, mx = 0;
    for (auto u : reb) {
        while (r != n && coord[r].f <= u + w) {
            update(root, coord[r].s, coord[r].s + h + 1, 1);
            r++;
        }
        while (l != n && coord[l].f < u) {
            update(root, coord[l].s, coord[l].s + h + 1, -1);
            l++;
        }
        mx = max(mx, get(root, 0, N));
    }
    cout << mx << endl;
}

signed main() {
    ios;
//    open("anime.in", "anime.out");
    int attempts = 1;
//    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}