#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

#define int long long

const int INF = 1e14 + 228;

namespace LOL {
    int n, K;
    vector<int> arr;
    vector<int> pref;

    int calc(int l, int r) {
        return (pref[r] - pref[l]) * (r - l - 1);
    }

    vector<int> dp;
    vector<int> dp_;

    void run(int l, int r, int pl, int pr) {
        if (r - l <= 1)
            return;
        int m = (l + r) / 2;
        dp_[m] = INF;
        int p = -1;
        for (int k = pl; k <= min(pr, m - 1); k++) {
            if (dp_[m] > dp[k] + calc(k, m)) {
                dp_[m] = dp[k] + calc(k, m);
                p = k;
            }
        }
        run(l, m, pl, p);
        run(m, r, p, pr);
    }

    void solve_dnc() {
        pref.resize(n + 1);
        for (int i = 0; i < n; i++) {
            pref[i + 1] = pref[i] + arr[i];
        }
        int cur_layer = 1;
        dp.resize(n + 1, INF);
        for (int i = 1; i <= n; i++) {
            dp[i] = calc(0, i);
        }
        dp_.resize(n + 1);
        while (cur_layer != K) {
            cur_layer++;
            run(-1, n + 1, 0, n + 1);
            swap(dp, dp_);
        }
        cout << dp.back() << endl;
    }

};


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, K;
    cin >> n >> K;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    if (K == 3) {
        LOL::n = n;
        LOL::K = K;
        LOL::arr = arr;
        LOL::solve_dnc();
        return 0;
    }
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + arr[i];
    }
    auto calc = [&](int l, int r) {
        return (pref[r] - pref[l]) * (r - l - 1);
    };
    
    vector<vector<int>> dp(2, vector<int> (n + 1, INF));
    vector<vector<int>> p(2, vector<int> (n + 1, -1));

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        dp[1][i + 1] = calc(0, i + 1);
        p[1][i + 1] = 0;
    }
    for (int j = 2; j <= K; j++) {
        vector<int>().swap(dp[j - 2]);
        vector<int>().swap(p[j - 2]);
        dp.push_back(vector<int> (n + 1, INF));
        p.push_back(vector<int> (n + 1, -1));
        for (int i = n; i >= 1; i--) {
            int right = n;
            if (i != n) {
                right = p[j][i + 1];
            }
            right = min(right, i - 1);
            for (int k = p[j - 1][i]; k <= right; k++) {
                int x = dp[j - 1][k] + calc(k, i);
                if (x < dp[j][i]) {
                    dp[j][i] = x;
                    p[j][i] = k;
                }
            }
        }
    }
    cout << dp.back().back() << endl;
}

