#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5;

int tree[4 * MAXN];
int mod[4 * MAXN];

void push(int v, int l, int r) {
    if (l + 1 != r) {
        mod[2 * v + 1] += mod[v];
        mod[2 * v + 2] += mod[v];
    }
    tree[v] += mod[v];
    mod[v] = 0;
}

void add(int v, int l, int r, int ql, int qr, int val) {
    push(v, l, r);
    if (ql >= r || qr <= l) {
        return;
    }
    if (ql <= l && r <= qr) {
        mod[v] += val;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    add(2 * v + 1, l, m, ql, qr, val);
    add(2 * v + 2, m, r, ql, qr, val);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}


void add(int l, int r, int x) {
    add(0, 0, MAXN, l, r, x);
}

int get_max() {
    push(0, 0, MAXN);
    return tree[0];
}

vector<vector<int>> evs;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, w, h;
    cin >> n >> w >> h;

    map<int, int> coord;

    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        evs.push_back({x + 1, -1, y, y + h + 1});
        coord[y] = 0;
        coord[y + h + 1] = 0;
        evs.push_back({x - w, 1, y, y + h + 1});
    }

    int cur = 0;
    for (auto &el : coord)
        el.second = cur++;
    sort(evs.begin(), evs.end());
    int ans = 0;
    for (auto &ev : evs) {
        add(coord[ev[2]], coord[ev[3]], ev[1]);
        ans = max(ans, get_max());
    }
    cout << ans << endl;
}
