#pragma GCC optimize("O3,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e5;

pair<int, int> tree[4 * MAXN];

void push(int v, int l, int r) {
    if (l + 1 != r) {
        tree[2 * v + 1].second += tree[v].second;
        tree[2 * v + 2].second += tree[v].second;
    }
    tree[v].first += tree[v].second;
    tree[v].second = 0;
}

void add(int v, int l, int r, int ql, int qr, int val) {
    push(v, l, r);
    if (ql >= r || qr <= l) {
        return;
    }
    if (ql <= l && r <= qr) {
        tree[v].second += val;
        push(v, l, r);
        return;
    }
    int m = (l + r) / 2;
    add(2 * v + 1, l, m, ql, qr, val);
    add(2 * v + 2, m, r, ql, qr, val);
    tree[v].first = max(tree[2 * v + 1].first, tree[2 * v + 2].first);
}


void add(int l, int r, int x) {
    add(0, 0, MAXN, l, r, x);
}

int get_max() {
    push(0, 0, MAXN);
    return tree[0].first;
}

vector<int> evs[MAXN];


int coord[MAXN];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, w, h;
    cin >> n >> w >> h;

    int ctop = 0;
    int etop = 0;

    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        evs[etop++] = {x + 1, -1, y, y + h + 1};
        coord[ctop++] = y;
        coord[ctop++] = y + h + 1;
        evs[etop++] = {x - w, 1, y, y + h + 1};
    }
    sort(coord, coord + ctop);
    ctop = unique(coord, coord + ctop) - coord;
    sort(evs, evs + etop);
    int ans = 0;
    for (int i = 0; i < etop; i++) {
        auto ev = evs[i];
        int l = ev[2];
        l = lower_bound(coord, coord + ctop, l) - coord;
        int r = ev[3];
        r = lower_bound(coord, coord + ctop, r) - coord;
        add(l, r, ev[1]);
        ans = max(ans, get_max());
    }
    cout << ans << endl;
}
