#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 1e18;
int arr[MAXN], pref[MAXN];
int n, k;

namespace fast
{
    array<int, 2> get(int x) {
        vector<int> dp(n + 1, 0);
        vector<int> pr(n + 1, -1);
        for (int i = 1; i <= n; ++i) {
            dp[i] = 2 * INF;
            for (int j = 0; j < i; ++j) {
                int nw = (pref[i] - pref[j]) * (i - j) + dp[j] + x;
                if (nw <= dp[i]) {
                    dp[i] = nw;
                    pr[i] = j;
                }
            }
        }
        int cnt = 0;
        int cur = n;
        while (cur != 0) {
            cnt++;
            cur = pr[cur];
        }
        return {dp[n], cnt};
    }

    int solve() {
        int l = 0, r = INF;
        auto res = fast::get(l);
        while (r - l > 1) {
            int m = (l + r) / 2;
            auto res = get(m);
            if (res[1] < k) {
                r = m;
            } else {
                l = m;
            }
        }
        res = get(l);
        return res[0] - k * l - pref[n];
    }
}

namespace slow
{
    int solve() {
        vector<vector<int>> dp(n + 1, vector<int>(k + 1, INF));
        dp[0][0] = 0;
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= k; ++j) {
                for (int x = 0; x < i; ++x) {
                    if (dp[x][j - 1] == INF) {
                        continue;
                    }
                    int nw = dp[x][j - 1] + (pref[i] - pref[x]) * (i - x);
                    if (nw <= dp[i][j]) {
                        dp[i][j] = nw;
                    }
                }
            }
        }
        return dp[n][k] - pref[n];
    }
}

main() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        pref[i + 1] = pref[i] + arr[i];
    }
    cout << fast::solve();
    return 0;
}
