#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e6;
int tree[MAXN], add[MAXN];

void pull(int v) {
    int v1 = v * 2, v2 = v * 2 + 1;
    tree[v] = max(tree[v1], tree[v2]);
}

void push(int v) {
    tree[v] += add[v];
    int v1 = v * 2, v2 = v * 2 + 1;
    add[v1] += add[v];
    add[v2] += add[v];
    add[v] = 0;
}

void update(int v, int vl, int vr, int l, int r, int val) {
    push(v);
    if (l >= vr || r <= vl) {
        return;
    }
    if (l <= vl && r >= vr) {
        add[v] += val;
        push(v);
        return;
    }
    push(v);
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, l, r, val);
    update(v * 2 + 1, vm, vr, l, r, val);
    pull(v);
}

int get(int v, int vl, int vr, int l, int r) {
    push(v);
    if (l >= vr || r <= vl) {
        return 0;
    }
    if (l <= vl && r >= vr) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    int res1 = get(v * 2, vl, vm, l, r);
    int res2 = get(v * 2 + 1, vm, vr, l, r);
    return max(res1, res2);
}

main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<array<int, 4>> q;
    vector<int> all;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        q.push_back({x, -1, y, y + h});
        q.push_back({x + w, 1, y, y + h});
        all.push_back(y);
        all.push_back(y + h);
    }
    sort(all.begin(), all.end());
    int k = unique(all.begin(), all.end()) - all.begin();
    map<int, int> mp;
    for (int i = 0; i < k; ++i) {
        mp[all[i]] = i;
    }
    for (auto &elem : q) {
        elem[2] = mp[elem[2]];
        elem[3] = mp[elem[3]];
    }
    sort(q.begin(), q.end());
    int ans = 0;
    for (auto elem : q) {
        update(1, 0, k, elem[2], elem[3] + 1, -elem[1]);
        ans = max(ans, get(1, 0, k, 0, k));
    }
    cout << ans;
    return 0;
}
