#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 10;
const int inf = 1e18 + 10;

int n, k;
int a[N];
int pdp[N];
int dp[N];
int pref[N];
int dp2[100][100];

int getsum(int l, int r)
{
	return pref[r + 1] - pref[l];
}

int f(int l, int r)
{
	if (l > r)
		return 0;

	return getsum(l, r) * (r - l);
}

void solve(int l, int r, int optl, int optr)
{
	if (l > r)
		return;

	if (optl == optr)
	{
		for (int i = l; i <= r; ++i)
			if (optl < i)
				dp[i] = min(dp[i], pdp[optl] + f(optl, i - 1));

		return;
	}

	if (l == r)
	{
		for (int i = optl; i <= optr; ++i)
			if (i < l)
				dp[l] = min(dp[l], pdp[i] + f(i, l - 1));

		return;
	}

	int mid = (l + r) / 2;

	int opt = optl;

	for (int i = optl; i <= optr; ++i)
		if (i < mid)
		{
			int val = pdp[i] + f(i, mid - 1);

			if (val < dp[mid])
			{
				dp[mid] = val;
				opt = i;
			}
		}

	solve(l, mid - 1, optl, opt);
	solve(mid + 1, r, opt, optr);
}

void solve2()
{
	for (int i = 0; i <= n; ++i)
		for (int j = 0; j <= n; ++j)
			dp2[i][j] = inf;

	dp2[0][0] = 0;

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= k; ++j)
		{
			for (int z = 0; z < i; ++z)
				dp2[i][j] = min(dp2[i][j], dp2[z][j - 1] + f(z, i - 1));
		}

	cout << dp2[n][k] << endl;
}

int check(int mnval)
{
	int res = 0;
	int l = 0;
	int cnt = 0;

	for (int i = 0; i < n; ++i)
	{
		int val = f(l, i);

		if (cnt + 1 + (n - 1 - i) == k)
		{
			res += f(l, i);
			cnt = k;
			break;
		}

		if (cnt + 1 == k)
		{
			res += f(l, n - 1);
			cnt = k;
			break;
		}

		if (val >= mnval)
		{
			l = i + 1;
			res += val;
			++cnt;
		}
	}

	return res;
}

int ternsearch()
{
	int l = 0;
	int r = 1e16;

	while (l + 5 < r)
	{
		int m1 = l + (r - l) / 3ll;
		int m2 = r - (r - l) / 3ll;
		int val1 = check(m1);
		int val2 = check(m2);

		if (val1 == val2)
		{
			l = m1;
			r = m2;
		}
		else if (val1 < val2)
			r = m2;
		else
			l = m1;
	}

	int res = inf;

	for (int i = l; i <= r; ++i)
		res = min(res, check(i));

	return res;
}

void solve3()
{
	cout << ternsearch() << endl;
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> k;

	for (int i = 0; i < n; ++i)
		cin >> a[i];

	pref[0] = 0;

	for (int i = 1; i <= n; ++i)
		pref[i] = pref[i - 1] + a[i - 1];

	if (n <= 50)
	{
		solve2();
		return 0;
	}
	else if (k >= 1000)
	{
		solve3();
		return 0;
	}

	fill(pdp, pdp + N, inf);

	for (int i = 1; i <= n; ++i)
		pdp[i] = f(0, i - 1);

	for (int i = 1; i < k; ++i)
	{
		fill(dp, dp + n + 4, inf);
		solve(1, n, 0, n);
		copy(dp, dp + n + 4, pdp);
	}


	cout << dp[n] << endl;
}