#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <utility>
#include <random>
#include <chrono>
//#define int long long
#define pii pair<int, int>
#define x first
#define y second
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC target("avx,avx2")
#define endl "\n"
#define all(a) (a.begin()), (a.end())

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;
const int B = 300;
const int MXCORD = 2e3 + 10;
const int inf = 1e18 + 10;

int n;
int w, h;
pii a[N];
int pref[MXCORD][MXCORD];
vector<int> cnv;
vector<int> ycord[N];
vector<int> t[N * 4];

void build(int tl, int tr, int v)
{
	if (tl == tr)
	{
		t[v] = move(ycord[tl]);
		return;
	}

	int mid = (tl + tr) / 2;

	build(tl, mid, v * 2);
	build(mid + 1, tr, v * 2 + 1);
	t[v].resize(t[v * 2].size() + t[v * 2 + 1].size());
	merge(all(t[v * 2]), all(t[v * 2 + 1]), t[v].begin());
}

int getpref(int v, int x)
{
	return upper_bound(all(t[v]), x) - t[v].begin() - 1;
}

int calc(int v, int l, int r)
{
	return getpref(v, r) - getpref(v, l - 1);
}

int get(int tl, int tr, int v, int lx, int rx, int ly, int ry)
{
	if (tl > rx || tr < lx)
		return 0;

	if (tl >= lx && tr <= rx)
		return calc(v, ly, ry);

	int mid = (tl + tr) / 2;

	return get(tl, mid, v * 2, lx, rx, ly, ry) + get(mid + 1, tr, v * 2 + 1, lx, rx, ly, ry);
}


int sum(int x1, int y1, int x2, int y2)
{
	return pref[x2][y2] - pref[x1 - 1][y2] - pref[x2][y1 - 1] + pref[x1 - 1][y1 - 1];
}

int getid(int x)
{
	auto it = lower_bound(all(cnv), x);

	if (it != cnv.end() && it != cnv.begin() && *it > x)
		--it;

	return it - cnv.begin() + 1;
}

void group2()
{
	int ans = 0;

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			ans = max(ans, sum(a[i].x, a[j].y, getid(cnv[a[i].x - 1] + w), getid(cnv[a[j].y - 1] + h)));

	cout << ans << endl;
}

void group45()
{
	int ans = 0;

	for (int i = 0; i < n; ++i)
		ans = max(ans, get(1, cnv.size() + 1, 1, getid(cnv[a[i].x - 1] - w), a[i].x, getid(cnv[a[i].y - 1] - h), a[i].y));

	cout << ans << endl;
}

void squeeze()
{
	cnv.reserve(n * 2);

	for (int i = 0; i < n; ++i)
	{
		cnv.push_back(a[i].x);
		cnv.push_back(a[i].y);
	}

	sort(all(cnv));
	cnv.resize(unique(all(cnv)) - cnv.begin());

	for (int i = 0; i < n; ++i)
	{
		a[i].x = getid(a[i].x);
		a[i].y = getid(a[i].y);
	}
}

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> w >> h;

	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;

	squeeze();

	for (int i = 0; i < MXCORD; ++i)
		for (int j = 0; j < MXCORD; ++j)
			pref[i][j] = 0;

	for (int i = 0; i < n; ++i)
		++pref[a[i].x][a[i].y];

	for (int i = 0; i < n; ++i)
		ycord[a[i].x].push_back(a[i].y);

	for (int i = 0; i < N; ++i)
		sort(all(ycord[i]));

	build(1, cnv.size() + 1, 1);

	for (int i = 1; i < MXCORD; ++i)
		for (int j = 1; j < MXCORD; ++j)
			pref[i][j] = pref[i][j] + pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];

	if (n <= 1010)
		group2();
	else
		group45();
}