#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
const int N = 1e5;
vector <int> v[1 + N];
int t;
int get (vector <int> &v, int x) {
    int lb = 0, rb = v.size () - 1, best = -1;
    while (lb <= rb) {
        int mid = (lb + rb) / 2;
        if (v[mid] <= x)
            best = mid, lb = mid + 1;
        else
            rb = mid - 1;
    }
    return best + 1;
}
struct SegTree2D {
    int n;
    vector <vector <int>> seg;
    SegTree2D (int n) {
        this->n = n;
        seg.resize (4 * n + 1);
    }
    vector <int> join (vector <int> &l, vector <int> &r) {
        int li = 0, ri = 0;
        vector <int> ans (l.size () + r.size ());
        t++;
        int i = 0;
        while (li < l.size () && ri < r.size ()) {
            if (l[li] < r[ri])
                ans[i] = l[li], li++;
            else
                ans[i] = r[ri], ri++;
            i++;
        }
        while (li < l.size ())
            ans[i] = l[li], li++, i++;
        while (ri < r.size ())
            ans[i] = r[ri], ri++, i++;
        return ans;
    }
    void build (int node, int lb, int rb) {
        if (lb == rb) {
            seg[node] = v[lb];
            return;
        }
        int mid = (lb + rb) / 2;
        build (node * 2, lb, mid);
        build (node * 2 + 1, mid + 1, rb);
        seg[node] = join (seg[node * 2], seg[node * 2 + 1]);

    }
    int query (int node, int lb, int rb, int x1, int y1, int x2, int y2) {
        if (y1 <= lb && rb <= y2) {
            int diff = get (seg[node], x2) - get (seg[node], x1 - 1);
            return diff;
        }
        int mid = (lb + rb) / 2;
        int ans = 0;
        if (mid >= y1)
            ans += query (node * 2, lb, mid, x1, y1, x2, y2);
        if (mid + 1 <= y2)
            ans += query (node * 2 + 1, mid + 1, rb, x1, y1, x2, y2);
        return ans;
    }
};
vector <pair <int, int>> points;
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie (0);
    int n, w, h;
    cin >> n >> w >> h;
    int mX = 0, mY = 0;
    map <int, int> norm;
    vector <int> vy;
    for (int i = 1; i <= n; i++) {
        int x, y;
        cin >> x >> y;
        x++, y++;
        norm[y];
        points.pb ({x, y});
        vy.pb (y);
    }
    int nr = 0;
    for (auto &x : norm)
        x.second = ++nr;
    for (auto &p : points) {
        int x = p.first;
        int y = p.second;
        mX = max (mX, x);
        int ny = norm[y];
        mY = max (mY, ny);
        v[ny].pb (x);
    }

    SegTree2D grid (mY);

    for (int i = 1; i <= mY; i++) {
        sort (v[i].begin (), v[i].end ());
    }
    grid.build (1, 1, mY);

    if (n <= 1000) {
        vector <pair <int, int>> newpoints;
        for (auto p1 : points) {
            for (auto p2 : points) {
                newpoints.pb({max (p1.first, p2.first), max (p1.second, p2.second)});
            }
        }
        points = newpoints;
    }
    int ans = 0;
    for (pair <int, int> p : points) {
        int x = p.first;
        int y = p.second;
        int yy = max (1, y - h);
        int ny1 = get (vy, yy) + 1;
        int nr = grid.query (1, 1, mY, max (1, x - w), ny1, x, norm[y]);
        //dbg (nr);
        ans = max (ans, nr);
    }
    cout << ans << "\n";
    return 0;
}
