#include <iostream>
#include <cstdio>

#define double long double

using namespace std;

const int MAX_N = 6001;

int a[MAX_N];
long long sp[MAX_N];

double dp[MAX_N];
int cnt[MAX_N];

int n;

double compute_dp(int i, int j) {
    return dp[j] + (sp[i] - sp[j]) * (i - j - 1);
}

pair<int, long long> solve(double d) {
    for (int i = 1; i <= n; i++) {
        dp[i] = compute_dp(i, 0);
        cnt[i] = 1;
        for (int j = 1; j < i; j++) {
            double c = compute_dp(i, j);
            if (c < dp[i]) {
                dp[i] = compute_dp(i, j);
                cnt[i] = cnt[j] + 1;
            }
        }
        dp[i] += d;
    }
    return {cnt[n], dp[n] - d * cnt[n] + 0.5};
}

int main() {
//    freopen("input.txt", "r", stdin);


    int k;
    cin >> n >> k;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        sp[i] = sp[i - 1] + a[i];
    }

    if (k == n) {
        cout << 0 << endl;
        return 0;
    } if (k == 1) {
        cout << (long long)compute_dp(n, 0) << endl;
        return 0;
    }

    if (solve(0).first != n || solve(1e15).first != 1)
        return 1 / 0;

    double delta = 0;
    pair<int, long long> ans;
    for (double pas = 1e15; delta + pas != delta; pas *= 0.5) {
        pair<int, long long> x = solve(delta + pas);
        if (x.first == k) {
            cout << x.second;
            return 0;
        } else if (x.first > k)
            delta += pas;
        else
            ans = x;
    }

    if (ans.first != k - 1)
        cout << ans.second;

    return 0;
}
