#include <iostream>
#include <algorithm>
#include <set>

using namespace std;

const int MAX_N = 1e5;
pair<int, int> p[MAX_N];
int y_sorted[MAX_N];

int aint[4 * MAX_N];
int lazy[4 * MAX_N];


void propag(int n, int st, int dr) {
    if (st != dr && lazy[n]) {
        aint[n * 2 + 1] += lazy[n];
        lazy[n * 2 + 1] += lazy[n];
        aint[n * 2 + 2] += lazy[n];
        lazy[n * 2 + 2] += lazy[n];
    }
    lazy[n] = 0;
}

void update(int st, int dr, int val, int n, int nst, int ndr) {
    propag(n, nst, ndr);

    if (st == nst && dr == ndr) {
        lazy[n] += val;
        aint[n] += val;
        return;
    }

    int mid = (nst + ndr) / 2;
    if (st <= mid)
        update(st, min(dr, mid), val, n * 2 + 1, nst, mid);
    if (dr > mid)
        update(max(st, mid + 1), dr, val, n * 2 + 2, mid + 1, ndr);
    aint[n] = max(aint[n * 2 + 1], aint[n * 2 + 2]);
}

int query(int st, int dr, int n, int nst, int ndr) {
    propag(n, nst, ndr);

    if (st == nst && dr == ndr)
        return aint[n];

    int mid = (nst + ndr) / 2;
    int ans = 0;
    if (st <= mid)
        ans = max(ans, query(st, min(dr, mid), n * 2 + 1, nst, mid));
    if (dr > mid)
        ans = max(ans, query(max(st, mid + 1), dr, n * 2 + 2, mid + 1, ndr));
    return ans;
}

int n;

int norm(int x) {
    int y = -1;
    for (int pas = (1 << 20); pas > 0; pas >>= 1)
        if (y + pas < n - 1 && y_sorted[y + pas] < x)
            y += pas;
    return y + 1;
}

int main() {
    int w, h;
    cin >> n >> w >> h;

    set<int> yset;
    for (int i = 0; i < n; i++) {
        cin >> p[i].first >> p[i].second;
        yset.insert(p[i].second);
    }

    int cnt = 0;
    for (int y : yset)
        y_sorted[cnt++] = y;

    sort(p, p + n);

    int j = 0;
    while (j < n && p[j].first - p[0].first <= w) {
        update(norm(p[j].second - h), norm(p[j].second), +1, 0, 0, n);
        j++;
    }
    int ans = aint[0];
    for (int i = 1; i <= n; i++) {
        update(norm(p[i - 1].second - h), norm(p[i - 1].second), -1, 0, 0, n);
        while (j < n && p[j].first - p[i].first <= w) {
            update(norm(p[j].second - h), norm(p[j].second), +1, 0, 0, n);
            j++;
        }
        ans = max(ans, aint[0]);
    }

    cout << ans;

    return 0;
}
