#include <iostream>
#include <algorithm>
#define fi first
#define se second
using namespace std;

const int MAXN = 100005;
const int MAXH = 100005;

int n, w, h;
pair<int, int> p[MAXN];

int tree[MAXH * 4];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> w >> h;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> p[i].fi >> p[i].se;
    }

    sort(p + 1, p + n + 1);
}

int upd_pos, delta;
void update(int v = 1, int l = 1, int r = MAXH)
{
    if (l == upd_pos and r == upd_pos)
    {
        tree[v] += delta;
        return;
    }

    int mid = (l + r) >> 1;
    if (upd_pos <= mid) update(v << 1 | 0, l, mid + 0);
    else update(v << 1 | 1, mid + 1, r);

    tree[v] = tree[v << 1 | 0] + tree[v << 1 | 1];
}

int int_l, int_r;
int query(int v = 1, int l = 1, int r = MAXH)
{
    if (int_r < l or int_l > r) return 0;
    if (int_l <= l and r <= int_r) return tree[v];

    int mid = (l + r) >> 1;
    return query(v << 1 | 0, l, mid + 0) + query(v << 1 | 1, mid + 1, r);
}

void Solve()
{
    int ans = 0;
    int add = 0, rem = 0;

    int Xmax = p[1].fi;
    while (true)
    {
       // cout << add << ' ' << rem << endl;
        if (p[rem + 1].fi < Xmax - w)
        {
            rem++;
            delta = -1;
            upd_pos = p[rem].se;
            update();
            continue;
        }

        if (add + 1 > n or p[add + 1].fi != Xmax)
        {
            for (int i = add; i >= 1; -- i)
            {
                if (p[i].fi != Xmax) break;
                if (p[i].se < h) break;
                int_r = p[i].se;
                int_l = p[i].se - h;
                ans = max(ans, query());
            }

            if (add + 1 > n) break;
            Xmax = p[add + 1].fi; // mark the next point for adding
            continue;
        }

        if (p[add + 1].fi == Xmax)
        {
            add++;
            delta = +1;
            upd_pos = p[add].se;
            update();
            continue;
        }
    }

    cout << ans << endl;
}

int main()
{
    Init();
    Solve();

}
