#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#define fi first
#define se second
using namespace std;

const int MAXN = 100005;
const int MAXH = 100000008;

int n, w, h;
pair<int, int> p[MAXN];

struct node
{
    int lazy, maxv;
};

node tree[MAXN * 4];
vector<int> cmpry;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    set<int> Ys;
    cin >> n >> w >> h;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> p[i].fi >> p[i].se;
        Ys.insert(p[i].se);
    }
    sort(p + 1, p + n + 1);
    for (int Y : Ys)
    {
        cmpry.push_back(Y);
        //cout << Y << ' ';
    }
   // cout << endl;
}

void clear_lazy(int v, int l, int r)
{
    if (tree[v].lazy != 0)
    {
        tree[v].maxv += tree[v].lazy;
        if (l != r)
        {
            tree[v << 1 | 0].lazy += tree[v].lazy;
            tree[v << 1 | 1].lazy += tree[v].lazy;
        }
        tree[v].lazy = 0;
    }
}

int upd_l, upd_r, delta;
void update(int v = 1, int l = 0, int r = cmpry.size() - 1)
{
    clear_lazy(v, l, r);

    if (upd_l > upd_r) return;
    if (r < upd_l or l > upd_r) return;
    if (upd_l <= l and r <= upd_r)
    {
        tree[v].lazy += delta;
        clear_lazy(v, l, r);
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1 | 0, l, mid + 0);
    update(v << 1 | 1, mid + 1, r);

    tree[v].maxv = max(tree[v << 1 | 0].maxv, tree[v << 1 | 1].maxv);
}

int int_l, int_r;
int query(int v = 1, int l = 0, int r = cmpry.size() - 1)
{
    clear_lazy(v, l, r);

    if (int_r < l or int_l > r) return 0;
    if (int_l <= l and r <= int_r) return tree[v].maxv;

    int mid = (l + r) >> 1;
    return max(query(v << 1 | 0, l, mid + 0), query(v << 1 | 1, mid + 1, r));
}

pair<int, int> find_range(int y)
{
    int l, r, mini = MAXH, maxi = -1;

    l = 0; r = cmpry.size() - 1;
    while (l <= r)
    {
        int mid = (l + r) / 2;
        if (cmpry[mid] < y) l = mid + 1;
        else
        {
            mini = mid;
            r = mid - 1;
        }
    }

    l = 0; r = cmpry.size() - 1;
    while (l <= r)
    {
        int mid = (l + r) / 2;
        if (cmpry[mid] > y + h) r = mid - 1;
        else
        {
            maxi = mid;
            l = mid + 1;
        }
    }

    /*cout << "for " << y << ' ' << y + h << " found " << mini << ' ' << maxi << endl;
    if (mini != MAXH) cout << cmpry[mini] << ' '; else cout << "- ";
    if (maxi != -1) cout << cmpry[maxi] << ' '; else cout << "- ";
    cout << endl;*/

    return make_pair(mini, maxi);
}

void Solve()
{
    int ans = 0;
    int add = 0, rem = 0;

    int Xmax = p[1].fi;
    while (true)
    {
        if (p[rem + 1].fi < Xmax - w)
        {
            rem++;
            delta = -1;
            auto rng = find_range(p[rem].se);
            upd_l = rng.fi;
            upd_r = rng.se;
            update();
            continue;
        }

        if (add + 1 > n or p[add + 1].fi != Xmax)
        {
            int_l = 0;
            int_r = cmpry.size() - 1;
            ans = max(query(), ans);

            if (add + 1 > n) break;
            Xmax = p[add + 1].fi; // mark the next point for adding
            continue;
        }

        if (p[add + 1].fi == Xmax)
        {
            add++;
            delta = +1;
            auto rng = find_range(p[add].se);
            upd_l = rng.fi;
            upd_r = rng.se;
            update();
            continue;
        }
    }

    cout << ans << endl;
}

int main()
{
    Init();
    Solve();
    return 0;
}
