#include <bits/stdc++.h>

using namespace std;
 
using ll = long long;
using ld = long double;
using db = double; 
using str = string; 

using pi = pair<int, int>;
using pl = pair<ll, ll>;
using pd = pair<double, double>;

using vpi = vector <pi>;
using vpl = vector <pl>;

#define f first
#define s second
#define mp(x, y) make_pair(x, y)

#define sz(X) x.size()
#define pb(x) push_back(x)
#define ins(x) insert(x)

const int MOD = 1e9+7;
const int mxN = 2e6+5;
const ll INF = 1e18; 
const ld PI = acos((ld)-1);

mt19937 rnd(1236133);
 
struct point
{
	int x, y;

	point(int _x, int _y)
	{
		x = _x; y = _y;
	}

	bool operator<(point other) const
	{
		return x < other.x || (x == other.x && y < other.y);
	}
};

struct ots
{
	int x, y1, y2, ind, type;

	ots(int _x, int _y1, int _y2, int _ind, int _type)
	{
		x = _x; y1 = _y1; y2 = _y2; ind = _ind; type = _type;
	}
	bool operator<(ots other) const
	{
		return x < other.x || (x == other.x && type > other.type);
	}
};

int n, w, h;
vector <point> v;
vector <ots> o_v;

struct treap
{
	int key, priority;
	int cnt;
	treap *left, *right;
	treap(int _key)
	{
		key = _key;
		priority = rnd();
		cnt = 1;
		left = right = nullptr;
	}

	void recalc()
	{
		cnt = 1;
		if(left != nullptr)
		{
			cnt += left->cnt;
		}
		if(right != nullptr)
		{
			cnt += right->cnt;
		}
	}
};

treap* merge(treap*sm, treap*bg)
{
	if(sm == nullptr)
	{
		return bg;
	}
	if(bg == nullptr)
	{
		return sm;
	}
	if(sm->priority > bg->priority)
	{
		sm->right = merge(sm->right, bg);
		sm->recalc();
		return sm;
	}
	else
	{
		bg->left = merge(sm, bg->left);
		bg->recalc();
		return bg;
	}
}

pair<treap*, treap*> split(treap* t, int key)
{
	if(t == nullptr)
	{
		return mp(nullptr, nullptr);
	}
	if(t->key < key)
	{
		auto splitResults = split(t->right, key);
		t->right = splitResults.first;
		t->recalc();
		return mp(t, splitResults.second);
	}
	else
	{
		auto splitResults = split(t->left, key);
		t->left = splitResults.second;
		t->recalc();
		return mp(splitResults.first, t);
	}
}

treap* root = nullptr;

void add(int key)
{
	if(root == nullptr)
	{
		root = new treap(key);
		return;
	}
	treap* te = new treap(key);
	auto splitResults = split(root, key);
	splitResults.s = merge(te, splitResults.s);
	root = merge(splitResults.f, splitResults.s);
}

int query(int l, int r)
{
	int cnt = 0;
	auto splitResults = split(root, l);
	auto splitResults2 = split(splitResults.s, r + 1);
	if(splitResults2.f != nullptr)
	{
		cnt = splitResults2.f->cnt;
	}
	root = merge(splitResults.f, merge(splitResults2.f, splitResults2.s));

	//cout << cnt << "\n";
	return cnt;
}

int br[mxN];

int solve()
{
	sort(o_v.begin(), o_v.end());
	
	int ans = 0;
	for(auto x : o_v)
	{
		//cout << x.x << " " << x.y1 << " " << x.y2 << " " << x.ind << " " << x.type << "\n";
		/*if(x.type != 0)
		{
			cout << "~" << x.x << " " << x.y1 << " " << x.y2 << " " << query(x.y1, x.y2) << "\n";
		}*/
		if(x.type == 0)
		{
			add(x.y1);
		}
		else if(x.type == 1)
		{
			br[x.ind] -= query(x.y1, x.y2);
		}
		else
		{
			br[x.ind] += query(x.y1, x.y2);
			ans = max(ans, br[x.ind]);
		}
	}
	//cout << query(1, 5) << "\n";
	return ans;
}

int chck(int x, int y, int l, int r, int u, int d)
{
	if(x >= l && x <= r && y >= d && y <= u) return 1;
	return 0;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> w >> h;

	int x, y;
	for(int i = 0; i < n; i++)
	{
		cin >> x >> y;
		v.pb(point(x, y));
		o_v.pb(ots(x, y, y, 0, 0));
	}

	int br = 0;
	//int anse = 0;
	sort(v.begin(), v.end());
	for(int i = 0; i < n; i++)
	{
		int l = i, r = n - 1;
		int z = i;
		while(l <= r)
		{
			int middle = (l + r) >> 1;
			if(abs(v[middle].x - v[i].x) <= w)
			{
				z = middle;
				l = middle + 1;
			}
			else
			{
				r = middle - 1;
			}
		}
		for(int j = z - 5; j <= z; j++)
		{
			int ri = max(v[i].x, v[j].x);
			int up = max(v[i].y, v[j].y);
			int dwn = up - h;
			int le = ri - w;

			//if(abs(v[i].x - v[j].x) > w || abs(v[i].y - v[j].y) > h) continue;
			//int yee = 0;
			/*for(int z = 0; z < n; z++)
			{
				if(chck(v[z].x, v[z].y, le, ri, up, dwn)) yee++;
			}
			anse = max(anse, yee);*/

			//cout << le << " " << ri << " " << up << " " << dwn << "\n";

			o_v.pb(ots(le, dwn, up, br, 1));
			o_v.pb(ots(ri, dwn, up, br++, -1));
			/*if(n > 1000)
			{
				break;
			}*/
		}
	} 
	cout << solve() << "\n";

	return 0;
}
 
 /* stuff you should look for
	* int overflow, array bounds
	* special cases (n=1?)
	* do smth instead of nothing and stay organized
	* WRITE STUFF DOWN
	* DON'T GET STUCK ON ONE APPROACH
*/

