#include <iostream>
#include <vector>
#include <functional>

#define ENDL '\n'

namespace {
template <class T>
using vec = std::vector<T>;

auto solve(vec<int>& crabs, int k) {
    auto n = static_cast<int>(crabs.size());

    vec<vec<int>> aquariums;
    aquariums.resize(k);

    std::function<int(int, int)> recurse;
    recurse = [&](int aq_idx, int crab_idx) {
        auto res = std::numeric_limits<int>::max();

        if (crab_idx >= n) {
            res = 0;

            for (auto& aquarium : aquariums) {
                for (auto& crab_i : aquarium) {
                    for (auto& crab_j : aquarium) {
                        if (crab_i == crab_j) {
                            continue;
                        }

                        res += crabs[crab_j];
                    }
                }
            }

            return res;
        }

        if (aq_idx < k) {
            aquariums[aq_idx].emplace_back(crab_idx);

            auto res_put = recurse(aq_idx, crab_idx + 1);
            res = std::min(res, res_put);

            aquariums[aq_idx].pop_back();

            auto res_skip = recurse(aq_idx + 1, crab_idx);
            res = std::min(res, res_skip);
        }

        return res;
    };

    return recurse(0, 0);
}
} // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, k;
    std::cin >> n >> k;

    vec<int> aggressiveness;
    aggressiveness.reserve(n);

    int foo;
    while (n--) {
        std::cin >> foo;
        aggressiveness.emplace_back(foo);
    }

    std::cout << solve(aggressiveness, k) << ENDL;

    return 0;
}

