#include <iostream>
#include <map>

#define ENDL '\n'

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, w, h;
    std::cin >> n >> w >> h;

    std::multimap<int, int> points;

    int x, y;
    auto max_x = 0, max_y = 0;

    while (n--) {
        std::cin >> x >> y;
        points.emplace(x, y);

        max_x = std::max(max_x, x);
        max_y = std::max(max_y, y);
    }

    auto res = 0;

    for (auto i = w; i <= max_x; ++i) {
        for (auto j = h; j <= max_y; ++j) {
            auto li = i - w;
            auto lj = j - h;

            // std::cout << i << ", " << j << " - " << li << ", " << lj << ENDL;

            auto lo = points.lower_bound(li);
            auto hi = points.upper_bound(i);

            auto curr_res = 0;

            for (auto it = lo; it != hi; ++it) {
                auto cj = it->second;

                if (cj < lj || cj > j) {
                    continue;
                }

                // std::cout << it->first << ", " << cj << ENDL;

                ++curr_res;
            }

            // std::cout << ENDL;

            res = std::max(res, curr_res);
        }
    }

    std::cout << res << ENDL;

    return 0;
}
