#include <iostream>
#include <map>
#include <functional>

#define ENDL '\n'

namespace {
auto solve(std::multimap<int, int>& points, int w, int h) {
    auto count_rect = [&](int li, int lj, int hi, int hj) {
        auto res = 0;

        if (li < 0 || lj < 0 || hi < 0 || hj < 0) {
            return res;
        }

        // std::cout << li << ", " << lj << " - " << hi << ", " << hj << " = ";

        auto low = points.lower_bound(li);
        auto high = points.upper_bound(hi);

        for (auto it = low; it != high; ++it) {
            if (it->second < lj || it->second > hj) {
                continue;
            }

            ++res;
        }

        // std::cout << res << ENDL;

        return res;
    };

    auto max_x = 0, max_y = 0;
    for (auto& [curr_x, curr_y] : points) {
        max_x = std::max(max_x, curr_x);
        max_y = std::max(max_y, curr_y);
    }

    auto res = 0;

    for (auto i = 0; i <= max_x; ++i) {
        for (auto j = 0; j <= max_y; ++j) {
            res = std::max(res, count_rect(i, j, i + w, j + h));
            res = std::max(res, count_rect(i - w, j - h, i, j));
        }
    }

    return res;
}
} // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, w, h;
    std::cin >> n >> w >> h;

    std::multimap<int, int> points;

    int x, y;
    while (n--) {
        std::cin >> x >> y;
        points.emplace(x, y);
    }

    std::cout << solve(points, w, h) << ENDL;

    return 0;
}
