#include <iostream>
#include <map>
#include <functional>

#define ENDL '\n'

namespace {
auto solve(std::vector<std::pair<int, int>>& points, int w, int h) {
    std::sort(points.begin(), points.end());

    auto count_rect = [&](int li, int lj, int hi, int hj) {
        auto res = 0LL;

        if (li < 0 || lj < 0 || hi < 0 || hj < 0) {
            return res;
        }

        auto low = std::lower_bound(points.begin(), points.end(), std::make_pair(li, lj));
        auto high = std::upper_bound(points.begin(), points.end(), std::make_pair(hi, hj));

        for (auto it = low; it != high; ++it) {
            if (it->second < lj || it->second > hj) {
                continue;
            }

            ++res;
        }

        return res;
    };

    auto max_x = 0, max_y = 0;
    for (auto& [curr_x, curr_y] : points) {
        max_x = std::max(max_x, curr_x);
        max_y = std::max(max_y, curr_y);
    }

    auto res = 0LL;

    for (auto i = 0; i <= max_x; ++i) {
        for (auto j = 0; j <= max_y; ++j) {
            res = std::max(res, count_rect(i, j, i + w, j + h));
            res = std::max(res, count_rect(i - w, j - h, i, j));
        }
    }

    return res;
}
} // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, w, h;
    std::cin >> n >> w >> h;

    std::vector<std::pair<int, int>> points;
    points.reserve(n);

    int x, y;
    while (n--) {
        std::cin >> x >> y;
        points.emplace_back(x, y);
    }

    std::cout << solve(points, w, h) << ENDL;

    return 0;
}
