#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl "\n";
#define out(x) << "{" << (#x) << ": " << x << "} "
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) {out << x.first << " " << x.second; return out;}
template<class T, class T2> inline istream &operator >>(istream &in, pair<T, T2> &x) {in >> x.first >> x.second; return in;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 2e5 + 10;
pair<int, int> arr[MAX_N];
int n, w, h;

map<int, int> cord;

void compress() {
    vector<int> c;
    for(int i = 0; i < n; i ++) {
        c.push_back(arr[i].second);
        c.push_back(arr[i].second - h);
    }
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    for(int i = 0; i < c.size(); i ++) {
        cord[c[i]] = i;
    }
}

struct SegTree {
    int tree[4 * MAX_N], lazy[4 * MAX_N];
    void push(int curr, int l, int r) {
        tree[curr] += lazy[curr];
        if(l != r) {
            lazy[curr * 2] += lazy[curr];
            lazy[curr * 2 + 1] += lazy[curr];
        }
        lazy[curr] = 0;
    }
    void upd(int curr, int l, int r, int ql, int qr, int val) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            lazy[curr] += val;
            push(curr, l, r);
            return;
        } else if(l > qr || r < ql) {return;}
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ql, qr, val);
        upd(curr * 2 + 1, m + 1, r, ql, qr, val);
        tree[curr] = max(tree[curr * 2], tree[curr * 2 + 1]);
    }
    int query(int curr, int l, int r, int ql, int qr) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) {return 0;}
        int m = (l + r) / 2ll;
        return max(query(curr * 2, l, m, ql, qr), query(curr * 2 + 1, m + 1, r, ql, qr));
    }
    int ans() {
        push(1, 0, MAX_N - 1);
        return tree[1];
    }
};

SegTree best;

void add(int y, int val) {
    int l = cord[y - h], r = cord[y];
    best.upd(1, 0, MAX_N - 1, l, r, val);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> w >> h;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    sort(arr, arr + n);
    compress();
    int ret = 0;
    for(int l = 0, r = 0; l < n; l ++) {
        while(r < n && arr[l].first + w >= arr[r].first) {
            add(arr[r].second, 1);
            r ++;
        }
        chkmax(ret, best.ans());
        add(arr[r].second, -1);
    }
    cout << ret << endl;
}

