#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 1e5 + 3;
const ll INF = 2e18;
const ll MAX = 1e13;

int n, k;
ll a[N], prefix[N];
ll dp[N], cnt[N], dp2[4][N];

void divide_and_conquer(int l, int r, int sl, int sr, int idx){
    if(l > r) return;

    int mid = (l + r) >> 1;
    pair<ll, int> ans{INF, -1};
    for(int i = max(mid, sl); i <= sr; ++i)
        ans = min(ans, {dp2[idx + 1][i + 1] + (prefix[i] - prefix[mid - 1]) * (i - mid), i});
    dp2[idx][mid] = ans.first;

    divide_and_conquer(l, mid - 1, sl, ans.second, idx);
    divide_and_conquer(mid + 1, r, ans.second, sr, idx);
}

ll solve2(){
    for(int i = 1; i <= n; ++i)
        dp2[k][i] = INF;
    dp2[k][n + 1] = 0;

    for(int j = k - 1; j >= 0; --j){
        divide_and_conquer(1, n, 1, n, j);
        dp2[j][n + 1] = 0;
    }

    return dp2[0][1];
}

void solve(ll cost){
    dp[n + 1] = 0;
    cnt[n + 1] = 0;

    for(int i = n; i >= 1; --i){
        dp[i] = INF;
        for(int j = i; j <= n; ++j){
            ll curr = (prefix[j] - prefix[i - 1]) * (ll)(j - i) + dp[j + 1] + cost;
            if(curr < dp[i]){
                dp[i] = curr;
                cnt[i] = cnt[j + 1] + 1;
            }
            else if(curr == dp[i]){
                if(cnt[j + 1] + 1 < cnt[i]){
                    cnt[i] = cnt[j + 1] + 1;
                }
            }
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 1; i <= n; ++i)
        cin >> a[i];

    for(int i = 1; i <= n; ++i)
        prefix[i] = prefix[i - 1] + a[i];

    if(k <= 3){
        cout << solve2() << "\n";
        return 0;
    }

    ll l = -MAX, r = MAX;
    while(l != r){
        ll mid = (l + r) >> 1;
        solve(mid);

        if(cnt[1] <= k)
            r = mid;
        else
            l = mid + 1;
    }

    solve(l);
    cout << dp[1] - k * l << "\n";
}
/*
5 3
25 93 21 13 42
*/
