#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 3;

struct Segment_Tree{
    int mx[4 * N], lp[4 * N];

    Segment_Tree(){}

    void push_lazy(int i, int l, int r){
        mx[i] += lp[i];
        if(l != r){
            lp[2 * i + 1] += lp[i];
            lp[2 * i + 2] += lp[i];
        }
        lp[i] = 0;
    }

    void update(int i, int l, int r, int sl, int sr, int add){
        push_lazy(i, l, r);
        if(sl > r || sr < l) return;
        if(sl <= l && r <= sr){
            lp[i] += add;
            push_lazy(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;
        update(2 * i + 1, l, mid, sl, sr, add);
        update(2 * i + 2, mid + 1, r, sl, sr, add);

        mx[i] = max(mx[2 * i + 1], mx[2 * i + 2]);
    }

    int query(int i, int l, int r, int sl, int sr){
        push_lazy(i, l, r);
        if(sl <= l && r <= sr)
            return mx[i];
    }
};

int n, w, h;
vector<int> v[N];
Segment_Tree st;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> w >> h;
    for(int i = 0; i < n; ++i){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
    }

    int ans = 0;
    for(int x = 1; x < N; ++x){
        for(int y: v[x])
            st.update(0, 0, N - 1, max(y - w, 0), y, 1);
        if(x - h - 1 >= 1){
            for(int y: v[x - h - 1])
                st.update(0, 0, N - 1, max(y - w, 0), y, -1);
        }
        ans = max(ans, st.query(0, 0, N - 1, 0, N - 1));
    }

    cout << ans << "\n";
}
/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/
