#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 3;

struct Segment_Tree{
    int mx[4 * N], lp[4 * N];

    Segment_Tree(){}

    void push_lazy(int i, int l, int r){
        mx[i] += lp[i];
        if(l != r){
            lp[2 * i + 1] += lp[i];
            lp[2 * i + 2] += lp[i];
        }
        lp[i] = 0;
    }

    void update(int i, int l, int r, int sl, int sr, int add){
        push_lazy(i, l, r);
        if(sl > r || sr < l) return;
        if(sl <= l && r <= sr){
            lp[i] += add;
            push_lazy(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;
        update(2 * i + 1, l, mid, sl, sr, add);
        update(2 * i + 2, mid + 1, r, sl, sr, add);

        mx[i] = max(mx[2 * i + 1], mx[2 * i + 2]);
    }

    int query(int i, int l, int r, int sl, int sr){
        push_lazy(i, l, r);
        if(sl <= l && r <= sr)
            return mx[i];
    }
};

int n, w, h;
vector<int> v[N], vx, vy;
Segment_Tree st;
pair<int, int> p[N];
set<int> sx, sy;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> w >> h;
    for(int i = 0; i < n; ++i){
        cin >> p[i].first >> p[i].second;
        sx.insert(p[i].first);
        sy.insert(p[i].second);
    }

    for(int x: sx)
        vx.push_back(x);
    for(int y: sy)
        vy.push_back(y);

    for(int i = 0; i < n; ++i){
        p[i].first = lower_bound(vx.begin(), vx.end(), p[i].first) - vx.begin();
        p[i].second = lower_bound(vy.begin(), vy.end(), p[i].second) - vy.begin();
        v[p[i].first].push_back(p[i].second);
    }

    int ans = 0, ptr = 0;
    for(int x = 0; x < vx.size(); ++x){
        for(int y: v[x]){
            int idx_y = lower_bound(vy.begin(), vy.end(), vy[y] - h) - vy.begin();
            st.update(0, 0, N - 1, idx_y, y, 1);
        }
        while(vx[ptr] < vx[x] - w){
            for(int y: v[ptr]){
                int idx_y = lower_bound(vy.begin(), vy.end(), vy[y] - h) - vy.begin();
                st.update(0, 0, N - 1, idx_y, y, -1);
            }
            ptr++;
        }
        //cout << vx[x] << " - " << vx[ptr] << endl;
        ans = max(ans, st.query(0, 0, N - 1, 0, N - 1));
    }

    cout << ans << "\n";
}
/*
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
*/
