#include <iostream>

using namespace std;

const int MAXN = 1005;
const long long inf = 1e17 + 5;

int n, k;
int a[MAXN];

long long pref[MAXN];
long long dp[MAXN][MAXN];

long long getSum(int l, int r)
{
    if(l==0) return pref[r];
    return pref[r] - pref[l-1];
}

void init()
{
    pref[0] = a[0];
    for(int i = 0;i<n;i++) pref[i] = pref[i-1] + a[i];

    for(int i = 0;i<n;i++) dp[i][0] = pref[i]*i;
}

int getFear(int l, int r)
{
    return getSum(l, r)*(r-l);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> a[i];
    init();

    for(int groupCnt = 1;groupCnt<k;groupCnt++)
    {
        for(int i = groupCnt;i<n;i++)
        {
            dp[i][groupCnt] = inf;
            for(int p = groupCnt;p<=i;p++)
                dp[i][groupCnt] = min(dp[i][groupCnt], dp[p-1][groupCnt-1]+getFear(p, i));
        }
    }

    cout << dp[n-1][k-1] << '\n';
}
