#include <iostream>

using namespace std;

const int MAXN = 6005;
const long long inf = 1e17 + 5;

int n, k;
int a[MAXN];

long long pref[MAXN];
long long dp[MAXN][2];

long long getSum(int l, int r)
{
    if(l==0) return pref[r];
    return pref[r] - pref[l-1];
}

void init()
{
    pref[0] = a[0];
    for(int i = 0;i<n;i++) pref[i] = pref[i-1] + a[i];

    for(int i = 0;i<n;i++) dp[i][0] = pref[i]*i;
}

long long getFear(int l, int r)
{
    return getSum(l, r)*(r-l);
}

long long findBest(int i, int groupCnt, int lOpt, int rOpt, int &opt)
{
    long long ans = inf;
    for(int p = max(groupCnt, lOpt-1);p<=min(i, rOpt+1);p++)
    {
        long long val = dp[p-1][(groupCnt-1)&1] + getFear(p, i);
        if(val<ans)
        {
            ans = val;
            opt = p;
        }
    }

    return ans;
}

void solve(int groupCnt, int l, int r, int lOpt, int rOpt)
{
    if(l>r) return;

    int opt;
    int mid = (l+r)/2;
    dp[mid][groupCnt&1] = findBest(mid, groupCnt, lOpt, rOpt, opt);

    solve(groupCnt, l, mid-1, lOpt, opt);
    solve(groupCnt, mid+1, r, opt, rOpt);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> a[i];
    init();

    for(int groupCnt = 1;groupCnt<k;groupCnt++)
    {
        solve(groupCnt, 0, n-1, 0, n-1);
    }

    cout << dp[n-1][(k-1)&1] << '\n';
}
