#include <iostream>

using namespace std;

const int MAXN = 6005;
const long long inf = 1e17 + 5;

int n, k;
int a[MAXN];

long long pref[MAXN];
long long dp[MAXN][2];

long long getSum(int l, int r)
{
    if(l==0) return pref[r];
    return pref[r] - pref[l-1];
}

void init()
{
    pref[0] = a[0];
    for(int i = 0;i<n;i++) pref[i] = pref[i-1] + a[i];

    for(int i = 0;i<n;i++) dp[i][0] = pref[i]*i;
}

long long getFear(int l, int r)
{
    return getSum(l, r)*(r-l);
}

long long findBest(int i, int groupCnt, int lOpt, int rOpt, int &opt)
{
    long long ans = inf;
    for(int p = max(groupCnt, lOpt);p<=min(i, rOpt);p++)
    {
        long long val = dp[p-1][(groupCnt-1)&1] + getFear(p, i);
        if(val<ans)
        {
            ans = val;
            opt = p;
        }
    }

    return ans;
}

void solve(int groupCnt, int l, int r, int lOpt, int rOpt)
{
    if(l>r) return;

    int opt;
    int mid = (l+r)/2;
    dp[mid][groupCnt&1] = findBest(mid, groupCnt, lOpt, rOpt, opt);

    solve(groupCnt, l, mid-1, lOpt, opt);
    solve(groupCnt, mid+1, r, opt, rOpt);
}

pair <long long, int> dp1[MAXN];
void alliens(long long c)
{
    for(int i = 0;i<n;i++)
    {
        dp1[i] = {getFear(0, i)+c, 1};
        for(int j = 1;j<=i;j++)
        {
            long long val = dp1[j-1].first + getFear(j, i) + c;
            if(val<=dp1[i].first)
            {
                dp1[i].first = val;
                dp1[i].second = dp1[j-1].second + 1;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;
    for(int i = 0;i<n;i++) cin >> a[i];
    init();

    /*
    for(int groupCnt = 1;groupCnt<k;groupCnt++)
    {
        solve(groupCnt, 0, n-1, 0, n-1);
    }
    */

    long long l = 0, r = 1e13 + 22, mid;
    while(l<r)
    {
        mid = (l+r)/2;

        alliens(mid);
        if(dp1[n-1].second==k)
        {
            cout << dp1[n-1].first - k*mid << '\n';
            return 0;
        }

        if(dp1[n-1].second<k) r = mid - 1;
        else l = mid + 1;
    }

    alliens(l);
    long long val1 = dp1[n-1].first - k*l + inf;

    alliens(r);
    long long val2 = dp1[n-1].first - k*r;

    cout << min(val1, val2) << '\n';
    //cout << dp[n-1][(k-1)&1] << '\n';
}
