#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <list>
#include <set>

using namespace std;

struct Point
{
    int x, y;

    Point(){}
    Point(int x, int y)
    {
        this->x = x;
        this->y = y;
    }
};

struct PointsKeeper
{
    int w, h;
    list <Point> active;
    multiset <pair <int, int>> activeSet;//{x, y}

    PointsKeeper(){}
    PointsKeeper(int w, int h)
    {
        this->w = w;
        this->h = h;
    }

    void addPoint(Point P)
    {
        active.push_back(P);
        activeSet.insert({P.x, P.y});

        while((*active.begin()).y<P.y-h) removePoint();
    }

    void removePoint()
    {
        Point P = *active.begin();

        activeSet.erase({P.x, P.y});
        active.erase(active.begin());
    }

    int evalBest()
    {
        int ans = 0;
        for(auto it = activeSet.begin();it!=activeSet.end();it++)
        {
            int cnt = 0;
            for(auto it1 = it;it1!=activeSet.end();it1++)
            {
                if(it1->first>it->first+w) break;
                cnt++;
            }

            ans = max(ans, cnt);
        }

        return ans;
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    int w, h;
    vector <Point> points;

    cin >> n;
    cin >> w >> h;
    for(int i = 0;i<n;i++)
    {
        int x, y;
        cin >> x >> y;

        points.push_back(Point(x, y));
    }

    sort(points.begin(), points.end(),
    [](Point A, Point  B)
    {
        if(A.y!=B.y) return A.y<B.y;
        return A.x<B.x;
    });

    int ans = 0;
    PointsKeeper yoanko(w, h);

    for(Point p: points)
    {
        yoanko.addPoint(p);
        ans = max(ans, yoanko.evalBest());
    }

    cout << ans << '\n';
}
