#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

void solve() {
    vector<vector<long long>> cost(n, vector<long long>(n));
    for (int i = 0; i < n; i++) {
        long long sum = 0;

        for (int j = i; j < n; j++) {
            sum += a[j];

            cost[i][j] = sum * (j - i);
        }
    }

    vector<pair<int, int>> intervals(n);

    for (int i = 0; i < n; i++) {
        intervals[i] = {i, i};
    }

    while ((int)intervals.size() > k) {
        int pos = -1;
        long long minCost = 1e18, minLength = 0;

        for (int i = 0; i < (int)intervals.size() - 1; i++) {
            int l = intervals[i].first;
            int r = intervals[i + 1].second;

            if (cost[l][r] < minCost) {
                minCost = cost[l][r];
                minLength = r - l + 1;
                pos = i;
            } else if (cost[l][r] == minCost && r - l + 1 < minLength) {
                minLength = r - l + 1;
            }
        }

        intervals[pos].second = intervals[pos + 1].second;
        intervals.erase(intervals.begin() + (pos + 1));
    }

    long long answer = 0;

    for (int i = 0; i < k; i++) {
        answer += cost[intervals[i].first][intervals[i].second];
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
