#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, w, h;
vector<pair<int, int>> points;
int maxX = 0, maxY = 0;

void read() {
    cin >> n >> w >> h;

    points.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;

        maxX = max(maxX, points[i].first);
        maxY = max(maxY, points[i].second);
    }
}

vector<vector<int>> numPoints;

int query(int x1, int y1, int x2, int y2) {
    int answer = numPoints[x2][y2];

    if (y1 > 0) {
        answer -= numPoints[x2][y1 - 1];
    }

    if (x1 > 0) {
        answer -= numPoints[x1 - 1][y2];
    }

    if (x1 > 0 && y1 > 0) {
        answer += numPoints[x1 - 1][y1 - 1];
    }

    return answer;
}

void solve() {
    numPoints.resize(maxX + 1, vector<int>(maxY + 1, 0));
    for (int i = 0; i < n; i++) {
        numPoints[points[i].first][points[i].second]++;
    }

    for (int i = 0; i <= maxX; i++) {
        int rowSum = 0;

        for (int j = 0; j <= maxY; j++) {
            rowSum += numPoints[i][j];

            numPoints[i][j] = rowSum;
            if (i > 0) {
                numPoints[i][j] += numPoints[i - 1][j];
            }
        }
    }

    int maxPoints = 0;

    for (int i = 0; i <= maxX - w; i++) {
        for (int j = 0; j <= maxY - h; j++) {
            maxPoints = max(maxPoints, query(i, j, i + w, j + h));
        }
    }

    cout << maxPoints << endl;
}

int main() {
    setIO();

    read();

    solve();
}
