#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, w, h;
vector<pair<int, int>> points;
int maxX = 0, maxY = 0;

void read() {
    cin >> n >> w >> h;

    points.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
        points[i].first++;
        points[i].second++;

        maxX = max(maxX, points[i].first);
        maxY = max(maxY, points[i].second);
    }
}

map<int, map<int, int>> tree;

void update(int x, int y, int delta) {
    for (int i = x; i <= maxX; i += i & -i) {
        for (int j = y; j <= maxY; j += j & -j) {
            tree[i][j] += delta;
        }
    }
}

int query(int x, int y) {
    int answer = 0;

    for (int i = x; i > 0; i -= i & -i) {
        for (int j = y; j > 0; j -= j & -j) {
            answer += tree[i][j];
        }
    }

    return answer;
}

int query(int x1, int y1, int x2, int y2) {
    int answer = query(x2, y2);

    if (y1 > 1) {
        answer -= query(x2, y1 - 1);
    }

    if (x1 > 1) {
        answer -= query(x1 - 1, y2);
    }

    if (x1 > 1 && y1 > 1) {
        answer += query(x1 - 1, y1 - 1);
    }

    return answer;
}

void solve() {
    for (int i = 0; i < n; i++) {
        update(points[i].first, points[i].second, 1);
    }

    int maxPoints = 0;

    for (int i = 0; i < n; i++) {
        maxPoints = max(maxPoints, query(points[i].first - w, points[i].second - h, points[i].first, points[i].second));
    }

    cout << maxPoints << endl;
}

int main() {
    setIO();

    read();

    solve();
}
