#include <iostream>
#include <queue>

using namespace std;

const int maxn = 100000;
int aggress [maxn];
long long sumAgressUpTo[maxn];

struct info{
    long long len;
    int vert;
    int aquLeft;
    long long totalAgressUpToHere;
};

bool operator< (info a, info b){
    return a.len < b.len;
}

bool operator<= (info a, info b){
    return a.len <= b.len;
}

bool operator> (info a, info b){
    return a.len > b.len;
}

bool operator>= (info a, info b){
    return a.len >= b.len;
}

bool operator== (info a, info b){
    return a.len == b.len;
}

priority_queue<info> frontier;

long long length(info first, info second){
    return (second.vert - first.vert - 1)*(sumAgressUpTo[second.vert-1] - sumAgressUpTo[first.vert-1]);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int N, K;
    cin >> N >> K;

    for(int i=0; i<N; i++){
        cin >> aggress[i];
        sumAgressUpTo[i] = sumAgressUpTo[i-1] + aggress[i];
    }

    info start;
    start.len = 0;
    start.vert = 0;
    start.aquLeft = K;
    start.totalAgressUpToHere = 0;

    frontier.push(start);

    while(true){

        info curr = frontier.top();
        curr.len *= -1;
        frontier.pop();

        cout << "frontier pops: " << curr.vert << endl;

        if(curr.vert == -1){  /// i.e. END
            cout << curr.totalAgressUpToHere << endl;
            break;
        }

        if(curr.aquLeft == 1){
            info trueEnd;
            trueEnd.vert = N;

            info endd;
            endd.vert = -1;
            endd.len = length(curr, trueEnd); /// double check?
            endd.totalAgressUpToHere = curr.totalAgressUpToHere + endd.len;

            endd.len *= -1;
            frontier.push(endd);
            cout << "frontier pushes: " << endd.vert << " with len: " << endd.len << endl;
            continue;
        }

        for(int i=curr.vert+1; i<N; i++){
            info neigh; /// neighbour
            neigh.vert = i;
            neigh.len = length(curr, neigh); ///i.e. total sum of agg of prev aqu
            neigh.aquLeft = curr.aquLeft - 1;
            neigh.totalAgressUpToHere = curr.totalAgressUpToHere + neigh.len;

            neigh.len *= -1;
            frontier.push(neigh);
            cout << "frontier pushes: " << neigh.vert << " with len: " << neigh.len << endl;
        }
    }

    return 0;
}
